/* worm.c generated by valac 0.56.17, the Vala compiler
 * generated from worm.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 * Copyright (C) 2022-24 Ben Corby <bcorby@new-ms.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Coding style.
 *
 * To help you comply with the coding style in this project use the
 * following greps. Any lines returned should be adjusted so they
 * don't match. The convoluted regular expressions are so they don't
 * match them self.
 *
 * grep -ne '[^][)(_!$ "](' *.vala
 * grep -ne '[(] ' *.vala
 * grep -ne '[ ])' *.vala
 * grep -ne ' $' *.vala
 *
 */

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>
#include <gdk/gdk.h>

#define WORM_MAP_bits ((guint8) (sizeof (guint64) * 8))
#define ANGLE_step_multiplier_2n 38
#define ANGLE_step_multiplier 274877906944LL
#define NIBBLES_GAME_EMPTYCHAR 'a'
#define WORM_STARTING_LIVES ((guint8) 6)
#define WORM_STARTING_LENGTH 5
#define WORM_MAX_LIVES ((guint8) 12)
#define WORM_GROW_FACTOR 4
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	WORM_DIRECTION_NONE,
	WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_EAST = WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_DOWN,
	WORM_DIRECTION_SOUTH = WORM_DIRECTION_DOWN,
	WORM_DIRECTION_LEFT,
	WORM_DIRECTION_WEST = WORM_DIRECTION_LEFT,
	WORM_DIRECTION_UP,
	WORM_DIRECTION_NORTH = WORM_DIRECTION_UP
} WormDirection;

#define TYPE_WORM_DIRECTION (worm_direction_get_type ())

#define TYPE_POSITION (position_get_type ())
typedef struct _Position Position;

#define TYPE_SIGNED_POSITION (signed_position_get_type ())
typedef struct _SignedPosition SignedPosition;

#define TYPE_WORM_MAP (worm_map_get_type ())
#define WORM_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_MAP, WormMap))
#define WORM_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_MAP, WormMapClass))
#define IS_WORM_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_MAP))
#define IS_WORM_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_MAP))
#define WORM_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_MAP, WormMapClass))

typedef struct _WormMap WormMap;
typedef struct _WormMapClass WormMapClass;
typedef struct _WormMapPrivate WormMapPrivate;
enum  {
	WORM_MAP_0_PROPERTY,
	WORM_MAP_NUM_PROPERTIES
};
static GParamSpec* worm_map_properties[WORM_MAP_NUM_PROPERTIES];

#define TYPE_WORM (worm_get_type ())
#define WORM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM, Worm))
#define WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM, WormClass))
#define IS_WORM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM))
#define IS_WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM))
#define WORM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM, WormClass))

typedef struct _Worm Worm;
typedef struct _WormClass WormClass;

#define TYPE_WORM_POSITIONS (worm_positions_get_type ())
#define WORM_POSITIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_POSITIONS, WormPositions))
#define WORM_POSITIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_POSITIONS, WormPositionsClass))
#define IS_WORM_POSITIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_POSITIONS))
#define IS_WORM_POSITIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_POSITIONS))
#define WORM_POSITIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_POSITIONS, WormPositionsClass))

typedef struct _WormPositions WormPositions;
typedef struct _WormPositionsClass WormPositionsClass;
typedef struct _WormPrivate WormPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_INT128 (int128_get_type ())
typedef struct _int128 int128;

#define TYPE_ANGLE_ITERATOR (angle_iterator_get_type ())
#define ANGLE_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ANGLE_ITERATOR, AngleIterator))
#define ANGLE_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ANGLE_ITERATOR, AngleIteratorClass))
#define IS_ANGLE_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ANGLE_ITERATOR))
#define IS_ANGLE_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ANGLE_ITERATOR))
#define ANGLE_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ANGLE_ITERATOR, AngleIteratorClass))

typedef struct _AngleIterator AngleIterator;
typedef struct _AngleIteratorClass AngleIteratorClass;
typedef struct _AngleIteratorPrivate AngleIteratorPrivate;

#define TYPE_ANGLE (angle_get_type ())
typedef struct _Angle Angle;
typedef struct _ParamSpecAngleIterator ParamSpecAngleIterator;
typedef enum  {
	QUARTER_Q0,
	QUARTER_Q1,
	QUARTER_Q2,
	QUARTER_Q3
} Quarter;

#define TYPE_QUARTER (quarter_get_type ())

#define TYPE_SLICE (slice_get_type ())
#define SLICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SLICE, Slice))
#define SLICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SLICE, SliceClass))
#define IS_SLICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SLICE))
#define IS_SLICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SLICE))
#define SLICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SLICE, SliceClass))

typedef struct _Slice Slice;
typedef struct _SliceClass SliceClass;
typedef struct _SlicePrivate SlicePrivate;
enum  {
	SLICE_0_PROPERTY,
	SLICE_NUM_PROPERTIES
};
static GParamSpec* slice_properties[SLICE_NUM_PROPERTIES];

#define TYPE_BONUS (bonus_get_type ())
#define BONUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONUS, Bonus))
#define BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONUS, BonusClass))
#define IS_BONUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONUS))
#define IS_BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONUS))
#define BONUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONUS, BonusClass))

typedef struct _Bonus Bonus;
typedef struct _BonusClass BonusClass;
#define _angle_iterator_unref0(var) ((var == NULL) ? NULL : (var = (angle_iterator_unref (var), NULL)))

#define TYPE_WORM_PROPERTIES (worm_properties_get_type ())
#define WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_PROPERTIES, WormProperties))
#define WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_PROPERTIES, WormPropertiesClass))
#define IS_WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_PROPERTIES))
#define IS_WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_PROPERTIES))
#define WORM_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_PROPERTIES, WormPropertiesClass))

typedef struct _WormProperties WormProperties;
typedef struct _WormPropertiesClass WormPropertiesClass;
typedef struct _WormPropertiesPrivate WormPropertiesPrivate;
enum  {
	WORM_PROPERTIES_0_PROPERTY,
	WORM_PROPERTIES_COLOR_PROPERTY,
	WORM_PROPERTIES_UP_PROPERTY,
	WORM_PROPERTIES_DOWN_PROPERTY,
	WORM_PROPERTIES_LEFT_PROPERTY,
	WORM_PROPERTIES_RIGHT_PROPERTY,
	WORM_PROPERTIES_RAW_UP_PROPERTY,
	WORM_PROPERTIES_RAW_DOWN_PROPERTY,
	WORM_PROPERTIES_RAW_LEFT_PROPERTY,
	WORM_PROPERTIES_RAW_RIGHT_PROPERTY,
	WORM_PROPERTIES_NUM_PROPERTIES
};
static GParamSpec* worm_properties_properties[WORM_PROPERTIES_NUM_PROPERTIES];
typedef struct _WormPositionsPrivate WormPositionsPrivate;
enum  {
	WORM_POSITIONS_0_PROPERTY,
	WORM_POSITIONS_NUM_PROPERTIES
};
static GParamSpec* worm_positions_properties[WORM_POSITIONS_NUM_PROPERTIES];
typedef GeeList* (*WormGetOtherWormsType) (Worm* _self_, gpointer user_data);
typedef GeeList* (*WormGetBonusesType) (gpointer user_data);
enum  {
	WORM_0_PROPERTY,
	WORM_STARTING_POSITION_PROPERTY,
	WORM_ID_PROPERTY,
	WORM_IS_MATERIALIZED_PROPERTY,
	WORM_LIVES_PROPERTY,
	WORM_CHANGE_PROPERTY,
	WORM_SCORE_PROPERTY,
	WORM_LENGTH_PROPERTY,
	WORM_HEAD_PROPERTY,
	WORM_DIRECTION_PROPERTY,
	WORM_WIDTH_PROPERTY,
	WORM_HEIGHT_PROPERTY,
	WORM_CAPACITY_PROPERTY,
	WORM_NUM_PROPERTIES
};
static GParamSpec* worm_properties[WORM_NUM_PROPERTIES];
typedef struct _Block11Data Block11Data;
typedef enum  {
	BONUS_ETYPE_REGULAR,
	BONUS_ETYPE_HALF,
	BONUS_ETYPE_DOUBLE,
	BONUS_ETYPE_LIFE,
	BONUS_ETYPE_REVERSE,
	BONUS_ETYPE_WARP
} BonuseType;

#define BONUS_TYPE_ETYPE (bonus_etype_get_type ())
enum  {
	WORM_BONUS_FOUND_SIGNAL,
	WORM_NUM_SIGNALS
};
static guint worm_signals[WORM_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Position {
	guint8 x;
	guint8 y;
};

struct _SignedPosition {
	gint64 x;
	gint64 y;
	gint64 x_max;
	gint64 y_max;
};

struct _WormMap {
	GObject parent_instance;
	WormMapPrivate * priv;
};

struct _WormMapClass {
	GObjectClass parent_class;
};

struct _WormMapPrivate {
	guint64* map;
	gint map_length1;
	gint map_length2;
};

struct _Worm {
	GObject parent_instance;
	WormPrivate * priv;
	gboolean is_human;
	gboolean keypress;
	gint rounds_to_stay_still;
	gboolean is_stopped;
	Position warp_position;
	gboolean warp_bonus;
	WormPositions* list;
};

struct _WormClass {
	GObjectClass parent_class;
};

struct _int128 {
	guint64 hi;
	guint64 lo;
	gboolean negative;
	guint64 remainder;
};

struct _AngleIterator {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AngleIteratorPrivate * priv;
};

struct _AngleIteratorClass {
	GTypeClass parent_class;
	void (*finalize) (AngleIterator *self);
};

struct _Angle {
	gint64 x;
	gint64 y;
	gint64 origin_x;
	gint64 origin_y;
	gint64 x_max;
	gint64 y_max;
};

struct _AngleIteratorPrivate {
	Angle pAngle;
	guint64 index;
};

struct _ParamSpecAngleIterator {
	GParamSpec parent_instance;
};

struct _Slice {
	GObject parent_instance;
	SlicePrivate * priv;
	Angle min;
	Angle max;
};

struct _SliceClass {
	GObjectClass parent_class;
};

struct _SlicePrivate {
	gboolean min_set;
	gboolean max_set;
};

struct _WormProperties {
	GObject parent_instance;
	WormPropertiesPrivate * priv;
};

struct _WormPropertiesClass {
	GObjectClass parent_class;
};

struct _WormPropertiesPrivate {
	gint _color;
	guint _up;
	guint _down;
	guint _left;
	guint _right;
	gint _raw_up;
	gint _raw_down;
	gint _raw_left;
	gint _raw_right;
};

struct _WormPositions {
	GeeLinkedList parent_instance;
	WormPositionsPrivate * priv;
};

struct _WormPositionsClass {
	GeeLinkedListClass parent_class;
};

struct _WormPrivate {
	Position _starting_position;
	gint _id;
	gint rounds_to_stay_dematerialized;
	guint8 _lives;
	gint _change;
	gint _score;
	WormDirection _direction;
	WormDirection starting_direction;
	GeeArrayQueue* key_queue;
	GeeArrayList* bonus_eaten;
	WormGetOtherWormsType get_other_worms;
	gpointer get_other_worms_target;
	GDestroyNotify get_other_worms_target_destroy_notify;
	WormGetBonusesType get_bonuses;
	gpointer get_bonuses_target;
	GDestroyNotify get_bonuses_target_destroy_notify;
	guint8 _width;
	guint8 _height;
	gint _capacity;
	gboolean LastUturnA;
};

struct _Block11Data {
	int _ref_count_;
	Worm* self;
	WormGetOtherWormsType cb0;
	gpointer cb0_target;
	WormGetBonusesType cb1;
	gpointer cb1_target;
};

static gint WormMap_private_offset;
static gpointer worm_map_parent_class = NULL;
static gint AngleIterator_private_offset;
static gpointer angle_iterator_parent_class = NULL;
static gint Slice_private_offset;
static gpointer slice_parent_class = NULL;
static gint WormProperties_private_offset;
static gpointer worm_properties_parent_class = NULL;
static gpointer worm_positions_parent_class = NULL;
static gint Worm_private_offset;
static gpointer worm_parent_class = NULL;
static guint* worm_deadend_board;
static gint worm_deadend_board_length1;
static gint worm_deadend_board_length2;
static guint* worm_deadend_board = NULL;
static gint worm_deadend_board_length1 = 0;
static gint worm_deadend_board_length2 = 0;
static guint worm_deadend_runnumber;
static guint worm_deadend_runnumber = (guint) 0;

VALA_EXTERN GType worm_direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN WormDirection worm_direction_turn_left (WormDirection self);
VALA_EXTERN WormDirection worm_direction_turn_right (WormDirection self);
VALA_EXTERN WormDirection* worm_direction_get_space_fill_array (WormDirection self,
                                                    gint* result_length1);
VALA_EXTERN WormDirection worm_direction_reverse (WormDirection self);
VALA_EXTERN GType position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Position* position_dup (const Position* self);
VALA_EXTERN void position_free (Position* self);
VALA_EXTERN void position_move (Position *self,
                    WormDirection direction,
                    guint8 width,
                    guint8 height);
VALA_EXTERN GType signed_position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SignedPosition* signed_position_dup (const SignedPosition* self);
VALA_EXTERN void signed_position_free (SignedPosition* self);
VALA_EXTERN guint8 signed_position_wrap_x (SignedPosition *self);
VALA_EXTERN guint8 signed_position_wrap_y (SignedPosition *self);
VALA_EXTERN guint16 signed_position_wrap_xy (SignedPosition *self);
VALA_EXTERN GType worm_map_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormMap, g_object_unref)
VALA_EXTERN GType worm_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Worm, g_object_unref)
VALA_EXTERN WormMap* worm_map_new (GeeList* worms,
                       guint8 map_width,
                       guint8 map_height);
VALA_EXTERN WormMap* worm_map_construct (GType object_type,
                             GeeList* worms,
                             guint8 map_width,
                             guint8 map_height);
static void worm_map_add (WormMap* self,
                   GeeList* worms);
VALA_EXTERN gboolean worm_map_contain (WormMap* self,
                           guint16 p);
VALA_EXTERN gboolean worm_map_contain_position (WormMap* self,
                                    Position* p);
VALA_EXTERN GType worm_positions_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormPositions, g_object_unref)
VALA_EXTERN gboolean worm_map_contains (WormMap* self,
                            WormPositions* position_list);
VALA_EXTERN gboolean worm_get_is_materialized (Worm* self);
static void worm_map_finalize (GObject * obj);
static GType worm_map_get_type_once (void);
VALA_EXTERN GType int128_get_type (void) G_GNUC_CONST ;
VALA_EXTERN int128* int128_dup (const int128* self);
VALA_EXTERN void int128_free (int128* self);
VALA_EXTERN void int128_left_shift_assign (int128 *self,
                               gint shift);
VALA_EXTERN void int128_left_shift (int128 *self,
                        gint shift,
                        int128* result);
VALA_EXTERN void int128_right_shift_assign (int128 *self,
                                gint shift);
VALA_EXTERN void int128_add_assign (int128 *self,
                        int128* a);
VALA_EXTERN gboolean int128_greater_than (int128 *self,
                              int128* a);
VALA_EXTERN gboolean int128_less_than_or_equal_to (int128 *self,
                                       int128* a);
VALA_EXTERN gboolean int128_less_than (int128 *self,
                           int128* a);
VALA_EXTERN gboolean int128_equal_to (int128 *self,
                          int128* a);
VALA_EXTERN void int128_divide_by (int128 *self,
                       gint64 x,
                       int128* result);
static void int128_minus (int128 *self,
                   int128* a);
static void int128_multiply (int128 *self,
                      guint64 _a,
                      int128* result);
static gboolean int128_is_valid_int64 (int128 *self);
VALA_EXTERN gint64 int128_get_int64 (int128 *self);
VALA_EXTERN void multiply (gint64 _a,
               gint64 _b,
               int128* result);
VALA_EXTERN void multiply_by_2n (gint64 a,
                     gint n,
                     int128* result);
VALA_EXTERN gpointer angle_iterator_ref (gpointer instance);
VALA_EXTERN void angle_iterator_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_angle_iterator (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_angle_iterator (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_angle_iterator (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_angle_iterator (const GValue* value);
VALA_EXTERN GType angle_iterator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AngleIterator, angle_iterator_unref)
VALA_EXTERN GType angle_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Angle* angle_dup (const Angle* self);
VALA_EXTERN void angle_free (Angle* self);
VALA_EXTERN AngleIterator* angle_iterator_new (Angle* p);
VALA_EXTERN AngleIterator* angle_iterator_construct (GType object_type,
                                         Angle* p);
VALA_EXTERN gboolean angle_iterator_next (AngleIterator* self);
VALA_EXTERN void angle_iterator_get (AngleIterator* self,
                         SignedPosition* result);
VALA_EXTERN void angle_get (Angle *self,
                guint64 i,
                SignedPosition* result);
static void angle_iterator_finalize (AngleIterator * obj);
static GType angle_iterator_get_type_once (void);
VALA_EXTERN GType quarter_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void angle_assign (Angle *self,
                   Angle* o);
VALA_EXTERN gboolean angle_less_than_or_equal_to (Angle *self,
                                      Angle* o);
VALA_EXTERN gboolean angle_greater_than (Angle *self,
                             Angle* o);
static Quarter angle_get_quarter (Angle *self);
VALA_EXTERN gboolean angle_less_than (Angle *self,
                          Angle* o);
VALA_EXTERN gboolean angle_equal_to (Angle *self,
                         Angle* o);
VALA_EXTERN gboolean angle_greater_than_or_equal_to (Angle *self,
                                         Angle* o);
VALA_EXTERN void angle_set_origin (Angle *self,
                       Position* origin);
VALA_EXTERN void angle_set_wrapping (Angle *self,
                         gint x,
                         gint y);
VALA_EXTERN gboolean angle_step_along_x (Angle *self);
static gint64 angle_set_delta_x_sign (Angle *self,
                               gint64 _x);
static gint64 angle_set_delta_y_sign (Angle *self,
                               gint64 _y);
VALA_EXTERN AngleIterator* angle_iterator (Angle *self);
VALA_EXTERN GType slice_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Slice, g_object_unref)
VALA_EXTERN Slice* slice_new (Slice* copy);
VALA_EXTERN Slice* slice_construct (GType object_type,
                        Slice* copy);
VALA_EXTERN void slice_assign (Slice* self,
                   Slice* o);
VALA_EXTERN void slice_set_direction_view (Slice* self,
                               WormDirection d,
                               gint* board,
                               gint board_length1,
                               gint board_length2);
VALA_EXTERN void slice_add_angle (Slice* self,
                      Angle* a);
VALA_EXTERN void slice_set_from_position (Slice* self,
                              Position* origin,
                              gint64 x,
                              gint64 y,
                              gint size);
VALA_EXTERN void slice_intersection_by_position (Slice* self,
                                     Position* origin,
                                     guint8 _x,
                                     guint8 _y,
                                     gint size);
VALA_EXTERN gboolean slice_is_empty (Slice* self);
VALA_EXTERN GType bonus_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bonus, g_object_unref)
static gboolean slice_is_bonus_at (Slice* self,
                            guint8 x,
                            guint8 y,
                            Bonus* b);
VALA_EXTERN guint8 bonus_get_x (Bonus* self);
VALA_EXTERN guint8 bonus_get_y (Bonus* self);
static gboolean slice_is_position_occupied (Slice* self,
                                     Position* p,
                                     gint* board,
                                     gint board_length1,
                                     gint board_length2,
                                     WormMap* worm_map);
VALA_EXTERN gint64 slice_is_visible (Slice* self,
                         Position* origin,
                         gint* board,
                         gint board_length1,
                         gint board_length2,
                         WormMap* worm_map,
                         Bonus* bonus);
static void slice_finalize (GObject * obj);
static GType slice_get_type_once (void);
VALA_EXTERN GType worm_properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormProperties, g_object_unref)
VALA_EXTERN WormProperties* worm_properties_new (void);
VALA_EXTERN WormProperties* worm_properties_construct (GType object_type);
VALA_EXTERN gint worm_properties_get_color (WormProperties* self);
VALA_EXTERN void worm_properties_set_color (WormProperties* self,
                                gint value);
VALA_EXTERN guint worm_properties_get_up (WormProperties* self);
VALA_EXTERN void worm_properties_set_up (WormProperties* self,
                             guint value);
VALA_EXTERN guint worm_properties_get_down (WormProperties* self);
VALA_EXTERN void worm_properties_set_down (WormProperties* self,
                               guint value);
VALA_EXTERN guint worm_properties_get_left (WormProperties* self);
VALA_EXTERN void worm_properties_set_left (WormProperties* self,
                               guint value);
VALA_EXTERN guint worm_properties_get_right (WormProperties* self);
VALA_EXTERN void worm_properties_set_right (WormProperties* self,
                                guint value);
VALA_EXTERN gint worm_properties_get_raw_up (WormProperties* self);
VALA_EXTERN void worm_properties_set_raw_up (WormProperties* self,
                                 gint value);
VALA_EXTERN gint worm_properties_get_raw_down (WormProperties* self);
VALA_EXTERN void worm_properties_set_raw_down (WormProperties* self,
                                   gint value);
VALA_EXTERN gint worm_properties_get_raw_left (WormProperties* self);
VALA_EXTERN void worm_properties_set_raw_left (WormProperties* self,
                                   gint value);
VALA_EXTERN gint worm_properties_get_raw_right (WormProperties* self);
VALA_EXTERN void worm_properties_set_raw_right (WormProperties* self,
                                    gint value);
static void worm_properties_finalize (GObject * obj);
static GType worm_properties_get_type_once (void);
static void _vala_worm_properties_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_worm_properties_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
VALA_EXTERN gboolean worm_positions_append_position (WormPositions* self,
                                         Position* p);
VALA_EXTERN void worm_positions_get_head (WormPositions* self,
                              Position* result);
VALA_EXTERN void worm_positions_set_head (WormPositions* self,
                              Position* p);
VALA_EXTERN gboolean worm_positions_prepend_position (WormPositions* self,
                                          Position* p);
VALA_EXTERN void worm_positions_remove_tail (WormPositions* self,
                                 Position* result);
VALA_EXTERN WormPositions* worm_positions_new (void);
VALA_EXTERN WormPositions* worm_positions_construct (GType object_type);
static GType worm_positions_get_type_once (void);
VALA_EXTERN Worm* worm_new (gint id,
                guint8 width,
                guint8 height,
                WormGetOtherWormsType cb0,
                gpointer cb0_target,
                WormGetBonusesType cb1,
                gpointer cb1_target);
VALA_EXTERN Worm* worm_construct (GType object_type,
                      gint id,
                      guint8 width,
                      guint8 height,
                      WormGetOtherWormsType cb0,
                      gpointer cb0_target,
                      WormGetBonusesType cb1,
                      gpointer cb1_target);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static GeeList* __lambda4_ (Block11Data* _data11_,
                     Worm* worm);
static GeeList* ___lambda4__worm_get_other_worms_type (Worm* _self_,
                                                gpointer self);
static GeeList* __lambda5_ (Block11Data* _data11_);
static GeeList* ___lambda5__worm_get_bonuses_type (gpointer self);
VALA_EXTERN void worm_set_start (Worm* self,
                     guint8 x,
                     guint8 y,
                     WormDirection direction);
static void worm_set_starting_position (Worm* self,
                                 Position * value);
VALA_EXTERN void worm_get_starting_position (Worm* self,
                                 Position * result);
static void worm_set_direction (Worm* self,
                         WormDirection value);
VALA_EXTERN void worm_set_change (Worm* self,
                      gint value);
VALA_EXTERN void worm_move_part_1 (Worm* self);
VALA_EXTERN void worm_get_head (Worm* self,
                    Position * result);
VALA_EXTERN WormDirection worm_get_direction (Worm* self);
static guint8 worm_get_width (Worm* self);
static guint8 worm_get_height (Worm* self);
VALA_EXTERN void worm_move_part_2 (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       Position* head_position);
static void worm_set_head (Worm* self,
                    Position * value);
VALA_EXTERN gint worm_get_change (Worm* self);
VALA_EXTERN void worm_remove_bonus_eaten_position (Worm* self,
                                       Position* p);
static void worm_dequeue_keypress (Worm* self);
static void worm_materialize (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2);
VALA_EXTERN void worm_add_bonus_eaten_position (Worm* self,
                                    guint8 x,
                                    guint8 y);
VALA_EXTERN gboolean worm_was_bonus_eaten_at_this_position (Worm* self,
                                                guint16 position);
VALA_EXTERN void worm_reduce_tail (Worm* self,
                       gint erase_size);
VALA_EXTERN void worm_reverse (Worm* self);
static gboolean worm_does_list_contain_position (WormPositions* position_list,
                                          guint16 position);
VALA_EXTERN gboolean worm_is_position_clear_of_materialized_worms (Worm* self,
                                                       GeeLinkedList* worms,
                                                       Position* position);
static gboolean worm_is_board_position_occupied (Position* p,
                                          gint* board,
                                          gint board_length1,
                                          gint board_length2);
VALA_EXTERN gboolean worm_can_move_to (Worm* self,
                           gint* board,
                           gint board_length1,
                           gint board_length2,
                           GeeLinkedList* worms,
                           Position* position);
VALA_EXTERN gboolean worm_can_move_to_map (Worm* self,
                               gint* board,
                               gint board_length1,
                               gint board_length2,
                               WormMap* worm_map,
                               Position* position);
VALA_EXTERN gboolean worm_can_move_direction (Worm* self,
                                  gint* board,
                                  gint board_length1,
                                  gint board_length2,
                                  GeeLinkedList* worms,
                                  WormDirection direction);
VALA_EXTERN void worm_spawn (Worm* self,
                 gint* board,
                 gint board_length1,
                 gint board_length2);
VALA_EXTERN void worm_get_position_after_direction_move (Worm* self,
                                             Position* origin,
                                             WormDirection direction,
                                             Position* result);
VALA_EXTERN void worm_dematerialize (Worm* self,
                         gint rounds,
                         gint gamedelay);
VALA_EXTERN void worm_add_life (Worm* self);
VALA_EXTERN guint8 worm_get_lives (Worm* self);
VALA_EXTERN void worm_set_lives (Worm* self,
                     guint8 value);
static inline void worm_lose_life (Worm* self);
VALA_EXTERN void worm_reset (Worm* self,
                 gint* board,
                 gint board_length1,
                 gint board_length2);
VALA_EXTERN void worm_position_move (Worm* self,
                         Position* result);
static void worm_direction_set (Worm* self,
                         WormDirection dir);
static void worm_queue_keypress (Worm* self,
                          WormDirection dir);
static WormDirection worm_uturn (Worm* self,
                          gint* board,
                          gint board_length1,
                          gint board_length2,
                          GeeLinkedList* worms,
                          WormDirection direction);
static gint worm_get_raw_key (Worm* self,
                       guint keyval);
VALA_EXTERN gboolean worm_handle_keypress (Worm* self,
                               guint keycode,
                               GeeHashMap* worm_props,
                               gint* board,
                               gint board_length1,
                               gint board_length2,
                               GeeLinkedList* worms);
static gint worm_ai_deadend (gint* board,
                      gint board_length1,
                      gint board_length2,
                      WormMap* worm_map,
                      Position* position,
                      gint length);
static void _vala_array_add8 (Position* * array,
                       gint* length,
                       gint* size,
                       const Position* value);
VALA_EXTERN gint worm_ai_deadend_after (gint* board,
                            gint board_length1,
                            gint board_length2,
                            GeeLinkedList* worms,
                            WormMap* worm_map,
                            Position* old_position,
                            WormDirection direction,
                            gint length);
static inline gboolean worm_ai_too_close (Worm* self,
                            GeeLinkedList* worms,
                            WormDirection direction);
VALA_EXTERN GType bonus_etype_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean worm_ai_is_bonus_more_attractive (Worm* self,
                                           BonuseType b0,
                                           gint64 d0,
                                           BonuseType b1,
                                           gint64 d1);
VALA_EXTERN gboolean worm_ai_can_see_bonus (Worm* self,
                                gint* board,
                                gint board_length1,
                                gint board_length2,
                                Position* origin,
                                Bonus* bonus,
                                WormDirection direction);
VALA_EXTERN gint64 worm_ai_count_distance_to_a_bonus_in_direction (Worm* self,
                                                       gint* board,
                                                       gint board_length1,
                                                       gint board_length2,
                                                       WormMap* worm_map,
                                                       Position* origin,
                                                       WormDirection direction,
                                                       BonuseType* bonus_type);
VALA_EXTERN BonuseType bonus_get_etype (Bonus* self);
VALA_EXTERN void worm_ai_move (Worm* self,
                   gint* board,
                   gint board_length1,
                   gint board_length2,
                   GeeLinkedList* worms);
static gint worm_get_capacity (Worm* self);
VALA_EXTERN gint worm_get_length (Worm* self);
static gboolean _position_equal (const Position * s1,
                          const Position * s2);
VALA_EXTERN gint worm_get_id (Worm* self);
static void worm_set_id (Worm* self,
                  gint value);
VALA_EXTERN gint worm_get_score (Worm* self);
VALA_EXTERN void worm_set_score (Worm* self,
                     gint value);
static void worm_set_width (Worm* self,
                     guint8 value);
static void worm_set_height (Worm* self,
                      guint8 value);
static void worm_set_capacity (Worm* self,
                        gint value);
static GObject * worm_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties);
static void worm_finalize (GObject * obj);
static GType worm_get_type_once (void);
static void _vala_worm_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_worm_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);

WormDirection
worm_direction_turn_left (WormDirection self)
{
	WormDirection result;
#line 48 "../src/worm.vala"
	switch (self) {
#line 48 "../src/worm.vala"
		case WORM_DIRECTION_EAST:
#line 882 "worm.c"
		{
#line 51 "../src/worm.vala"
			result = WORM_DIRECTION_NORTH;
#line 51 "../src/worm.vala"
			return result;
#line 888 "worm.c"
		}
#line 48 "../src/worm.vala"
		case WORM_DIRECTION_NORTH:
#line 892 "worm.c"
		{
#line 53 "../src/worm.vala"
			result = WORM_DIRECTION_WEST;
#line 53 "../src/worm.vala"
			return result;
#line 898 "worm.c"
		}
#line 48 "../src/worm.vala"
		case WORM_DIRECTION_WEST:
#line 902 "worm.c"
		{
#line 55 "../src/worm.vala"
			result = WORM_DIRECTION_SOUTH;
#line 55 "../src/worm.vala"
			return result;
#line 908 "worm.c"
		}
#line 48 "../src/worm.vala"
		case WORM_DIRECTION_SOUTH:
#line 912 "worm.c"
		{
#line 57 "../src/worm.vala"
			result = WORM_DIRECTION_EAST;
#line 57 "../src/worm.vala"
			return result;
#line 918 "worm.c"
		}
		default:
		{
#line 59 "../src/worm.vala"
			g_assert_not_reached ();
#line 924 "worm.c"
		}
	}
}

WormDirection
worm_direction_turn_right (WormDirection self)
{
	WormDirection result;
#line 65 "../src/worm.vala"
	switch (self) {
#line 65 "../src/worm.vala"
		case WORM_DIRECTION_EAST:
#line 937 "worm.c"
		{
#line 68 "../src/worm.vala"
			result = WORM_DIRECTION_SOUTH;
#line 68 "../src/worm.vala"
			return result;
#line 943 "worm.c"
		}
#line 65 "../src/worm.vala"
		case WORM_DIRECTION_SOUTH:
#line 947 "worm.c"
		{
#line 70 "../src/worm.vala"
			result = WORM_DIRECTION_WEST;
#line 70 "../src/worm.vala"
			return result;
#line 953 "worm.c"
		}
#line 65 "../src/worm.vala"
		case WORM_DIRECTION_WEST:
#line 957 "worm.c"
		{
#line 72 "../src/worm.vala"
			result = WORM_DIRECTION_NORTH;
#line 72 "../src/worm.vala"
			return result;
#line 963 "worm.c"
		}
#line 65 "../src/worm.vala"
		case WORM_DIRECTION_NORTH:
#line 967 "worm.c"
		{
#line 74 "../src/worm.vala"
			result = WORM_DIRECTION_EAST;
#line 74 "../src/worm.vala"
			return result;
#line 973 "worm.c"
		}
		default:
		{
#line 76 "../src/worm.vala"
			g_assert_not_reached ();
#line 979 "worm.c"
		}
	}
}

WormDirection*
worm_direction_get_space_fill_array (WormDirection self,
                                     gint* result_length1)
{
	WormDirection* result;
#line 82 "../src/worm.vala"
	switch (self) {
#line 82 "../src/worm.vala"
		case WORM_DIRECTION_WEST:
#line 993 "worm.c"
		{
			WormDirection* _tmp0_;
			WormDirection* _tmp1_;
			gint _tmp1__length1;
#line 85 "../src/worm.vala"
			_tmp0_ = g_new0 (WormDirection, 3);
#line 85 "../src/worm.vala"
			_tmp0_[0] = WORM_DIRECTION_SOUTH;
#line 85 "../src/worm.vala"
			_tmp0_[1] = WORM_DIRECTION_WEST;
#line 85 "../src/worm.vala"
			_tmp0_[2] = WORM_DIRECTION_NORTH;
#line 85 "../src/worm.vala"
			_tmp1_ = _tmp0_;
#line 85 "../src/worm.vala"
			_tmp1__length1 = 3;
#line 85 "../src/worm.vala"
			if (result_length1) {
#line 85 "../src/worm.vala"
				*result_length1 = _tmp1__length1;
#line 1014 "worm.c"
			}
#line 85 "../src/worm.vala"
			result = _tmp1_;
#line 85 "../src/worm.vala"
			return result;
#line 1020 "worm.c"
		}
#line 82 "../src/worm.vala"
		case WORM_DIRECTION_NORTH:
#line 1024 "worm.c"
		{
			WormDirection* _tmp2_;
			WormDirection* _tmp3_;
			gint _tmp3__length1;
#line 87 "../src/worm.vala"
			_tmp2_ = g_new0 (WormDirection, 3);
#line 87 "../src/worm.vala"
			_tmp2_[0] = WORM_DIRECTION_EAST;
#line 87 "../src/worm.vala"
			_tmp2_[1] = WORM_DIRECTION_WEST;
#line 87 "../src/worm.vala"
			_tmp2_[2] = WORM_DIRECTION_NORTH;
#line 87 "../src/worm.vala"
			_tmp3_ = _tmp2_;
#line 87 "../src/worm.vala"
			_tmp3__length1 = 3;
#line 87 "../src/worm.vala"
			if (result_length1) {
#line 87 "../src/worm.vala"
				*result_length1 = _tmp3__length1;
#line 1045 "worm.c"
			}
#line 87 "../src/worm.vala"
			result = _tmp3_;
#line 87 "../src/worm.vala"
			return result;
#line 1051 "worm.c"
		}
#line 82 "../src/worm.vala"
		case WORM_DIRECTION_EAST:
#line 1055 "worm.c"
		{
			WormDirection* _tmp4_;
			WormDirection* _tmp5_;
			gint _tmp5__length1;
#line 89 "../src/worm.vala"
			_tmp4_ = g_new0 (WormDirection, 3);
#line 89 "../src/worm.vala"
			_tmp4_[0] = WORM_DIRECTION_EAST;
#line 89 "../src/worm.vala"
			_tmp4_[1] = WORM_DIRECTION_SOUTH;
#line 89 "../src/worm.vala"
			_tmp4_[2] = WORM_DIRECTION_NORTH;
#line 89 "../src/worm.vala"
			_tmp5_ = _tmp4_;
#line 89 "../src/worm.vala"
			_tmp5__length1 = 3;
#line 89 "../src/worm.vala"
			if (result_length1) {
#line 89 "../src/worm.vala"
				*result_length1 = _tmp5__length1;
#line 1076 "worm.c"
			}
#line 89 "../src/worm.vala"
			result = _tmp5_;
#line 89 "../src/worm.vala"
			return result;
#line 1082 "worm.c"
		}
#line 82 "../src/worm.vala"
		case WORM_DIRECTION_SOUTH:
#line 1086 "worm.c"
		{
			WormDirection* _tmp6_;
			WormDirection* _tmp7_;
			gint _tmp7__length1;
#line 91 "../src/worm.vala"
			_tmp6_ = g_new0 (WormDirection, 3);
#line 91 "../src/worm.vala"
			_tmp6_[0] = WORM_DIRECTION_EAST;
#line 91 "../src/worm.vala"
			_tmp6_[1] = WORM_DIRECTION_SOUTH;
#line 91 "../src/worm.vala"
			_tmp6_[2] = WORM_DIRECTION_WEST;
#line 91 "../src/worm.vala"
			_tmp7_ = _tmp6_;
#line 91 "../src/worm.vala"
			_tmp7__length1 = 3;
#line 91 "../src/worm.vala"
			if (result_length1) {
#line 91 "../src/worm.vala"
				*result_length1 = _tmp7__length1;
#line 1107 "worm.c"
			}
#line 91 "../src/worm.vala"
			result = _tmp7_;
#line 91 "../src/worm.vala"
			return result;
#line 1113 "worm.c"
		}
		default:
		{
#line 93 "../src/worm.vala"
			g_assert_not_reached ();
#line 1119 "worm.c"
		}
	}
}

WormDirection
worm_direction_reverse (WormDirection self)
{
	WormDirection result;
#line 100 "../src/worm.vala"
	switch (self) {
#line 100 "../src/worm.vala"
		case WORM_DIRECTION_EAST:
#line 1132 "worm.c"
		{
#line 103 "../src/worm.vala"
			result = WORM_DIRECTION_WEST;
#line 103 "../src/worm.vala"
			return result;
#line 1138 "worm.c"
		}
#line 100 "../src/worm.vala"
		case WORM_DIRECTION_SOUTH:
#line 1142 "worm.c"
		{
#line 105 "../src/worm.vala"
			result = WORM_DIRECTION_NORTH;
#line 105 "../src/worm.vala"
			return result;
#line 1148 "worm.c"
		}
#line 100 "../src/worm.vala"
		case WORM_DIRECTION_WEST:
#line 1152 "worm.c"
		{
#line 107 "../src/worm.vala"
			result = WORM_DIRECTION_EAST;
#line 107 "../src/worm.vala"
			return result;
#line 1158 "worm.c"
		}
#line 100 "../src/worm.vala"
		case WORM_DIRECTION_NORTH:
#line 1162 "worm.c"
		{
#line 109 "../src/worm.vala"
			result = WORM_DIRECTION_SOUTH;
#line 109 "../src/worm.vala"
			return result;
#line 1168 "worm.c"
		}
		default:
		{
#line 111 "../src/worm.vala"
			g_assert_not_reached ();
#line 1174 "worm.c"
		}
	}
}

 G_GNUC_NO_INLINE static GType
worm_direction_get_type_once (void)
{
	static const GEnumValue values[] = {{WORM_DIRECTION_NONE, "WORM_DIRECTION_NONE", "none"}, {WORM_DIRECTION_RIGHT, "WORM_DIRECTION_RIGHT", "right"}, {WORM_DIRECTION_EAST, "WORM_DIRECTION_EAST", "east"}, {WORM_DIRECTION_DOWN, "WORM_DIRECTION_DOWN", "down"}, {WORM_DIRECTION_SOUTH, "WORM_DIRECTION_SOUTH", "south"}, {WORM_DIRECTION_LEFT, "WORM_DIRECTION_LEFT", "left"}, {WORM_DIRECTION_WEST, "WORM_DIRECTION_WEST", "west"}, {WORM_DIRECTION_UP, "WORM_DIRECTION_UP", "up"}, {WORM_DIRECTION_NORTH, "WORM_DIRECTION_NORTH", "north"}, {0, NULL, NULL}};
	GType worm_direction_type_id;
	worm_direction_type_id = g_enum_register_static ("WormDirection", values);
	return worm_direction_type_id;
}

GType
worm_direction_get_type (void)
{
	static gsize worm_direction_type_id__once = 0;
	if (g_once_init_enter (&worm_direction_type_id__once)) {
		GType worm_direction_type_id;
		worm_direction_type_id = worm_direction_get_type_once ();
		g_once_init_leave (&worm_direction_type_id__once, worm_direction_type_id);
	}
	return worm_direction_type_id__once;
}

void
position_move (Position *self,
               WormDirection direction,
               guint8 width,
               guint8 height)
{
#line 124 "../src/worm.vala"
	switch (direction) {
#line 124 "../src/worm.vala"
		case WORM_DIRECTION_NORTH:
#line 1210 "worm.c"
		{
#line 127 "../src/worm.vala"
			if (((gint) (*self).y) == 0) {
#line 128 "../src/worm.vala"
				(*self).y = (guint8) (height - 1);
#line 1216 "worm.c"
			} else {
				guint8 _tmp0_;
#line 130 "../src/worm.vala"
				_tmp0_ = (*self).y;
#line 130 "../src/worm.vala"
				(*self).y = _tmp0_ - 1;
#line 1223 "worm.c"
			}
#line 131 "../src/worm.vala"
			break;
#line 1227 "worm.c"
		}
#line 124 "../src/worm.vala"
		case WORM_DIRECTION_SOUTH:
#line 1231 "worm.c"
		{
#line 133 "../src/worm.vala"
			if (((gint) (*self).y) >= (height - 1)) {
#line 134 "../src/worm.vala"
				(*self).y = (guint8) 0;
#line 1237 "worm.c"
			} else {
				guint8 _tmp1_;
#line 136 "../src/worm.vala"
				_tmp1_ = (*self).y;
#line 136 "../src/worm.vala"
				(*self).y = _tmp1_ + 1;
#line 1244 "worm.c"
			}
#line 137 "../src/worm.vala"
			break;
#line 1248 "worm.c"
		}
#line 124 "../src/worm.vala"
		case WORM_DIRECTION_WEST:
#line 1252 "worm.c"
		{
#line 139 "../src/worm.vala"
			if (((gint) (*self).x) == 0) {
#line 140 "../src/worm.vala"
				(*self).x = (guint8) (width - 1);
#line 1258 "worm.c"
			} else {
				guint8 _tmp2_;
#line 142 "../src/worm.vala"
				_tmp2_ = (*self).x;
#line 142 "../src/worm.vala"
				(*self).x = _tmp2_ - 1;
#line 1265 "worm.c"
			}
#line 143 "../src/worm.vala"
			break;
#line 1269 "worm.c"
		}
#line 124 "../src/worm.vala"
		case WORM_DIRECTION_EAST:
#line 1273 "worm.c"
		{
#line 145 "../src/worm.vala"
			if (((gint) (*self).x) >= (width - 1)) {
#line 146 "../src/worm.vala"
				(*self).x = (guint8) 0;
#line 1279 "worm.c"
			} else {
				guint8 _tmp3_;
#line 148 "../src/worm.vala"
				_tmp3_ = (*self).x;
#line 148 "../src/worm.vala"
				(*self).x = _tmp3_ + 1;
#line 1286 "worm.c"
			}
#line 149 "../src/worm.vala"
			break;
#line 1290 "worm.c"
		}
		default:
		{
#line 151 "../src/worm.vala"
			g_assert_not_reached ();
#line 1296 "worm.c"
		}
	}
}

Position*
position_dup (const Position* self)
{
	Position* dup;
#line 117 "../src/worm.vala"
	dup = g_new0 (Position, 1);
#line 117 "../src/worm.vala"
	memcpy (dup, self, sizeof (Position));
#line 117 "../src/worm.vala"
	return dup;
#line 1311 "worm.c"
}

void
position_free (Position* self)
{
#line 117 "../src/worm.vala"
	g_free (self);
#line 1319 "worm.c"
}

 G_GNUC_NO_INLINE static GType
position_get_type_once (void)
{
	GType position_type_id;
	position_type_id = g_boxed_type_register_static ("Position", (GBoxedCopyFunc) position_dup, (GBoxedFreeFunc) position_free);
	return position_type_id;
}

GType
position_get_type (void)
{
	static gsize position_type_id__once = 0;
	if (g_once_init_enter (&position_type_id__once)) {
		GType position_type_id;
		position_type_id = position_get_type_once ();
		g_once_init_leave (&position_type_id__once, position_type_id);
	}
	return position_type_id__once;
}

guint8
signed_position_wrap_x (SignedPosition *self)
{
	guint8 result;
#line 171 "../src/worm.vala"
	_vala_assert ((*self).x_max > ((gint64) 0), "x_max > 0");
#line 172 "../src/worm.vala"
	if ((*self).x > (*self).x_max) {
#line 173 "../src/worm.vala"
		result = (guint8) ((*self).x % (*self).x_max);
#line 173 "../src/worm.vala"
		return result;
#line 1354 "worm.c"
	} else {
#line 174 "../src/worm.vala"
		if ((*self).x < ((gint64) 0)) {
#line 175 "../src/worm.vala"
			result = (guint8) ((*self).x + (((llabs ((*self).x) / (*self).x_max) + 1) * (*self).x_max));
#line 175 "../src/worm.vala"
			return result;
#line 1362 "worm.c"
		} else {
#line 177 "../src/worm.vala"
			result = (guint8) (*self).x;
#line 177 "../src/worm.vala"
			return result;
#line 1368 "worm.c"
		}
	}
}

guint8
signed_position_wrap_y (SignedPosition *self)
{
	guint8 result;
#line 182 "../src/worm.vala"
	_vala_assert ((*self).y_max > ((gint64) 0), "y_max > 0");
#line 183 "../src/worm.vala"
	if ((*self).y > (*self).y_max) {
#line 184 "../src/worm.vala"
		result = (guint8) ((*self).y % (*self).y_max);
#line 184 "../src/worm.vala"
		return result;
#line 1385 "worm.c"
	} else {
#line 185 "../src/worm.vala"
		if ((*self).y < ((gint64) 0)) {
#line 186 "../src/worm.vala"
			result = (guint8) ((*self).y + (((llabs ((*self).y) / (*self).y_max) + 1) * (*self).y_max));
#line 186 "../src/worm.vala"
			return result;
#line 1393 "worm.c"
		} else {
#line 188 "../src/worm.vala"
			result = (guint8) (*self).y;
#line 188 "../src/worm.vala"
			return result;
#line 1399 "worm.c"
		}
	}
}

guint16
signed_position_wrap_xy (SignedPosition *self)
{
	guint16 result;
#line 193 "../src/worm.vala"
	result = (guint16) ((((guint16) signed_position_wrap_x (&(*self))) << 8) | signed_position_wrap_y (&(*self)));
#line 193 "../src/worm.vala"
	return result;
#line 1412 "worm.c"
}

SignedPosition*
signed_position_dup (const SignedPosition* self)
{
	SignedPosition* dup;
#line 160 "../src/worm.vala"
	dup = g_new0 (SignedPosition, 1);
#line 160 "../src/worm.vala"
	memcpy (dup, self, sizeof (SignedPosition));
#line 160 "../src/worm.vala"
	return dup;
#line 1425 "worm.c"
}

void
signed_position_free (SignedPosition* self)
{
#line 160 "../src/worm.vala"
	g_free (self);
#line 1433 "worm.c"
}

 G_GNUC_NO_INLINE static GType
signed_position_get_type_once (void)
{
	GType signed_position_type_id;
	signed_position_type_id = g_boxed_type_register_static ("SignedPosition", (GBoxedCopyFunc) signed_position_dup, (GBoxedFreeFunc) signed_position_free);
	return signed_position_type_id;
}

GType
signed_position_get_type (void)
{
	static gsize signed_position_type_id__once = 0;
	if (g_once_init_enter (&signed_position_type_id__once)) {
		GType signed_position_type_id;
		signed_position_type_id = signed_position_get_type_once ();
		g_once_init_leave (&signed_position_type_id__once, signed_position_type_id);
	}
	return signed_position_type_id__once;
}

static inline gpointer
worm_map_get_instance_private (WormMap* self)
{
	return G_STRUCT_MEMBER_P (self, WormMap_private_offset);
}

WormMap*
worm_map_construct (GType object_type,
                    GeeList* worms,
                    guint8 map_width,
                    guint8 map_height)
{
	WormMap * self = NULL;
	guint64* _tmp0_;
#line 213 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, NULL);
#line 213 "../src/worm.vala"
	self = (WormMap*) g_object_new (object_type, NULL);
#line 241 "../src/worm.vala"
	_tmp0_ = g_new0 (guint64, (((map_width - 1) / WORM_MAP_bits) + 1) * map_height);
#line 241 "../src/worm.vala"
	self->priv->map = (g_free (self->priv->map), NULL);
#line 241 "../src/worm.vala"
	self->priv->map = _tmp0_;
#line 241 "../src/worm.vala"
	self->priv->map_length1 = ((map_width - 1) / WORM_MAP_bits) + 1;
#line 241 "../src/worm.vala"
	self->priv->map_length2 = map_height;
#line 242 "../src/worm.vala"
	worm_map_add (self, worms);
#line 213 "../src/worm.vala"
	return self;
#line 1488 "worm.c"
}

WormMap*
worm_map_new (GeeList* worms,
              guint8 map_width,
              guint8 map_height)
{
#line 213 "../src/worm.vala"
	return worm_map_construct (TYPE_WORM_MAP, worms, map_width, map_height);
#line 1498 "worm.c"
}

gboolean
worm_map_contain (WormMap* self,
                  guint16 p)
{
	guint8 quotient = 0U;
	guint8 remainder = 0U;
	guint64* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	guint64 _tmp1_;
	gboolean result;
#line 245 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 264 "../src/worm.vala"
	quotient = (guint8) ((p >> 8) / WORM_MAP_bits);
#line 265 "../src/worm.vala"
	remainder = (guint8) ((p >> 8) % WORM_MAP_bits);
#line 267 "../src/worm.vala"
	_tmp0_ = self->priv->map;
#line 267 "../src/worm.vala"
	_tmp0__length1 = self->priv->map_length1;
#line 267 "../src/worm.vala"
	_tmp0__length2 = self->priv->map_length2;
#line 267 "../src/worm.vala"
	_tmp1_ = _tmp0_[(quotient * _tmp0__length2) + ((guint8) p)];
#line 267 "../src/worm.vala"
	result = ((_tmp1_ >> remainder) & 1) > ((guint64) 0);
#line 267 "../src/worm.vala"
	return result;
#line 1530 "worm.c"
}

gboolean
worm_map_contain_position (WormMap* self,
                           Position* p)
{
	Position _tmp0_;
	Position _tmp1_;
	gboolean result;
#line 270 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 270 "../src/worm.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 272 "../src/worm.vala"
	_tmp0_ = *p;
#line 272 "../src/worm.vala"
	_tmp1_ = *p;
#line 272 "../src/worm.vala"
	result = worm_map_contain (self, (guint16) ((((guint16) _tmp0_.x) << 8) | _tmp1_.y));
#line 272 "../src/worm.vala"
	return result;
#line 1552 "worm.c"
}

gboolean
worm_map_contains (WormMap* self,
                   WormPositions* position_list)
{
	gboolean result;
#line 275 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 275 "../src/worm.vala"
	g_return_val_if_fail (position_list != NULL, FALSE);
#line 1564 "worm.c"
	{
		WormPositions* _p_list = NULL;
		gint _p_size = 0;
		WormPositions* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _p_index = 0;
#line 277 "../src/worm.vala"
		_p_list = position_list;
#line 277 "../src/worm.vala"
		_tmp0_ = _p_list;
#line 277 "../src/worm.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 277 "../src/worm.vala"
		_tmp2_ = _tmp1_;
#line 277 "../src/worm.vala"
		_p_size = _tmp2_;
#line 277 "../src/worm.vala"
		_p_index = -1;
#line 277 "../src/worm.vala"
		while (TRUE) {
#line 1586 "worm.c"
			gint _tmp3_;
			gint _tmp4_;
			guint16 p = 0U;
			WormPositions* _tmp5_;
			gpointer _tmp6_;
#line 277 "../src/worm.vala"
			_p_index = _p_index + 1;
#line 277 "../src/worm.vala"
			_tmp3_ = _p_index;
#line 277 "../src/worm.vala"
			_tmp4_ = _p_size;
#line 277 "../src/worm.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 277 "../src/worm.vala"
				break;
#line 1602 "worm.c"
			}
#line 277 "../src/worm.vala"
			_tmp5_ = _p_list;
#line 277 "../src/worm.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _p_index);
#line 277 "../src/worm.vala"
			p = (guint16) ((guintptr) _tmp6_);
#line 278 "../src/worm.vala"
			if (worm_map_contain (self, p)) {
#line 279 "../src/worm.vala"
				result = TRUE;
#line 279 "../src/worm.vala"
				return result;
#line 1616 "worm.c"
			}
		}
	}
#line 280 "../src/worm.vala"
	result = FALSE;
#line 280 "../src/worm.vala"
	return result;
#line 1624 "worm.c"
}

static void
worm_map_add (WormMap* self,
              GeeList* worms)
{
#line 285 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 285 "../src/worm.vala"
	g_return_if_fail (worms != NULL);
#line 1635 "worm.c"
	{
		GeeList* _worm_list = NULL;
		gint _worm_size = 0;
		GeeList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _worm_index = 0;
#line 287 "../src/worm.vala"
		_worm_list = worms;
#line 287 "../src/worm.vala"
		_tmp0_ = _worm_list;
#line 287 "../src/worm.vala"
		_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 287 "../src/worm.vala"
		_tmp2_ = _tmp1_;
#line 287 "../src/worm.vala"
		_worm_size = _tmp2_;
#line 287 "../src/worm.vala"
		_worm_index = -1;
#line 287 "../src/worm.vala"
		while (TRUE) {
#line 1657 "worm.c"
			gint _tmp3_;
			gint _tmp4_;
			Worm* worm = NULL;
			GeeList* _tmp5_;
			gpointer _tmp6_;
			gboolean _tmp7_ = FALSE;
			Worm* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 287 "../src/worm.vala"
			_worm_index = _worm_index + 1;
#line 287 "../src/worm.vala"
			_tmp3_ = _worm_index;
#line 287 "../src/worm.vala"
			_tmp4_ = _worm_size;
#line 287 "../src/worm.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 287 "../src/worm.vala"
				break;
#line 1677 "worm.c"
			}
#line 287 "../src/worm.vala"
			_tmp5_ = _worm_list;
#line 287 "../src/worm.vala"
			_tmp6_ = gee_list_get (_tmp5_, _worm_index);
#line 287 "../src/worm.vala"
			worm = (Worm*) _tmp6_;
#line 289 "../src/worm.vala"
			_tmp8_ = worm;
#line 289 "../src/worm.vala"
			_tmp9_ = worm_get_is_materialized (_tmp8_);
#line 289 "../src/worm.vala"
			_tmp10_ = _tmp9_;
#line 289 "../src/worm.vala"
			if (_tmp10_) {
#line 1693 "worm.c"
				Worm* _tmp11_;
#line 289 "../src/worm.vala"
				_tmp11_ = worm;
#line 289 "../src/worm.vala"
				_tmp7_ = !_tmp11_->is_stopped;
#line 1699 "worm.c"
			} else {
#line 289 "../src/worm.vala"
				_tmp7_ = FALSE;
#line 1703 "worm.c"
			}
#line 289 "../src/worm.vala"
			if (_tmp7_) {
#line 1707 "worm.c"
				{
					WormPositions* _p_list = NULL;
					Worm* _tmp12_;
					WormPositions* _tmp13_;
					gint _p_size = 0;
					WormPositions* _tmp14_;
					gint _tmp15_;
					gint _tmp16_;
					gint _p_index = 0;
#line 291 "../src/worm.vala"
					_tmp12_ = worm;
#line 291 "../src/worm.vala"
					_tmp13_ = _tmp12_->list;
#line 291 "../src/worm.vala"
					_p_list = _tmp13_;
#line 291 "../src/worm.vala"
					_tmp14_ = _p_list;
#line 291 "../src/worm.vala"
					_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 291 "../src/worm.vala"
					_tmp16_ = _tmp15_;
#line 291 "../src/worm.vala"
					_p_size = _tmp16_;
#line 291 "../src/worm.vala"
					_p_index = -1;
#line 291 "../src/worm.vala"
					while (TRUE) {
#line 1735 "worm.c"
						gint _tmp17_;
						gint _tmp18_;
						guint16 p = 0U;
						WormPositions* _tmp19_;
						gpointer _tmp20_;
						guint8 x = 0U;
						guint8 y = 0U;
						guint64* _tmp21_;
						gint _tmp21__length1;
						gint _tmp21__length2;
#line 291 "../src/worm.vala"
						_p_index = _p_index + 1;
#line 291 "../src/worm.vala"
						_tmp17_ = _p_index;
#line 291 "../src/worm.vala"
						_tmp18_ = _p_size;
#line 291 "../src/worm.vala"
						if (!(_tmp17_ < _tmp18_)) {
#line 291 "../src/worm.vala"
							break;
#line 1756 "worm.c"
						}
#line 291 "../src/worm.vala"
						_tmp19_ = _p_list;
#line 291 "../src/worm.vala"
						_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp19_, _p_index);
#line 291 "../src/worm.vala"
						p = (guint16) ((guintptr) _tmp20_);
#line 299 "../src/worm.vala"
						x = (guint8) (p >> 8);
#line 300 "../src/worm.vala"
						y = (guint8) p;
#line 301 "../src/worm.vala"
						_tmp21_ = self->priv->map;
#line 301 "../src/worm.vala"
						_tmp21__length1 = self->priv->map_length1;
#line 301 "../src/worm.vala"
						_tmp21__length2 = self->priv->map_length2;
#line 301 "../src/worm.vala"
						_tmp21_[((x / WORM_MAP_bits) * _tmp21__length2) + y] |= ((guint64) 1) << (x % WORM_MAP_bits);
#line 1776 "worm.c"
					}
				}
			}
#line 287 "../src/worm.vala"
			_g_object_unref0 (worm);
#line 1782 "worm.c"
		}
	}
}

static void
worm_map_class_init (WormMapClass * klass,
                     gpointer klass_data)
{
#line 202 "../src/worm.vala"
	worm_map_parent_class = g_type_class_peek_parent (klass);
#line 202 "../src/worm.vala"
	g_type_class_adjust_private_offset (klass, &WormMap_private_offset);
#line 202 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->finalize = worm_map_finalize;
#line 1797 "worm.c"
}

static void
worm_map_instance_init (WormMap * self,
                        gpointer klass)
{
#line 202 "../src/worm.vala"
	self->priv = worm_map_get_instance_private (self);
#line 1806 "worm.c"
}

static void
worm_map_finalize (GObject * obj)
{
	WormMap * self;
#line 202 "../src/worm.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WORM_MAP, WormMap);
#line 205 "../src/worm.vala"
	self->priv->map = (g_free (self->priv->map), NULL);
#line 202 "../src/worm.vala"
	G_OBJECT_CLASS (worm_map_parent_class)->finalize (obj);
#line 1819 "worm.c"
}

 G_GNUC_NO_INLINE static GType
worm_map_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WormMapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) worm_map_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WormMap), 0, (GInstanceInitFunc) worm_map_instance_init, NULL };
	GType worm_map_type_id;
	worm_map_type_id = g_type_register_static (G_TYPE_OBJECT, "WormMap", &g_define_type_info, 0);
	WormMap_private_offset = g_type_add_instance_private (worm_map_type_id, sizeof (WormMapPrivate));
	return worm_map_type_id;
}

GType
worm_map_get_type (void)
{
	static gsize worm_map_type_id__once = 0;
	if (g_once_init_enter (&worm_map_type_id__once)) {
		GType worm_map_type_id;
		worm_map_type_id = worm_map_get_type_once ();
		g_once_init_leave (&worm_map_type_id__once, worm_map_type_id);
	}
	return worm_map_type_id__once;
}

void
int128_left_shift_assign (int128 *self,
                          gint shift)
{
#line 322 "../src/worm.vala"
	if (shift >= 64) {
#line 324 "../src/worm.vala"
		(*self).hi = (*self).lo;
#line 325 "../src/worm.vala"
		(*self).lo = (guint64) 0;
#line 326 "../src/worm.vala"
		shift = shift - 64;
#line 1856 "worm.c"
	}
#line 328 "../src/worm.vala"
	if (shift > 0) {
#line 330 "../src/worm.vala"
		(*self).hi = (*self).hi << shift;
#line 331 "../src/worm.vala"
		(*self).hi = (*self).hi | ((*self).lo >> (64 - shift));
#line 332 "../src/worm.vala"
		(*self).lo = (*self).lo << shift;
#line 1866 "worm.c"
	}
}

void
int128_left_shift (int128 *self,
                   gint shift,
                   int128* result)
{
	int128 r = {0};
	int128 _tmp0_ = {0};
#line 339 "../src/worm.vala"
	_tmp0_.hi = (*self).hi;
#line 339 "../src/worm.vala"
	_tmp0_.lo = (*self).lo;
#line 339 "../src/worm.vala"
	_tmp0_.negative = (*self).negative;
#line 339 "../src/worm.vala"
	r = _tmp0_;
#line 340 "../src/worm.vala"
	int128_left_shift_assign (&r, shift);
#line 341 "../src/worm.vala"
	*result = r;
#line 341 "../src/worm.vala"
	return;
#line 1891 "worm.c"
}

void
int128_right_shift_assign (int128 *self,
                           gint shift)
{
#line 347 "../src/worm.vala"
	if (shift >= 64) {
#line 349 "../src/worm.vala"
		(*self).lo = (*self).hi;
#line 350 "../src/worm.vala"
		(*self).hi = (guint64) 0;
#line 351 "../src/worm.vala"
		shift = shift - 64;
#line 1906 "worm.c"
	}
#line 353 "../src/worm.vala"
	if (shift > 0) {
#line 355 "../src/worm.vala"
		(*self).lo = (*self).lo >> shift;
#line 356 "../src/worm.vala"
		(*self).lo = (*self).lo | ((*self).hi << (64 - shift));
#line 357 "../src/worm.vala"
		(*self).hi = (*self).hi >> shift;
#line 1916 "worm.c"
	}
}

void
int128_add_assign (int128 *self,
                   int128* a)
{
	int128 _tmp0_;
	guint64 o = 0ULL;
	int128 _tmp1_;
#line 362 "../src/worm.vala"
	g_return_if_fail (a != NULL);
#line 364 "../src/worm.vala"
	_tmp0_ = *a;
#line 364 "../src/worm.vala"
	(*self).hi = (*self).hi + _tmp0_.hi;
#line 365 "../src/worm.vala"
	o = (*self).lo;
#line 366 "../src/worm.vala"
	_tmp1_ = *a;
#line 366 "../src/worm.vala"
	(*self).lo = (*self).lo + _tmp1_.lo;
#line 367 "../src/worm.vala"
	if ((*self).lo < o) {
#line 368 "../src/worm.vala"
		(*self).hi = (*self).hi + 1;
#line 1943 "worm.c"
	}
}

gboolean
int128_greater_than (int128 *self,
                     int128* a)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 372 "../src/worm.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 374 "../src/worm.vala"
	if (!(*self).negative) {
#line 1957 "worm.c"
		int128 _tmp1_;
#line 374 "../src/worm.vala"
		_tmp1_ = *a;
#line 374 "../src/worm.vala"
		_tmp0_ = !_tmp1_.negative;
#line 1963 "worm.c"
	} else {
#line 374 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 1967 "worm.c"
	}
#line 374 "../src/worm.vala"
	if (_tmp0_) {
#line 1971 "worm.c"
		gboolean _tmp2_ = FALSE;
		int128 _tmp3_;
#line 375 "../src/worm.vala"
		_tmp3_ = *a;
#line 375 "../src/worm.vala"
		if ((*self).hi > _tmp3_.hi) {
#line 375 "../src/worm.vala"
			_tmp2_ = TRUE;
#line 1980 "worm.c"
		} else {
			gboolean _tmp4_ = FALSE;
			int128 _tmp5_;
#line 375 "../src/worm.vala"
			_tmp5_ = *a;
#line 375 "../src/worm.vala"
			if ((*self).hi == _tmp5_.hi) {
#line 1988 "worm.c"
				int128 _tmp6_;
#line 375 "../src/worm.vala"
				_tmp6_ = *a;
#line 375 "../src/worm.vala"
				_tmp4_ = (*self).lo > _tmp6_.lo;
#line 1994 "worm.c"
			} else {
#line 375 "../src/worm.vala"
				_tmp4_ = FALSE;
#line 1998 "worm.c"
			}
#line 375 "../src/worm.vala"
			_tmp2_ = _tmp4_;
#line 2002 "worm.c"
		}
#line 375 "../src/worm.vala"
		result = _tmp2_;
#line 375 "../src/worm.vala"
		return result;
#line 2008 "worm.c"
	} else {
		gboolean _tmp7_ = FALSE;
#line 376 "../src/worm.vala"
		if (!(*self).negative) {
#line 2013 "worm.c"
			int128 _tmp8_;
#line 376 "../src/worm.vala"
			_tmp8_ = *a;
#line 376 "../src/worm.vala"
			_tmp7_ = _tmp8_.negative;
#line 2019 "worm.c"
		} else {
#line 376 "../src/worm.vala"
			_tmp7_ = FALSE;
#line 2023 "worm.c"
		}
#line 376 "../src/worm.vala"
		if (_tmp7_) {
#line 377 "../src/worm.vala"
			result = TRUE;
#line 377 "../src/worm.vala"
			return result;
#line 2031 "worm.c"
		} else {
			gboolean _tmp9_ = FALSE;
#line 378 "../src/worm.vala"
			if ((*self).negative) {
#line 2036 "worm.c"
				int128 _tmp10_;
#line 378 "../src/worm.vala"
				_tmp10_ = *a;
#line 378 "../src/worm.vala"
				_tmp9_ = !_tmp10_.negative;
#line 2042 "worm.c"
			} else {
#line 378 "../src/worm.vala"
				_tmp9_ = FALSE;
#line 2046 "worm.c"
			}
#line 378 "../src/worm.vala"
			if (_tmp9_) {
#line 379 "../src/worm.vala"
				result = FALSE;
#line 379 "../src/worm.vala"
				return result;
#line 2054 "worm.c"
			} else {
				gboolean _tmp11_ = FALSE;
				int128 _tmp12_;
#line 381 "../src/worm.vala"
				_tmp12_ = *a;
#line 381 "../src/worm.vala"
				if ((*self).hi < _tmp12_.hi) {
#line 381 "../src/worm.vala"
					_tmp11_ = TRUE;
#line 2064 "worm.c"
				} else {
					gboolean _tmp13_ = FALSE;
					int128 _tmp14_;
#line 381 "../src/worm.vala"
					_tmp14_ = *a;
#line 381 "../src/worm.vala"
					if ((*self).hi == _tmp14_.hi) {
#line 2072 "worm.c"
						int128 _tmp15_;
#line 381 "../src/worm.vala"
						_tmp15_ = *a;
#line 381 "../src/worm.vala"
						_tmp13_ = (*self).lo < _tmp15_.lo;
#line 2078 "worm.c"
					} else {
#line 381 "../src/worm.vala"
						_tmp13_ = FALSE;
#line 2082 "worm.c"
					}
#line 381 "../src/worm.vala"
					_tmp11_ = _tmp13_;
#line 2086 "worm.c"
				}
#line 381 "../src/worm.vala"
				result = _tmp11_;
#line 381 "../src/worm.vala"
				return result;
#line 2092 "worm.c"
			}
		}
	}
}

gboolean
int128_less_than_or_equal_to (int128 *self,
                              int128* a)
{
	int128 _tmp0_;
	gboolean result;
#line 385 "../src/worm.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 387 "../src/worm.vala"
	_tmp0_ = *a;
#line 387 "../src/worm.vala"
	result = !int128_greater_than (&(*self), &_tmp0_);
#line 387 "../src/worm.vala"
	return result;
#line 2112 "worm.c"
}

gboolean
int128_less_than (int128 *self,
                  int128* a)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 391 "../src/worm.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 393 "../src/worm.vala"
	if (!(*self).negative) {
#line 2125 "worm.c"
		int128 _tmp1_;
#line 393 "../src/worm.vala"
		_tmp1_ = *a;
#line 393 "../src/worm.vala"
		_tmp0_ = !_tmp1_.negative;
#line 2131 "worm.c"
	} else {
#line 393 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 2135 "worm.c"
	}
#line 393 "../src/worm.vala"
	if (_tmp0_) {
#line 2139 "worm.c"
		gboolean _tmp2_ = FALSE;
		int128 _tmp3_;
#line 394 "../src/worm.vala"
		_tmp3_ = *a;
#line 394 "../src/worm.vala"
		if ((*self).hi < _tmp3_.hi) {
#line 394 "../src/worm.vala"
			_tmp2_ = TRUE;
#line 2148 "worm.c"
		} else {
			gboolean _tmp4_ = FALSE;
			int128 _tmp5_;
#line 394 "../src/worm.vala"
			_tmp5_ = *a;
#line 394 "../src/worm.vala"
			if ((*self).hi == _tmp5_.hi) {
#line 2156 "worm.c"
				int128 _tmp6_;
#line 394 "../src/worm.vala"
				_tmp6_ = *a;
#line 394 "../src/worm.vala"
				_tmp4_ = (*self).lo < _tmp6_.lo;
#line 2162 "worm.c"
			} else {
#line 394 "../src/worm.vala"
				_tmp4_ = FALSE;
#line 2166 "worm.c"
			}
#line 394 "../src/worm.vala"
			_tmp2_ = _tmp4_;
#line 2170 "worm.c"
		}
#line 394 "../src/worm.vala"
		result = _tmp2_;
#line 394 "../src/worm.vala"
		return result;
#line 2176 "worm.c"
	} else {
		gboolean _tmp7_ = FALSE;
#line 395 "../src/worm.vala"
		if (!(*self).negative) {
#line 2181 "worm.c"
			int128 _tmp8_;
#line 395 "../src/worm.vala"
			_tmp8_ = *a;
#line 395 "../src/worm.vala"
			_tmp7_ = _tmp8_.negative;
#line 2187 "worm.c"
		} else {
#line 395 "../src/worm.vala"
			_tmp7_ = FALSE;
#line 2191 "worm.c"
		}
#line 395 "../src/worm.vala"
		if (_tmp7_) {
#line 396 "../src/worm.vala"
			result = FALSE;
#line 396 "../src/worm.vala"
			return result;
#line 2199 "worm.c"
		} else {
			gboolean _tmp9_ = FALSE;
#line 397 "../src/worm.vala"
			if ((*self).negative) {
#line 2204 "worm.c"
				int128 _tmp10_;
#line 397 "../src/worm.vala"
				_tmp10_ = *a;
#line 397 "../src/worm.vala"
				_tmp9_ = !_tmp10_.negative;
#line 2210 "worm.c"
			} else {
#line 397 "../src/worm.vala"
				_tmp9_ = FALSE;
#line 2214 "worm.c"
			}
#line 397 "../src/worm.vala"
			if (_tmp9_) {
#line 398 "../src/worm.vala"
				result = TRUE;
#line 398 "../src/worm.vala"
				return result;
#line 2222 "worm.c"
			} else {
				gboolean _tmp11_ = FALSE;
				int128 _tmp12_;
#line 400 "../src/worm.vala"
				_tmp12_ = *a;
#line 400 "../src/worm.vala"
				if ((*self).hi > _tmp12_.hi) {
#line 400 "../src/worm.vala"
					_tmp11_ = TRUE;
#line 2232 "worm.c"
				} else {
					gboolean _tmp13_ = FALSE;
					int128 _tmp14_;
#line 400 "../src/worm.vala"
					_tmp14_ = *a;
#line 400 "../src/worm.vala"
					if ((*self).hi == _tmp14_.hi) {
#line 2240 "worm.c"
						int128 _tmp15_;
#line 400 "../src/worm.vala"
						_tmp15_ = *a;
#line 400 "../src/worm.vala"
						_tmp13_ = (*self).lo > _tmp15_.lo;
#line 2246 "worm.c"
					} else {
#line 400 "../src/worm.vala"
						_tmp13_ = FALSE;
#line 2250 "worm.c"
					}
#line 400 "../src/worm.vala"
					_tmp11_ = _tmp13_;
#line 2254 "worm.c"
				}
#line 400 "../src/worm.vala"
				result = _tmp11_;
#line 400 "../src/worm.vala"
				return result;
#line 2260 "worm.c"
			}
		}
	}
}

gboolean
int128_equal_to (int128 *self,
                 int128* a)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	int128 _tmp2_;
	gboolean result;
#line 404 "../src/worm.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 406 "../src/worm.vala"
	_tmp2_ = *a;
#line 406 "../src/worm.vala"
	if ((*self).negative == _tmp2_.negative) {
#line 2280 "worm.c"
		int128 _tmp3_;
#line 406 "../src/worm.vala"
		_tmp3_ = *a;
#line 406 "../src/worm.vala"
		_tmp1_ = (*self).hi == _tmp3_.hi;
#line 2286 "worm.c"
	} else {
#line 406 "../src/worm.vala"
		_tmp1_ = FALSE;
#line 2290 "worm.c"
	}
#line 406 "../src/worm.vala"
	if (_tmp1_) {
#line 2294 "worm.c"
		int128 _tmp4_;
#line 406 "../src/worm.vala"
		_tmp4_ = *a;
#line 406 "../src/worm.vala"
		_tmp0_ = (*self).lo == _tmp4_.lo;
#line 2300 "worm.c"
	} else {
#line 406 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 2304 "worm.c"
	}
#line 406 "../src/worm.vala"
	result = _tmp0_;
#line 406 "../src/worm.vala"
	return result;
#line 2310 "worm.c"
}

void
int128_divide_by (int128 *self,
                  gint64 x,
                  int128* result)
{
	guint64 div = 0ULL;
	int128 s = {0};
	int128 _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	int128 d = {0};
	int128 _tmp4_ = {0};
	gboolean _tmp5_ = FALSE;
	int128 _tmp6_;
	int128 _tmp24_;
#line 415 "../src/worm.vala"
	div = (guint64) llabs (x);
#line 416 "../src/worm.vala"
	_tmp0_.hi = (*self).hi;
#line 416 "../src/worm.vala"
	_tmp0_.lo = (*self).lo;
#line 416 "../src/worm.vala"
	s = _tmp0_;
#line 417 "../src/worm.vala"
	if ((*self).negative) {
#line 417 "../src/worm.vala"
		_tmp2_ = x >= ((gint64) 0);
#line 2340 "worm.c"
	} else {
#line 417 "../src/worm.vala"
		_tmp2_ = FALSE;
#line 2344 "worm.c"
	}
#line 417 "../src/worm.vala"
	if (_tmp2_) {
#line 417 "../src/worm.vala"
		_tmp1_ = TRUE;
#line 2350 "worm.c"
	} else {
		gboolean _tmp3_ = FALSE;
#line 417 "../src/worm.vala"
		if (!(*self).negative) {
#line 417 "../src/worm.vala"
			_tmp3_ = x < ((gint64) 0);
#line 2357 "worm.c"
		} else {
#line 417 "../src/worm.vala"
			_tmp3_ = FALSE;
#line 2361 "worm.c"
		}
#line 417 "../src/worm.vala"
		_tmp1_ = _tmp3_;
#line 2365 "worm.c"
	}
#line 417 "../src/worm.vala"
	_tmp4_.hi = (guint64) 0;
#line 417 "../src/worm.vala"
	_tmp4_.lo = (guint64) 0;
#line 417 "../src/worm.vala"
	_tmp4_.negative = _tmp1_;
#line 417 "../src/worm.vala"
	d = _tmp4_;
#line 420 "../src/worm.vala"
	_tmp6_ = s;
#line 420 "../src/worm.vala"
	if (_tmp6_.hi == ((guint64) 0)) {
#line 2379 "worm.c"
		int128 _tmp7_;
#line 420 "../src/worm.vala"
		_tmp7_ = s;
#line 420 "../src/worm.vala"
		_tmp5_ = _tmp7_.lo == ((guint64) 0);
#line 2385 "worm.c"
	} else {
#line 420 "../src/worm.vala"
		_tmp5_ = FALSE;
#line 2389 "worm.c"
	}
#line 420 "../src/worm.vala"
	if (_tmp5_) {
#line 2393 "worm.c"
		int128 _tmp8_ = {0};
#line 422 "../src/worm.vala"
		_tmp8_.hi = (guint64) 0;
#line 422 "../src/worm.vala"
		_tmp8_.lo = (guint64) 0;
#line 422 "../src/worm.vala"
		_tmp8_.negative = FALSE;
#line 422 "../src/worm.vala"
		d = _tmp8_;
#line 423 "../src/worm.vala"
		*result = d;
#line 423 "../src/worm.vala"
		return;
#line 2407 "worm.c"
	} else {
#line 425 "../src/worm.vala"
		if (div == ((guint64) 0)) {
#line 427 "../src/worm.vala"
			d.hi = (guint64) 0xffffffffffffffffLL;
#line 428 "../src/worm.vala"
			d.lo = (guint64) 0xffffffffffffffffLL;
#line 429 "../src/worm.vala"
			*result = d;
#line 429 "../src/worm.vala"
			return;
#line 2419 "worm.c"
		}
	}
	{
		gboolean _tmp9_ = FALSE;
#line 433 "../src/worm.vala"
		_tmp9_ = TRUE;
#line 433 "../src/worm.vala"
		while (TRUE) {
#line 2428 "worm.c"
			gboolean _tmp10_ = FALSE;
			int128 _tmp11_;
#line 433 "../src/worm.vala"
			if (!_tmp9_) {
#line 433 "../src/worm.vala"
				int128_right_shift_assign (&s, 1);
#line 433 "../src/worm.vala"
				div >>= (guint64) 1;
#line 2437 "worm.c"
			}
#line 433 "../src/worm.vala"
			_tmp9_ = FALSE;
#line 433 "../src/worm.vala"
			_tmp11_ = s;
#line 433 "../src/worm.vala"
			if ((_tmp11_.lo & 1) == ((guint64) 0)) {
#line 433 "../src/worm.vala"
				_tmp10_ = (div & 1) == ((guint64) 0);
#line 2447 "worm.c"
			} else {
#line 433 "../src/worm.vala"
				_tmp10_ = FALSE;
#line 2451 "worm.c"
			}
#line 433 "../src/worm.vala"
			if (!_tmp10_) {
#line 433 "../src/worm.vala"
				break;
#line 2457 "worm.c"
			}
		}
	}
#line 435 "../src/worm.vala"
	if (div == ((guint64) 1)) {
#line 2463 "worm.c"
		int128 _tmp12_;
#line 437 "../src/worm.vala"
		_tmp12_ = d;
#line 437 "../src/worm.vala"
		s.negative = _tmp12_.negative;
#line 438 "../src/worm.vala"
		*result = s;
#line 438 "../src/worm.vala"
		return;
#line 2473 "worm.c"
	}
	{
		gboolean _tmp13_ = FALSE;
#line 441 "../src/worm.vala"
		_tmp13_ = TRUE;
#line 441 "../src/worm.vala"
		while (TRUE) {
#line 2481 "worm.c"
			int128 _tmp14_;
			gint shift = 0;
			int128 a = {0};
			int128 _tmp15_;
			int128 _tmp16_;
			int128 _tmp17_ = {0};
			int128 _tmp18_;
			int128 _tmp22_ = {0};
			int128 _tmp23_;
#line 441 "../src/worm.vala"
			if (!_tmp13_) {
#line 2493 "worm.c"
			}
#line 441 "../src/worm.vala"
			_tmp13_ = FALSE;
#line 441 "../src/worm.vala"
			_tmp14_ = s;
#line 441 "../src/worm.vala"
			if (!(_tmp14_.hi > ((guint64) 0))) {
#line 441 "../src/worm.vala"
				break;
#line 2503 "worm.c"
			}
#line 443 "../src/worm.vala"
			shift = 0;
#line 444 "../src/worm.vala"
			_tmp15_ = s;
#line 444 "../src/worm.vala"
			_tmp16_ = s;
#line 444 "../src/worm.vala"
			_tmp17_.hi = _tmp15_.hi;
#line 444 "../src/worm.vala"
			_tmp17_.lo = _tmp16_.lo;
#line 444 "../src/worm.vala"
			a = _tmp17_;
#line 445 "../src/worm.vala"
			_tmp18_ = a;
#line 445 "../src/worm.vala"
			if (_tmp18_.hi < div) {
#line 2521 "worm.c"
				{
					gboolean _tmp19_ = FALSE;
#line 446 "../src/worm.vala"
					_tmp19_ = TRUE;
#line 446 "../src/worm.vala"
					while (TRUE) {
#line 2528 "worm.c"
						int128 _tmp21_;
#line 446 "../src/worm.vala"
						if (!_tmp19_) {
#line 2532 "worm.c"
							gint _tmp20_;
#line 446 "../src/worm.vala"
							int128_right_shift_assign (&a, 1);
#line 446 "../src/worm.vala"
							shift = shift + 1;
#line 446 "../src/worm.vala"
							_tmp20_ = shift;
#line 2540 "worm.c"
						}
#line 446 "../src/worm.vala"
						_tmp19_ = FALSE;
#line 446 "../src/worm.vala"
						_tmp21_ = a;
#line 446 "../src/worm.vala"
						if (!(_tmp21_.hi > ((guint64) 0))) {
#line 446 "../src/worm.vala"
							break;
#line 2550 "worm.c"
						}
					}
				}
			}
#line 448 "../src/worm.vala"
			a.hi = a.hi / div;
#line 449 "../src/worm.vala"
			a.lo = a.lo / div;
#line 450 "../src/worm.vala"
			int128_left_shift_assign (&a, shift);
#line 452 "../src/worm.vala"
			int128_multiply (&a, div, &_tmp22_);
#line 452 "../src/worm.vala"
			int128_minus (&s, &_tmp22_);
#line 454 "../src/worm.vala"
			_tmp23_ = a;
#line 454 "../src/worm.vala"
			int128_add_assign (&d, &_tmp23_);
#line 2569 "worm.c"
		}
	}
#line 456 "../src/worm.vala"
	_tmp24_ = s;
#line 456 "../src/worm.vala"
	if (_tmp24_.lo >= div) {
#line 2576 "worm.c"
		int128 a = {0};
		int128 _tmp25_;
		int128 _tmp26_ = {0};
		int128 _tmp27_;
		int128 _tmp28_;
#line 458 "../src/worm.vala"
		_tmp25_ = s;
#line 458 "../src/worm.vala"
		_tmp26_.hi = (guint64) 0;
#line 458 "../src/worm.vala"
		_tmp26_.lo = _tmp25_.lo / div;
#line 458 "../src/worm.vala"
		a = _tmp26_;
#line 459 "../src/worm.vala"
		_tmp27_ = a;
#line 459 "../src/worm.vala"
		int128_add_assign (&d, &_tmp27_);
#line 460 "../src/worm.vala"
		_tmp28_ = s;
#line 460 "../src/worm.vala"
		d.remainder = _tmp28_.lo % div;
#line 2598 "worm.c"
	} else {
		int128 _tmp29_;
#line 463 "../src/worm.vala"
		_tmp29_ = s;
#line 463 "../src/worm.vala"
		d.remainder = _tmp29_.lo;
#line 2605 "worm.c"
	}
#line 464 "../src/worm.vala"
	*result = d;
#line 464 "../src/worm.vala"
	return;
#line 2611 "worm.c"
}

static gboolean
int128_is_valid_int64 (int128 *self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 470 "../src/worm.vala"
	if ((*self).hi == ((guint64) 0)) {
#line 2621 "worm.c"
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
#line 471 "../src/worm.vala"
		if (!(*self).negative) {
#line 471 "../src/worm.vala"
			_tmp2_ = ((*self).lo & 0x8000000000000000LL) == ((guint64) 0);
#line 2628 "worm.c"
		} else {
#line 471 "../src/worm.vala"
			_tmp2_ = FALSE;
#line 2632 "worm.c"
		}
#line 471 "../src/worm.vala"
		if (_tmp2_) {
#line 471 "../src/worm.vala"
			_tmp1_ = TRUE;
#line 2638 "worm.c"
		} else {
			gboolean _tmp3_ = FALSE;
#line 472 "../src/worm.vala"
			if ((*self).negative) {
#line 472 "../src/worm.vala"
				_tmp3_ = (*self).lo <= ((guint64) 0x8000000000000000LL);
#line 2645 "worm.c"
			} else {
#line 472 "../src/worm.vala"
				_tmp3_ = FALSE;
#line 2649 "worm.c"
			}
#line 472 "../src/worm.vala"
			_tmp1_ = _tmp3_;
#line 2653 "worm.c"
		}
#line 471 "../src/worm.vala"
		_tmp0_ = _tmp1_;
#line 2657 "worm.c"
	} else {
#line 470 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 2661 "worm.c"
	}
#line 470 "../src/worm.vala"
	result = _tmp0_;
#line 470 "../src/worm.vala"
	return result;
#line 2667 "worm.c"
}

gint64
int128_get_int64 (int128 *self)
{
	gint64 _tmp0_ = 0LL;
	gint64 result;
#line 478 "../src/worm.vala"
	_vala_assert (int128_is_valid_int64 (&(*self)), "is_valid_int64 ()");
#line 479 "../src/worm.vala"
	if ((*self).negative) {
#line 479 "../src/worm.vala"
		_tmp0_ = (gint64) (-(*self).lo);
#line 2681 "worm.c"
	} else {
#line 479 "../src/worm.vala"
		_tmp0_ = (gint64) (*self).lo;
#line 2685 "worm.c"
	}
#line 479 "../src/worm.vala"
	result = _tmp0_;
#line 479 "../src/worm.vala"
	return result;
#line 2691 "worm.c"
}

static void
int128_multiply (int128 *self,
                 guint64 _a,
                 int128* result)
{
	int128 a = {0};
	int128 _tmp0_ = {0};
	int128 r = {0};
	int128 _tmp1_ = {0};
#line 485 "../src/worm.vala"
	_tmp0_.hi = (guint64) 0;
#line 485 "../src/worm.vala"
	_tmp0_.lo = _a;
#line 485 "../src/worm.vala"
	_tmp0_.negative = FALSE;
#line 485 "../src/worm.vala"
	a = _tmp0_;
#line 486 "../src/worm.vala"
	_tmp1_.hi = (guint64) 0;
#line 486 "../src/worm.vala"
	_tmp1_.lo = (guint64) 0;
#line 486 "../src/worm.vala"
	_tmp1_.negative = FALSE;
#line 486 "../src/worm.vala"
	r = _tmp1_;
#line 2719 "worm.c"
	{
		gint shift = 0;
#line 487 "../src/worm.vala"
		shift = 0;
#line 2724 "worm.c"
		{
			gboolean _tmp2_ = FALSE;
#line 487 "../src/worm.vala"
			_tmp2_ = TRUE;
#line 487 "../src/worm.vala"
			while (TRUE) {
#line 2731 "worm.c"
				gboolean _tmp4_ = FALSE;
				int128 _tmp5_;
				int128 _tmp7_;
#line 487 "../src/worm.vala"
				if (!_tmp2_) {
#line 2737 "worm.c"
					gint _tmp3_;
#line 487 "../src/worm.vala"
					int128_right_shift_assign (&a, 1);
#line 487 "../src/worm.vala"
					_tmp3_ = shift;
#line 487 "../src/worm.vala"
					shift = _tmp3_ + 1;
#line 2745 "worm.c"
				}
#line 487 "../src/worm.vala"
				_tmp2_ = FALSE;
#line 487 "../src/worm.vala"
				_tmp5_ = a;
#line 487 "../src/worm.vala"
				if (_tmp5_.hi > ((guint64) 0)) {
#line 487 "../src/worm.vala"
					_tmp4_ = TRUE;
#line 2755 "worm.c"
				} else {
					int128 _tmp6_;
#line 487 "../src/worm.vala"
					_tmp6_ = a;
#line 487 "../src/worm.vala"
					_tmp4_ = _tmp6_.lo > ((guint64) 0);
#line 2762 "worm.c"
				}
#line 487 "../src/worm.vala"
				if (!_tmp4_) {
#line 487 "../src/worm.vala"
					break;
#line 2768 "worm.c"
				}
#line 489 "../src/worm.vala"
				_tmp7_ = a;
#line 489 "../src/worm.vala"
				if ((_tmp7_.lo & 1) > ((guint64) 0)) {
#line 2774 "worm.c"
					int128 _tmp8_ = {0};
#line 490 "../src/worm.vala"
					int128_left_shift (&(*self), shift, &_tmp8_);
#line 490 "../src/worm.vala"
					int128_add_assign (&r, &_tmp8_);
#line 2780 "worm.c"
				}
			}
		}
	}
#line 492 "../src/worm.vala"
	*result = r;
#line 492 "../src/worm.vala"
	return;
#line 2789 "worm.c"
}

static void
int128_minus (int128 *self,
              int128* a)
{
	int128 _tmp0_;
	int128 _tmp1_;
	int128 _tmp3_;
#line 496 "../src/worm.vala"
	g_return_if_fail (a != NULL);
#line 499 "../src/worm.vala"
	_tmp0_ = *a;
#line 499 "../src/worm.vala"
	(*self).hi = (*self).hi - _tmp0_.hi;
#line 500 "../src/worm.vala"
	_tmp1_ = *a;
#line 500 "../src/worm.vala"
	if ((*self).lo < _tmp1_.lo) {
#line 2809 "worm.c"
		guint64 _tmp2_;
#line 501 "../src/worm.vala"
		(*self).hi = (*self).hi - 1;
#line 501 "../src/worm.vala"
		_tmp2_ = (*self).hi;
#line 2815 "worm.c"
	}
#line 502 "../src/worm.vala"
	_tmp3_ = *a;
#line 502 "../src/worm.vala"
	(*self).lo = (*self).lo - _tmp3_.lo;
#line 2821 "worm.c"
}

int128*
int128_dup (const int128* self)
{
	int128* dup;
#line 309 "../src/worm.vala"
	dup = g_new0 (int128, 1);
#line 309 "../src/worm.vala"
	memcpy (dup, self, sizeof (int128));
#line 309 "../src/worm.vala"
	return dup;
#line 2834 "worm.c"
}

void
int128_free (int128* self)
{
#line 309 "../src/worm.vala"
	g_free (self);
#line 2842 "worm.c"
}

 G_GNUC_NO_INLINE static GType
int128_get_type_once (void)
{
	GType int128_type_id;
	int128_type_id = g_boxed_type_register_static ("int128", (GBoxedCopyFunc) int128_dup, (GBoxedFreeFunc) int128_free);
	return int128_type_id;
}

GType
int128_get_type (void)
{
	static gsize int128_type_id__once = 0;
	if (g_once_init_enter (&int128_type_id__once)) {
		GType int128_type_id;
		int128_type_id = int128_get_type_once ();
		g_once_init_leave (&int128_type_id__once, int128_type_id);
	}
	return int128_type_id__once;
}

void
multiply (gint64 _a,
          gint64 _b,
          int128* result)
{
	gint64 _tmp0_ = 0LL;
	int128 a = {0};
	int128 _tmp1_ = {0};
	gint64 _tmp2_ = 0LL;
	int128 b = {0};
	int128 _tmp3_ = {0};
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	int128 r = {0};
	int128 _tmp7_ = {0};
#line 509 "../src/worm.vala"
	if (llabs (_a) < llabs (_b)) {
#line 509 "../src/worm.vala"
		_tmp0_ = llabs (_b);
#line 2884 "worm.c"
	} else {
#line 509 "../src/worm.vala"
		_tmp0_ = llabs (_a);
#line 2888 "worm.c"
	}
#line 509 "../src/worm.vala"
	_tmp1_.hi = (guint64) 0;
#line 509 "../src/worm.vala"
	_tmp1_.lo = (guint64) _tmp0_;
#line 509 "../src/worm.vala"
	a = _tmp1_;
#line 510 "../src/worm.vala"
	if (llabs (_a) >= llabs (_b)) {
#line 510 "../src/worm.vala"
		_tmp2_ = llabs (_b);
#line 2900 "worm.c"
	} else {
#line 510 "../src/worm.vala"
		_tmp2_ = llabs (_a);
#line 2904 "worm.c"
	}
#line 510 "../src/worm.vala"
	_tmp3_.hi = (guint64) 0;
#line 510 "../src/worm.vala"
	_tmp3_.lo = (guint64) _tmp2_;
#line 510 "../src/worm.vala"
	b = _tmp3_;
#line 511 "../src/worm.vala"
	if (_a < ((gint64) 0)) {
#line 511 "../src/worm.vala"
		_tmp5_ = _b >= ((gint64) 0);
#line 2916 "worm.c"
	} else {
#line 511 "../src/worm.vala"
		_tmp5_ = FALSE;
#line 2920 "worm.c"
	}
#line 511 "../src/worm.vala"
	if (_tmp5_) {
#line 511 "../src/worm.vala"
		_tmp4_ = TRUE;
#line 2926 "worm.c"
	} else {
		gboolean _tmp6_ = FALSE;
#line 511 "../src/worm.vala"
		if (_a >= ((gint64) 0)) {
#line 511 "../src/worm.vala"
			_tmp6_ = _b < ((gint64) 0);
#line 2933 "worm.c"
		} else {
#line 511 "../src/worm.vala"
			_tmp6_ = FALSE;
#line 2937 "worm.c"
		}
#line 511 "../src/worm.vala"
		_tmp4_ = _tmp6_;
#line 2941 "worm.c"
	}
#line 511 "../src/worm.vala"
	_tmp7_.hi = (guint64) 0;
#line 511 "../src/worm.vala"
	_tmp7_.lo = (guint64) 0;
#line 511 "../src/worm.vala"
	_tmp7_.negative = _tmp4_;
#line 511 "../src/worm.vala"
	r = _tmp7_;
#line 2951 "worm.c"
	{
		gint shift = 0;
#line 512 "../src/worm.vala"
		shift = 0;
#line 2956 "worm.c"
		{
			gboolean _tmp8_ = FALSE;
#line 512 "../src/worm.vala"
			_tmp8_ = TRUE;
#line 512 "../src/worm.vala"
			while (TRUE) {
#line 2963 "worm.c"
				gboolean _tmp10_ = FALSE;
				int128 _tmp11_;
				int128 _tmp13_;
#line 512 "../src/worm.vala"
				if (!_tmp8_) {
#line 2969 "worm.c"
					gint _tmp9_;
#line 512 "../src/worm.vala"
					int128_right_shift_assign (&b, 1);
#line 512 "../src/worm.vala"
					_tmp9_ = shift;
#line 512 "../src/worm.vala"
					shift = _tmp9_ + 1;
#line 2977 "worm.c"
				}
#line 512 "../src/worm.vala"
				_tmp8_ = FALSE;
#line 512 "../src/worm.vala"
				_tmp11_ = b;
#line 512 "../src/worm.vala"
				if (_tmp11_.hi > ((guint64) 0)) {
#line 512 "../src/worm.vala"
					_tmp10_ = TRUE;
#line 2987 "worm.c"
				} else {
					int128 _tmp12_;
#line 512 "../src/worm.vala"
					_tmp12_ = b;
#line 512 "../src/worm.vala"
					_tmp10_ = _tmp12_.lo > ((guint64) 0);
#line 2994 "worm.c"
				}
#line 512 "../src/worm.vala"
				if (!_tmp10_) {
#line 512 "../src/worm.vala"
					break;
#line 3000 "worm.c"
				}
#line 514 "../src/worm.vala"
				_tmp13_ = b;
#line 514 "../src/worm.vala"
				if ((_tmp13_.lo & 1) > ((guint64) 0)) {
#line 3006 "worm.c"
					int128 _tmp14_ = {0};
#line 515 "../src/worm.vala"
					int128_left_shift (&a, shift, &_tmp14_);
#line 515 "../src/worm.vala"
					int128_add_assign (&r, &_tmp14_);
#line 3012 "worm.c"
				}
			}
		}
	}
#line 517 "../src/worm.vala"
	*result = r;
#line 517 "../src/worm.vala"
	return;
#line 3021 "worm.c"
}

void
multiply_by_2n (gint64 a,
                gint n,
                int128* result)
{
	int128 r = {0};
	int128 _tmp0_ = {0};
#line 523 "../src/worm.vala"
	_tmp0_.hi = (guint64) 0;
#line 523 "../src/worm.vala"
	_tmp0_.lo = (guint64) llabs (a);
#line 523 "../src/worm.vala"
	_tmp0_.negative = a < ((gint64) 0);
#line 523 "../src/worm.vala"
	r = _tmp0_;
#line 524 "../src/worm.vala"
	int128_left_shift_assign (&r, n);
#line 525 "../src/worm.vala"
	*result = r;
#line 525 "../src/worm.vala"
	return;
#line 3045 "worm.c"
}

static inline gpointer
angle_iterator_get_instance_private (AngleIterator* self)
{
	return G_STRUCT_MEMBER_P (self, AngleIterator_private_offset);
}

AngleIterator*
angle_iterator_construct (GType object_type,
                          Angle* p)
{
	AngleIterator* self = NULL;
	Angle _tmp0_;
#line 536 "../src/worm.vala"
	g_return_val_if_fail (p != NULL, NULL);
#line 536 "../src/worm.vala"
	self = (AngleIterator*) g_type_create_instance (object_type);
#line 538 "../src/worm.vala"
	_tmp0_ = *p;
#line 538 "../src/worm.vala"
	self->priv->pAngle = _tmp0_;
#line 539 "../src/worm.vala"
	self->priv->index = (guint64) 0;
#line 536 "../src/worm.vala"
	return self;
#line 3072 "worm.c"
}

AngleIterator*
angle_iterator_new (Angle* p)
{
#line 536 "../src/worm.vala"
	return angle_iterator_construct (TYPE_ANGLE_ITERATOR, p);
#line 3080 "worm.c"
}

gboolean
angle_iterator_next (AngleIterator* self)
{
	guint64 _tmp0_;
	gboolean result;
#line 542 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 544 "../src/worm.vala"
	self->priv->index = self->priv->index + 1;
#line 544 "../src/worm.vala"
	_tmp0_ = self->priv->index;
#line 545 "../src/worm.vala"
	result = TRUE;
#line 545 "../src/worm.vala"
	return result;
#line 3098 "worm.c"
}

void
angle_iterator_get (AngleIterator* self,
                    SignedPosition* result)
{
	SignedPosition _tmp0_ = {0};
#line 548 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 550 "../src/worm.vala"
	angle_get (&self->priv->pAngle, self->priv->index, &_tmp0_);
#line 550 "../src/worm.vala"
	*result = _tmp0_;
#line 550 "../src/worm.vala"
	return;
#line 3114 "worm.c"
}

static void
value_angle_iterator_init (GValue* value)
{
#line 529 "../src/worm.vala"
	value->data[0].v_pointer = NULL;
#line 3122 "worm.c"
}

static void
value_angle_iterator_free_value (GValue* value)
{
#line 529 "../src/worm.vala"
	if (value->data[0].v_pointer) {
#line 529 "../src/worm.vala"
		angle_iterator_unref (value->data[0].v_pointer);
#line 3132 "worm.c"
	}
}

static void
value_angle_iterator_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 529 "../src/worm.vala"
	if (src_value->data[0].v_pointer) {
#line 529 "../src/worm.vala"
		dest_value->data[0].v_pointer = angle_iterator_ref (src_value->data[0].v_pointer);
#line 3144 "worm.c"
	} else {
#line 529 "../src/worm.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3148 "worm.c"
	}
}

static gpointer
value_angle_iterator_peek_pointer (const GValue* value)
{
#line 529 "../src/worm.vala"
	return value->data[0].v_pointer;
#line 3157 "worm.c"
}

static gchar*
value_angle_iterator_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 529 "../src/worm.vala"
	if (collect_values[0].v_pointer) {
#line 3168 "worm.c"
		AngleIterator * object;
		object = collect_values[0].v_pointer;
#line 529 "../src/worm.vala"
		if (object->parent_instance.g_class == NULL) {
#line 529 "../src/worm.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3175 "worm.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 529 "../src/worm.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3179 "worm.c"
		}
#line 529 "../src/worm.vala"
		value->data[0].v_pointer = angle_iterator_ref (object);
#line 3183 "worm.c"
	} else {
#line 529 "../src/worm.vala"
		value->data[0].v_pointer = NULL;
#line 3187 "worm.c"
	}
#line 529 "../src/worm.vala"
	return NULL;
#line 3191 "worm.c"
}

static gchar*
value_angle_iterator_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	AngleIterator ** object_p;
	object_p = collect_values[0].v_pointer;
#line 529 "../src/worm.vala"
	if (!object_p) {
#line 529 "../src/worm.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3206 "worm.c"
	}
#line 529 "../src/worm.vala"
	if (!value->data[0].v_pointer) {
#line 529 "../src/worm.vala"
		*object_p = NULL;
#line 3212 "worm.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 529 "../src/worm.vala"
		*object_p = value->data[0].v_pointer;
#line 3216 "worm.c"
	} else {
#line 529 "../src/worm.vala"
		*object_p = angle_iterator_ref (value->data[0].v_pointer);
#line 3220 "worm.c"
	}
#line 529 "../src/worm.vala"
	return NULL;
#line 3224 "worm.c"
}

GParamSpec*
param_spec_angle_iterator (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecAngleIterator* spec;
#line 529 "../src/worm.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ANGLE_ITERATOR), NULL);
#line 529 "../src/worm.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 529 "../src/worm.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 529 "../src/worm.vala"
	return G_PARAM_SPEC (spec);
#line 3243 "worm.c"
}

gpointer
value_get_angle_iterator (const GValue* value)
{
#line 529 "../src/worm.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ANGLE_ITERATOR), NULL);
#line 529 "../src/worm.vala"
	return value->data[0].v_pointer;
#line 3253 "worm.c"
}

void
value_set_angle_iterator (GValue* value,
                          gpointer v_object)
{
	AngleIterator * old;
#line 529 "../src/worm.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ANGLE_ITERATOR));
#line 529 "../src/worm.vala"
	old = value->data[0].v_pointer;
#line 529 "../src/worm.vala"
	if (v_object) {
#line 529 "../src/worm.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ANGLE_ITERATOR));
#line 529 "../src/worm.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 529 "../src/worm.vala"
		value->data[0].v_pointer = v_object;
#line 529 "../src/worm.vala"
		angle_iterator_ref (value->data[0].v_pointer);
#line 3275 "worm.c"
	} else {
#line 529 "../src/worm.vala"
		value->data[0].v_pointer = NULL;
#line 3279 "worm.c"
	}
#line 529 "../src/worm.vala"
	if (old) {
#line 529 "../src/worm.vala"
		angle_iterator_unref (old);
#line 3285 "worm.c"
	}
}

void
value_take_angle_iterator (GValue* value,
                           gpointer v_object)
{
	AngleIterator * old;
#line 529 "../src/worm.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ANGLE_ITERATOR));
#line 529 "../src/worm.vala"
	old = value->data[0].v_pointer;
#line 529 "../src/worm.vala"
	if (v_object) {
#line 529 "../src/worm.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ANGLE_ITERATOR));
#line 529 "../src/worm.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 529 "../src/worm.vala"
		value->data[0].v_pointer = v_object;
#line 3306 "worm.c"
	} else {
#line 529 "../src/worm.vala"
		value->data[0].v_pointer = NULL;
#line 3310 "worm.c"
	}
#line 529 "../src/worm.vala"
	if (old) {
#line 529 "../src/worm.vala"
		angle_iterator_unref (old);
#line 3316 "worm.c"
	}
}

static void
angle_iterator_class_init (AngleIteratorClass * klass,
                           gpointer klass_data)
{
#line 529 "../src/worm.vala"
	angle_iterator_parent_class = g_type_class_peek_parent (klass);
#line 529 "../src/worm.vala"
	((AngleIteratorClass *) klass)->finalize = angle_iterator_finalize;
#line 529 "../src/worm.vala"
	g_type_class_adjust_private_offset (klass, &AngleIterator_private_offset);
#line 3330 "worm.c"
}

static void
angle_iterator_instance_init (AngleIterator * self,
                              gpointer klass)
{
#line 529 "../src/worm.vala"
	self->priv = angle_iterator_get_instance_private (self);
#line 529 "../src/worm.vala"
	self->ref_count = 1;
#line 3341 "worm.c"
}

static void
angle_iterator_finalize (AngleIterator * obj)
{
	AngleIterator * self;
#line 529 "../src/worm.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ANGLE_ITERATOR, AngleIterator);
#line 529 "../src/worm.vala"
	g_signal_handlers_destroy (self);
#line 3352 "worm.c"
}

 G_GNUC_NO_INLINE static GType
angle_iterator_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_angle_iterator_init, value_angle_iterator_free_value, value_angle_iterator_copy_value, value_angle_iterator_peek_pointer, "p", value_angle_iterator_collect_value, "p", value_angle_iterator_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (AngleIteratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) angle_iterator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AngleIterator), 0, (GInstanceInitFunc) angle_iterator_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType angle_iterator_type_id;
	angle_iterator_type_id = g_type_register_fundamental (g_type_fundamental_next (), "AngleIterator", &g_define_type_info, &g_define_type_fundamental_info, 0);
	AngleIterator_private_offset = g_type_add_instance_private (angle_iterator_type_id, sizeof (AngleIteratorPrivate));
	return angle_iterator_type_id;
}

GType
angle_iterator_get_type (void)
{
	static gsize angle_iterator_type_id__once = 0;
	if (g_once_init_enter (&angle_iterator_type_id__once)) {
		GType angle_iterator_type_id;
		angle_iterator_type_id = angle_iterator_get_type_once ();
		g_once_init_leave (&angle_iterator_type_id__once, angle_iterator_type_id);
	}
	return angle_iterator_type_id__once;
}

gpointer
angle_iterator_ref (gpointer instance)
{
	AngleIterator * self;
	self = instance;
#line 529 "../src/worm.vala"
	g_atomic_int_inc (&self->ref_count);
#line 529 "../src/worm.vala"
	return instance;
#line 3388 "worm.c"
}

void
angle_iterator_unref (gpointer instance)
{
	AngleIterator * self;
	self = instance;
#line 529 "../src/worm.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 529 "../src/worm.vala"
		ANGLE_ITERATOR_GET_CLASS (self)->finalize (self);
#line 529 "../src/worm.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3402 "worm.c"
	}
}

 G_GNUC_NO_INLINE static GType
quarter_get_type_once (void)
{
	static const GEnumValue values[] = {{QUARTER_Q0, "QUARTER_Q0", "q0"}, {QUARTER_Q1, "QUARTER_Q1", "q1"}, {QUARTER_Q2, "QUARTER_Q2", "q2"}, {QUARTER_Q3, "QUARTER_Q3", "q3"}, {0, NULL, NULL}};
	GType quarter_type_id;
	quarter_type_id = g_enum_register_static ("Quarter", values);
	return quarter_type_id;
}

GType
quarter_get_type (void)
{
	static gsize quarter_type_id__once = 0;
	if (g_once_init_enter (&quarter_type_id__once)) {
		GType quarter_type_id;
		quarter_type_id = quarter_get_type_once ();
		g_once_init_leave (&quarter_type_id__once, quarter_type_id);
	}
	return quarter_type_id__once;
}

void
angle_assign (Angle *self,
              Angle* o)
{
	Angle _tmp0_;
	Angle _tmp1_;
	Angle _tmp2_;
	Angle _tmp3_;
	Angle _tmp4_;
	Angle _tmp5_;
#line 584 "../src/worm.vala"
	g_return_if_fail (o != NULL);
#line 586 "../src/worm.vala"
	_tmp0_ = *o;
#line 586 "../src/worm.vala"
	(*self).x = _tmp0_.x;
#line 587 "../src/worm.vala"
	_tmp1_ = *o;
#line 587 "../src/worm.vala"
	(*self).y = _tmp1_.y;
#line 588 "../src/worm.vala"
	_tmp2_ = *o;
#line 588 "../src/worm.vala"
	(*self).origin_x = _tmp2_.origin_x;
#line 589 "../src/worm.vala"
	_tmp3_ = *o;
#line 589 "../src/worm.vala"
	(*self).origin_y = _tmp3_.origin_y;
#line 590 "../src/worm.vala"
	_tmp4_ = *o;
#line 590 "../src/worm.vala"
	(*self).x_max = _tmp4_.x_max;
#line 591 "../src/worm.vala"
	_tmp5_ = *o;
#line 591 "../src/worm.vala"
	(*self).y_max = _tmp5_.y_max;
#line 3463 "worm.c"
}

gboolean
angle_less_than_or_equal_to (Angle *self,
                             Angle* o)
{
	Angle _tmp0_;
	gboolean result;
#line 595 "../src/worm.vala"
	g_return_val_if_fail (o != NULL, FALSE);
#line 597 "../src/worm.vala"
	_tmp0_ = *o;
#line 597 "../src/worm.vala"
	result = !angle_greater_than (&(*self), &_tmp0_);
#line 597 "../src/worm.vala"
	return result;
#line 3480 "worm.c"
}

gboolean
angle_greater_than (Angle *self,
                    Angle* o)
{
	Quarter q = 0;
	gboolean result;
#line 601 "../src/worm.vala"
	g_return_val_if_fail (o != NULL, FALSE);
#line 603 "../src/worm.vala"
	q = angle_get_quarter (o);
#line 604 "../src/worm.vala"
	switch (angle_get_quarter (&(*self))) {
#line 604 "../src/worm.vala"
		case QUARTER_Q0:
#line 3497 "worm.c"
		{
#line 607 "../src/worm.vala"
			if (q == QUARTER_Q3) {
#line 608 "../src/worm.vala"
				result = TRUE;
#line 608 "../src/worm.vala"
				return result;
#line 3505 "worm.c"
			} else {
#line 609 "../src/worm.vala"
				if (q == QUARTER_Q1) {
#line 610 "../src/worm.vala"
					result = FALSE;
#line 610 "../src/worm.vala"
					return result;
#line 3513 "worm.c"
				} else {
					Angle _tmp0_;
					int128 _tmp1_ = {0};
					Angle _tmp2_;
					int128 _tmp3_ = {0};
#line 612 "../src/worm.vala"
					_tmp0_ = *o;
#line 612 "../src/worm.vala"
					multiply ((*self).x, _tmp0_.y, &_tmp1_);
#line 612 "../src/worm.vala"
					_tmp2_ = *o;
#line 612 "../src/worm.vala"
					multiply (_tmp2_.x, (*self).y, &_tmp3_);
#line 612 "../src/worm.vala"
					result = int128_less_than (&_tmp1_, &_tmp3_);
#line 612 "../src/worm.vala"
					return result;
#line 3531 "worm.c"
				}
			}
		}
#line 604 "../src/worm.vala"
		case QUARTER_Q1:
#line 3537 "worm.c"
		{
#line 614 "../src/worm.vala"
			if (q == QUARTER_Q0) {
#line 615 "../src/worm.vala"
				result = TRUE;
#line 615 "../src/worm.vala"
				return result;
#line 3545 "worm.c"
			} else {
#line 616 "../src/worm.vala"
				if (q == QUARTER_Q2) {
#line 617 "../src/worm.vala"
					result = FALSE;
#line 617 "../src/worm.vala"
					return result;
#line 3553 "worm.c"
				} else {
					Angle _tmp4_;
					int128 _tmp5_ = {0};
					Angle _tmp6_;
					int128 _tmp7_ = {0};
#line 619 "../src/worm.vala"
					_tmp4_ = *o;
#line 619 "../src/worm.vala"
					multiply ((*self).x, _tmp4_.y, &_tmp5_);
#line 619 "../src/worm.vala"
					_tmp6_ = *o;
#line 619 "../src/worm.vala"
					multiply (_tmp6_.x, (*self).y, &_tmp7_);
#line 619 "../src/worm.vala"
					result = int128_less_than (&_tmp5_, &_tmp7_);
#line 619 "../src/worm.vala"
					return result;
#line 3571 "worm.c"
				}
			}
		}
#line 604 "../src/worm.vala"
		case QUARTER_Q2:
#line 3577 "worm.c"
		{
#line 621 "../src/worm.vala"
			if (q == QUARTER_Q1) {
#line 622 "../src/worm.vala"
				result = TRUE;
#line 622 "../src/worm.vala"
				return result;
#line 3585 "worm.c"
			} else {
#line 623 "../src/worm.vala"
				if (q == QUARTER_Q3) {
#line 624 "../src/worm.vala"
					result = FALSE;
#line 624 "../src/worm.vala"
					return result;
#line 3593 "worm.c"
				} else {
					Angle _tmp8_;
					int128 _tmp9_ = {0};
					Angle _tmp10_;
					int128 _tmp11_ = {0};
#line 626 "../src/worm.vala"
					_tmp8_ = *o;
#line 626 "../src/worm.vala"
					multiply ((*self).x, _tmp8_.y, &_tmp9_);
#line 626 "../src/worm.vala"
					_tmp10_ = *o;
#line 626 "../src/worm.vala"
					multiply (_tmp10_.x, (*self).y, &_tmp11_);
#line 626 "../src/worm.vala"
					result = int128_less_than (&_tmp9_, &_tmp11_);
#line 626 "../src/worm.vala"
					return result;
#line 3611 "worm.c"
				}
			}
		}
#line 604 "../src/worm.vala"
		case QUARTER_Q3:
#line 3617 "worm.c"
		{
#line 628 "../src/worm.vala"
			if (q == QUARTER_Q2) {
#line 629 "../src/worm.vala"
				result = TRUE;
#line 629 "../src/worm.vala"
				return result;
#line 3625 "worm.c"
			} else {
#line 630 "../src/worm.vala"
				if (q == QUARTER_Q0) {
#line 631 "../src/worm.vala"
					result = FALSE;
#line 631 "../src/worm.vala"
					return result;
#line 3633 "worm.c"
				} else {
					Angle _tmp12_;
					int128 _tmp13_ = {0};
					Angle _tmp14_;
					int128 _tmp15_ = {0};
#line 633 "../src/worm.vala"
					_tmp12_ = *o;
#line 633 "../src/worm.vala"
					multiply ((*self).x, _tmp12_.y, &_tmp13_);
#line 633 "../src/worm.vala"
					_tmp14_ = *o;
#line 633 "../src/worm.vala"
					multiply (_tmp14_.x, (*self).y, &_tmp15_);
#line 633 "../src/worm.vala"
					result = int128_less_than (&_tmp13_, &_tmp15_);
#line 633 "../src/worm.vala"
					return result;
#line 3651 "worm.c"
				}
			}
		}
		default:
		{
#line 635 "../src/worm.vala"
			result = FALSE;
#line 635 "../src/worm.vala"
			return result;
#line 3661 "worm.c"
		}
	}
}

gboolean
angle_less_than (Angle *self,
                 Angle* o)
{
	gboolean _tmp0_ = FALSE;
	Angle _tmp1_;
	gboolean result;
#line 640 "../src/worm.vala"
	g_return_val_if_fail (o != NULL, FALSE);
#line 642 "../src/worm.vala"
	_tmp1_ = *o;
#line 642 "../src/worm.vala"
	if (!angle_equal_to (&(*self), &_tmp1_)) {
#line 3679 "worm.c"
		Angle _tmp2_;
#line 642 "../src/worm.vala"
		_tmp2_ = *o;
#line 642 "../src/worm.vala"
		_tmp0_ = angle_less_than_or_equal_to (&(*self), &_tmp2_);
#line 3685 "worm.c"
	} else {
#line 642 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 3689 "worm.c"
	}
#line 642 "../src/worm.vala"
	result = _tmp0_;
#line 642 "../src/worm.vala"
	return result;
#line 3695 "worm.c"
}

gboolean
angle_greater_than_or_equal_to (Angle *self,
                                Angle* o)
{
	Quarter q = 0;
	gboolean result;
#line 646 "../src/worm.vala"
	g_return_val_if_fail (o != NULL, FALSE);
#line 648 "../src/worm.vala"
	q = angle_get_quarter (o);
#line 649 "../src/worm.vala"
	switch (angle_get_quarter (&(*self))) {
#line 649 "../src/worm.vala"
		case QUARTER_Q0:
#line 3712 "worm.c"
		{
#line 652 "../src/worm.vala"
			if (q == QUARTER_Q3) {
#line 653 "../src/worm.vala"
				result = TRUE;
#line 653 "../src/worm.vala"
				return result;
#line 3720 "worm.c"
			} else {
#line 654 "../src/worm.vala"
				if (q == QUARTER_Q1) {
#line 655 "../src/worm.vala"
					result = FALSE;
#line 655 "../src/worm.vala"
					return result;
#line 3728 "worm.c"
				} else {
#line 656 "../src/worm.vala"
					if (q == QUARTER_Q2) {
#line 3732 "worm.c"
						Angle _tmp0_;
						int128 _tmp1_ = {0};
						Angle _tmp2_;
						int128 _tmp3_ = {0};
#line 657 "../src/worm.vala"
						_tmp0_ = *o;
#line 657 "../src/worm.vala"
						multiply ((*self).x, _tmp0_.y, &_tmp1_);
#line 657 "../src/worm.vala"
						_tmp2_ = *o;
#line 657 "../src/worm.vala"
						multiply (_tmp2_.x, (*self).y, &_tmp3_);
#line 657 "../src/worm.vala"
						result = int128_less_than (&_tmp1_, &_tmp3_);
#line 657 "../src/worm.vala"
						return result;
#line 3749 "worm.c"
					} else {
						Angle _tmp4_;
						int128 _tmp5_ = {0};
						Angle _tmp6_;
						int128 _tmp7_ = {0};
#line 659 "../src/worm.vala"
						_tmp4_ = *o;
#line 659 "../src/worm.vala"
						multiply ((*self).x, _tmp4_.y, &_tmp5_);
#line 659 "../src/worm.vala"
						_tmp6_ = *o;
#line 659 "../src/worm.vala"
						multiply (_tmp6_.x, (*self).y, &_tmp7_);
#line 659 "../src/worm.vala"
						result = int128_less_than_or_equal_to (&_tmp5_, &_tmp7_);
#line 659 "../src/worm.vala"
						return result;
#line 3767 "worm.c"
					}
				}
			}
		}
#line 649 "../src/worm.vala"
		case QUARTER_Q1:
#line 3774 "worm.c"
		{
#line 661 "../src/worm.vala"
			if (q == QUARTER_Q0) {
#line 662 "../src/worm.vala"
				result = TRUE;
#line 662 "../src/worm.vala"
				return result;
#line 3782 "worm.c"
			} else {
#line 663 "../src/worm.vala"
				if (q == QUARTER_Q2) {
#line 664 "../src/worm.vala"
					result = FALSE;
#line 664 "../src/worm.vala"
					return result;
#line 3790 "worm.c"
				} else {
#line 665 "../src/worm.vala"
					if (q == QUARTER_Q3) {
#line 3794 "worm.c"
						Angle _tmp8_;
						int128 _tmp9_ = {0};
						Angle _tmp10_;
						int128 _tmp11_ = {0};
#line 666 "../src/worm.vala"
						_tmp8_ = *o;
#line 666 "../src/worm.vala"
						multiply ((*self).x, _tmp8_.y, &_tmp9_);
#line 666 "../src/worm.vala"
						_tmp10_ = *o;
#line 666 "../src/worm.vala"
						multiply (_tmp10_.x, (*self).y, &_tmp11_);
#line 666 "../src/worm.vala"
						result = int128_less_than (&_tmp9_, &_tmp11_);
#line 666 "../src/worm.vala"
						return result;
#line 3811 "worm.c"
					} else {
						Angle _tmp12_;
						int128 _tmp13_ = {0};
						Angle _tmp14_;
						int128 _tmp15_ = {0};
#line 668 "../src/worm.vala"
						_tmp12_ = *o;
#line 668 "../src/worm.vala"
						multiply ((*self).x, _tmp12_.y, &_tmp13_);
#line 668 "../src/worm.vala"
						_tmp14_ = *o;
#line 668 "../src/worm.vala"
						multiply (_tmp14_.x, (*self).y, &_tmp15_);
#line 668 "../src/worm.vala"
						result = int128_less_than_or_equal_to (&_tmp13_, &_tmp15_);
#line 668 "../src/worm.vala"
						return result;
#line 3829 "worm.c"
					}
				}
			}
		}
#line 649 "../src/worm.vala"
		case QUARTER_Q2:
#line 3836 "worm.c"
		{
#line 670 "../src/worm.vala"
			if (q == QUARTER_Q1) {
#line 671 "../src/worm.vala"
				result = TRUE;
#line 671 "../src/worm.vala"
				return result;
#line 3844 "worm.c"
			} else {
#line 672 "../src/worm.vala"
				if (q == QUARTER_Q3) {
#line 673 "../src/worm.vala"
					result = FALSE;
#line 673 "../src/worm.vala"
					return result;
#line 3852 "worm.c"
				} else {
#line 674 "../src/worm.vala"
					if (q == QUARTER_Q0) {
#line 3856 "worm.c"
						Angle _tmp16_;
						int128 _tmp17_ = {0};
						Angle _tmp18_;
						int128 _tmp19_ = {0};
#line 675 "../src/worm.vala"
						_tmp16_ = *o;
#line 675 "../src/worm.vala"
						multiply ((*self).x, _tmp16_.y, &_tmp17_);
#line 675 "../src/worm.vala"
						_tmp18_ = *o;
#line 675 "../src/worm.vala"
						multiply (_tmp18_.x, (*self).y, &_tmp19_);
#line 675 "../src/worm.vala"
						result = int128_less_than (&_tmp17_, &_tmp19_);
#line 675 "../src/worm.vala"
						return result;
#line 3873 "worm.c"
					} else {
						Angle _tmp20_;
						int128 _tmp21_ = {0};
						Angle _tmp22_;
						int128 _tmp23_ = {0};
#line 677 "../src/worm.vala"
						_tmp20_ = *o;
#line 677 "../src/worm.vala"
						multiply ((*self).x, _tmp20_.y, &_tmp21_);
#line 677 "../src/worm.vala"
						_tmp22_ = *o;
#line 677 "../src/worm.vala"
						multiply (_tmp22_.x, (*self).y, &_tmp23_);
#line 677 "../src/worm.vala"
						result = int128_less_than_or_equal_to (&_tmp21_, &_tmp23_);
#line 677 "../src/worm.vala"
						return result;
#line 3891 "worm.c"
					}
				}
			}
		}
#line 649 "../src/worm.vala"
		case QUARTER_Q3:
#line 3898 "worm.c"
		{
#line 679 "../src/worm.vala"
			if (q == QUARTER_Q2) {
#line 680 "../src/worm.vala"
				result = TRUE;
#line 680 "../src/worm.vala"
				return result;
#line 3906 "worm.c"
			} else {
#line 681 "../src/worm.vala"
				if (q == QUARTER_Q0) {
#line 682 "../src/worm.vala"
					result = FALSE;
#line 682 "../src/worm.vala"
					return result;
#line 3914 "worm.c"
				} else {
#line 683 "../src/worm.vala"
					if (q == QUARTER_Q1) {
#line 3918 "worm.c"
						Angle _tmp24_;
						int128 _tmp25_ = {0};
						Angle _tmp26_;
						int128 _tmp27_ = {0};
#line 684 "../src/worm.vala"
						_tmp24_ = *o;
#line 684 "../src/worm.vala"
						multiply ((*self).x, _tmp24_.y, &_tmp25_);
#line 684 "../src/worm.vala"
						_tmp26_ = *o;
#line 684 "../src/worm.vala"
						multiply (_tmp26_.x, (*self).y, &_tmp27_);
#line 684 "../src/worm.vala"
						result = int128_less_than (&_tmp25_, &_tmp27_);
#line 684 "../src/worm.vala"
						return result;
#line 3935 "worm.c"
					} else {
						Angle _tmp28_;
						int128 _tmp29_ = {0};
						Angle _tmp30_;
						int128 _tmp31_ = {0};
#line 686 "../src/worm.vala"
						_tmp28_ = *o;
#line 686 "../src/worm.vala"
						multiply ((*self).x, _tmp28_.y, &_tmp29_);
#line 686 "../src/worm.vala"
						_tmp30_ = *o;
#line 686 "../src/worm.vala"
						multiply (_tmp30_.x, (*self).y, &_tmp31_);
#line 686 "../src/worm.vala"
						result = int128_less_than_or_equal_to (&_tmp29_, &_tmp31_);
#line 686 "../src/worm.vala"
						return result;
#line 3953 "worm.c"
					}
				}
			}
		}
		default:
		{
#line 688 "../src/worm.vala"
			result = FALSE;
#line 688 "../src/worm.vala"
			return result;
#line 3964 "worm.c"
		}
	}
}

gboolean
angle_equal_to (Angle *self,
                Angle* o)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 693 "../src/worm.vala"
	g_return_val_if_fail (o != NULL, FALSE);
#line 695 "../src/worm.vala"
	if (angle_get_quarter (&(*self)) == angle_get_quarter (o)) {
#line 3979 "worm.c"
		Angle _tmp1_;
		int128 _tmp2_ = {0};
		Angle _tmp3_;
		int128 _tmp4_ = {0};
#line 696 "../src/worm.vala"
		_tmp1_ = *o;
#line 696 "../src/worm.vala"
		multiply ((*self).x, _tmp1_.y, &_tmp2_);
#line 696 "../src/worm.vala"
		_tmp3_ = *o;
#line 696 "../src/worm.vala"
		multiply (_tmp3_.x, (*self).y, &_tmp4_);
#line 696 "../src/worm.vala"
		_tmp0_ = int128_equal_to (&_tmp2_, &_tmp4_);
#line 3994 "worm.c"
	} else {
#line 695 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 3998 "worm.c"
	}
#line 695 "../src/worm.vala"
	result = _tmp0_;
#line 695 "../src/worm.vala"
	return result;
#line 4004 "worm.c"
}

void
angle_set_origin (Angle *self,
                  Position* origin)
{
	Position _tmp0_;
	Position _tmp1_;
#line 699 "../src/worm.vala"
	g_return_if_fail (origin != NULL);
#line 701 "../src/worm.vala"
	_tmp0_ = *origin;
#line 701 "../src/worm.vala"
	(*self).origin_x = ((_tmp0_.x * 2) + 1) * (ANGLE_step_multiplier / 2);
#line 702 "../src/worm.vala"
	_tmp1_ = *origin;
#line 702 "../src/worm.vala"
	(*self).origin_y = ((_tmp1_.y * 2) + 1) * (ANGLE_step_multiplier / 2);
#line 4023 "worm.c"
}

void
angle_set_wrapping (Angle *self,
                    gint x,
                    gint y)
{
#line 707 "../src/worm.vala"
	(*self).x_max = (gint64) x;
#line 708 "../src/worm.vala"
	(*self).y_max = (gint64) y;
#line 4035 "worm.c"
}

gboolean
angle_step_along_x (Angle *self)
{
	gboolean result;
#line 713 "../src/worm.vala"
	result = llabs ((*self).x) > llabs ((*self).y);
#line 713 "../src/worm.vala"
	return result;
#line 4046 "worm.c"
}

void
angle_get (Angle *self,
           guint64 i,
           SignedPosition* result)
{
	gint64 _tmp0_ = 0LL;
	gint64 delta_x = 0LL;
	gint64 _tmp3_ = 0LL;
	gint64 delta_y = 0LL;
	gint64 x_i = 0LL;
	gint64 y_i = 0LL;
	SignedPosition _tmp6_ = {0};
#line 720 "../src/worm.vala"
	if (angle_step_along_x (&(*self))) {
#line 720 "../src/worm.vala"
		_tmp0_ = angle_set_delta_x_sign (&(*self), ANGLE_step_multiplier);
#line 4065 "worm.c"
	} else {
		int128 _tmp1_ = {0};
		int128 _tmp2_ = {0};
#line 721 "../src/worm.vala"
		multiply_by_2n ((*self).x, ANGLE_step_multiplier_2n, &_tmp1_);
#line 721 "../src/worm.vala"
		int128_divide_by (&_tmp1_, (*self).y, &_tmp2_);
#line 721 "../src/worm.vala"
		_tmp0_ = angle_set_delta_x_sign (&(*self), int128_get_int64 (&_tmp2_));
#line 4075 "worm.c"
	}
#line 720 "../src/worm.vala"
	delta_x = _tmp0_;
#line 722 "../src/worm.vala"
	if (angle_step_along_x (&(*self))) {
#line 4081 "worm.c"
		int128 _tmp4_ = {0};
		int128 _tmp5_ = {0};
#line 722 "../src/worm.vala"
		multiply_by_2n ((*self).y, ANGLE_step_multiplier_2n, &_tmp4_);
#line 722 "../src/worm.vala"
		int128_divide_by (&_tmp4_, (*self).x, &_tmp5_);
#line 722 "../src/worm.vala"
		_tmp3_ = angle_set_delta_y_sign (&(*self), int128_get_int64 (&_tmp5_));
#line 4090 "worm.c"
	} else {
#line 723 "../src/worm.vala"
		_tmp3_ = angle_set_delta_y_sign (&(*self), ANGLE_step_multiplier);
#line 4094 "worm.c"
	}
#line 722 "../src/worm.vala"
	delta_y = _tmp3_;
#line 726 "../src/worm.vala"
	x_i = (*self).origin_x + (delta_x * ((gint64) i));
#line 727 "../src/worm.vala"
	y_i = (*self).origin_y + (delta_y * ((gint64) i));
#line 729 "../src/worm.vala"
	_tmp6_.x = x_i >> ANGLE_step_multiplier_2n;
#line 729 "../src/worm.vala"
	_tmp6_.y = y_i >> ANGLE_step_multiplier_2n;
#line 729 "../src/worm.vala"
	_tmp6_.x_max = (*self).x_max;
#line 729 "../src/worm.vala"
	_tmp6_.y_max = (*self).y_max;
#line 729 "../src/worm.vala"
	*result = _tmp6_;
#line 729 "../src/worm.vala"
	return;
#line 4114 "worm.c"
}

AngleIterator*
angle_iterator (Angle *self)
{
	AngleIterator* _tmp0_;
	AngleIterator* result;
#line 735 "../src/worm.vala"
	_tmp0_ = angle_iterator_new (&(*self));
#line 735 "../src/worm.vala"
	result = _tmp0_;
#line 735 "../src/worm.vala"
	return result;
#line 4128 "worm.c"
}

static Quarter
angle_get_quarter (Angle *self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	Quarter result;
#line 754 "../src/worm.vala"
	if ((*self).x >= ((gint64) 0)) {
#line 754 "../src/worm.vala"
		_tmp0_ = (*self).y < ((gint64) 0);
#line 4141 "worm.c"
	} else {
#line 754 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 4145 "worm.c"
	}
#line 754 "../src/worm.vala"
	if (_tmp0_) {
#line 755 "../src/worm.vala"
		result = QUARTER_Q0;
#line 755 "../src/worm.vala"
		return result;
#line 4153 "worm.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 756 "../src/worm.vala"
		if ((*self).x > ((gint64) 0)) {
#line 756 "../src/worm.vala"
			_tmp1_ = (*self).y >= ((gint64) 0);
#line 4160 "worm.c"
		} else {
#line 756 "../src/worm.vala"
			_tmp1_ = FALSE;
#line 4164 "worm.c"
		}
#line 756 "../src/worm.vala"
		if (_tmp1_) {
#line 757 "../src/worm.vala"
			result = QUARTER_Q1;
#line 757 "../src/worm.vala"
			return result;
#line 4172 "worm.c"
		}
	}
#line 758 "../src/worm.vala"
	if ((*self).x <= ((gint64) 0)) {
#line 758 "../src/worm.vala"
		_tmp2_ = (*self).y > ((gint64) 0);
#line 4179 "worm.c"
	} else {
#line 758 "../src/worm.vala"
		_tmp2_ = FALSE;
#line 4183 "worm.c"
	}
#line 758 "../src/worm.vala"
	if (_tmp2_) {
#line 759 "../src/worm.vala"
		result = QUARTER_Q2;
#line 759 "../src/worm.vala"
		return result;
#line 4191 "worm.c"
	} else {
#line 761 "../src/worm.vala"
		result = QUARTER_Q3;
#line 761 "../src/worm.vala"
		return result;
#line 4197 "worm.c"
	}
}

static gint64
angle_set_delta_x_sign (Angle *self,
                        gint64 _x)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint64 result;
#line 767 "../src/worm.vala"
	if ((*self).x >= ((gint64) 0)) {
#line 767 "../src/worm.vala"
		_tmp1_ = _x < ((gint64) 0);
#line 4212 "worm.c"
	} else {
#line 767 "../src/worm.vala"
		_tmp1_ = FALSE;
#line 4216 "worm.c"
	}
#line 767 "../src/worm.vala"
	if (_tmp1_) {
#line 767 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 4222 "worm.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 767 "../src/worm.vala"
		if ((*self).x < ((gint64) 0)) {
#line 767 "../src/worm.vala"
			_tmp2_ = _x >= ((gint64) 0);
#line 4229 "worm.c"
		} else {
#line 767 "../src/worm.vala"
			_tmp2_ = FALSE;
#line 4233 "worm.c"
		}
#line 767 "../src/worm.vala"
		_tmp0_ = _tmp2_;
#line 4237 "worm.c"
	}
#line 767 "../src/worm.vala"
	if (_tmp0_) {
#line 768 "../src/worm.vala"
		result = -_x;
#line 768 "../src/worm.vala"
		return result;
#line 4245 "worm.c"
	} else {
#line 770 "../src/worm.vala"
		result = _x;
#line 770 "../src/worm.vala"
		return result;
#line 4251 "worm.c"
	}
}

static gint64
angle_set_delta_y_sign (Angle *self,
                        gint64 _y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint64 result;
#line 776 "../src/worm.vala"
	if ((*self).y >= ((gint64) 0)) {
#line 776 "../src/worm.vala"
		_tmp1_ = _y < ((gint64) 0);
#line 4266 "worm.c"
	} else {
#line 776 "../src/worm.vala"
		_tmp1_ = FALSE;
#line 4270 "worm.c"
	}
#line 776 "../src/worm.vala"
	if (_tmp1_) {
#line 776 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 4276 "worm.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 776 "../src/worm.vala"
		if ((*self).y < ((gint64) 0)) {
#line 776 "../src/worm.vala"
			_tmp2_ = _y >= ((gint64) 0);
#line 4283 "worm.c"
		} else {
#line 776 "../src/worm.vala"
			_tmp2_ = FALSE;
#line 4287 "worm.c"
		}
#line 776 "../src/worm.vala"
		_tmp0_ = _tmp2_;
#line 4291 "worm.c"
	}
#line 776 "../src/worm.vala"
	if (_tmp0_) {
#line 777 "../src/worm.vala"
		result = -_y;
#line 777 "../src/worm.vala"
		return result;
#line 4299 "worm.c"
	} else {
#line 779 "../src/worm.vala"
		result = _y;
#line 779 "../src/worm.vala"
		return result;
#line 4305 "worm.c"
	}
}

Angle*
angle_dup (const Angle* self)
{
	Angle* dup;
#line 564 "../src/worm.vala"
	dup = g_new0 (Angle, 1);
#line 564 "../src/worm.vala"
	memcpy (dup, self, sizeof (Angle));
#line 564 "../src/worm.vala"
	return dup;
#line 4319 "worm.c"
}

void
angle_free (Angle* self)
{
#line 564 "../src/worm.vala"
	g_free (self);
#line 4327 "worm.c"
}

 G_GNUC_NO_INLINE static GType
angle_get_type_once (void)
{
	GType angle_type_id;
	angle_type_id = g_boxed_type_register_static ("Angle", (GBoxedCopyFunc) angle_dup, (GBoxedFreeFunc) angle_free);
	return angle_type_id;
}

GType
angle_get_type (void)
{
	static gsize angle_type_id__once = 0;
	if (g_once_init_enter (&angle_type_id__once)) {
		GType angle_type_id;
		angle_type_id = angle_get_type_once ();
		g_once_init_leave (&angle_type_id__once, angle_type_id);
	}
	return angle_type_id__once;
}

static inline gpointer
slice_get_instance_private (Slice* self)
{
	return G_STRUCT_MEMBER_P (self, Slice_private_offset);
}

Slice*
slice_construct (GType object_type,
                 Slice* copy)
{
	Slice * self = NULL;
#line 813 "../src/worm.vala"
	self = (Slice*) g_object_new (object_type, NULL);
#line 815 "../src/worm.vala"
	if (copy == NULL) {
#line 817 "../src/worm.vala"
		self->priv->min_set = FALSE;
#line 818 "../src/worm.vala"
		self->priv->max_set = FALSE;
#line 4369 "worm.c"
	} else {
#line 821 "../src/worm.vala"
		slice_assign (self, copy);
#line 4373 "worm.c"
	}
#line 813 "../src/worm.vala"
	return self;
#line 4377 "worm.c"
}

Slice*
slice_new (Slice* copy)
{
#line 813 "../src/worm.vala"
	return slice_construct (TYPE_SLICE, copy);
#line 4385 "worm.c"
}

void
slice_assign (Slice* self,
              Slice* o)
{
	Angle _tmp0_;
	Angle _tmp1_;
#line 825 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 825 "../src/worm.vala"
	g_return_if_fail (o != NULL);
#line 827 "../src/worm.vala"
	_tmp0_ = o->min;
#line 827 "../src/worm.vala"
	angle_assign (&self->min, &_tmp0_);
#line 828 "../src/worm.vala"
	_tmp1_ = o->max;
#line 828 "../src/worm.vala"
	angle_assign (&self->max, &_tmp1_);
#line 829 "../src/worm.vala"
	self->priv->min_set = o->priv->min_set;
#line 830 "../src/worm.vala"
	self->priv->max_set = o->priv->max_set;
#line 4410 "worm.c"
}

void
slice_set_direction_view (Slice* self,
                          WormDirection d,
                          gint* board,
                          gint board_length1,
                          gint board_length2)
{
#line 839 "../src/worm.vala"
	static const gint64 x = (gint64) 369665159;
#line 840 "../src/worm.vala"
	static const gint64 y = -14116942878LL;
#line 4424 "worm.c"
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
#line 833 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 841 "../src/worm.vala"
	switch (d) {
#line 841 "../src/worm.vala"
		case WORM_DIRECTION_EAST:
#line 4435 "worm.c"
		{
			Angle _tmp0_ = {0};
			Angle _tmp1_ = {0};
#line 855 "../src/worm.vala"
			_tmp0_.x = -y;
#line 855 "../src/worm.vala"
			_tmp0_.y = -x;
#line 855 "../src/worm.vala"
			self->min = _tmp0_;
#line 856 "../src/worm.vala"
			_tmp1_.x = -y;
#line 856 "../src/worm.vala"
			_tmp1_.y = +x;
#line 856 "../src/worm.vala"
			self->max = _tmp1_;
#line 857 "../src/worm.vala"
			break;
#line 4453 "worm.c"
		}
#line 841 "../src/worm.vala"
		case WORM_DIRECTION_SOUTH:
#line 4457 "worm.c"
		{
			Angle _tmp2_ = {0};
			Angle _tmp3_ = {0};
#line 866 "../src/worm.vala"
			_tmp2_.x = +x;
#line 866 "../src/worm.vala"
			_tmp2_.y = -y;
#line 866 "../src/worm.vala"
			self->min = _tmp2_;
#line 867 "../src/worm.vala"
			_tmp3_.x = -x;
#line 867 "../src/worm.vala"
			_tmp3_.y = -y;
#line 867 "../src/worm.vala"
			self->max = _tmp3_;
#line 868 "../src/worm.vala"
			break;
#line 4475 "worm.c"
		}
#line 841 "../src/worm.vala"
		case WORM_DIRECTION_WEST:
#line 4479 "worm.c"
		{
			Angle _tmp4_ = {0};
			Angle _tmp5_ = {0};
#line 881 "../src/worm.vala"
			_tmp4_.x = +y;
#line 881 "../src/worm.vala"
			_tmp4_.y = +x;
#line 881 "../src/worm.vala"
			self->min = _tmp4_;
#line 882 "../src/worm.vala"
			_tmp5_.x = +y;
#line 882 "../src/worm.vala"
			_tmp5_.y = -x;
#line 882 "../src/worm.vala"
			self->max = _tmp5_;
#line 883 "../src/worm.vala"
			break;
#line 4497 "worm.c"
		}
#line 841 "../src/worm.vala"
		case WORM_DIRECTION_NORTH:
#line 4501 "worm.c"
		{
			Angle _tmp6_ = {0};
			Angle _tmp7_ = {0};
#line 892 "../src/worm.vala"
			_tmp6_.x = -x;
#line 892 "../src/worm.vala"
			_tmp6_.y = +y;
#line 892 "../src/worm.vala"
			self->min = _tmp6_;
#line 893 "../src/worm.vala"
			_tmp7_.x = +x;
#line 893 "../src/worm.vala"
			_tmp7_.y = +y;
#line 893 "../src/worm.vala"
			self->max = _tmp7_;
#line 894 "../src/worm.vala"
			break;
#line 4519 "worm.c"
		}
		default:
		{
#line 896 "../src/worm.vala"
			break;
#line 4525 "worm.c"
		}
	}
#line 898 "../src/worm.vala"
	self->priv->min_set = TRUE;
#line 899 "../src/worm.vala"
	self->priv->max_set = TRUE;
#line 900 "../src/worm.vala"
	_tmp8_ = board_length1;
#line 900 "../src/worm.vala"
	_tmp9_ = board_length2;
#line 900 "../src/worm.vala"
	angle_set_wrapping (&self->min, _tmp8_, _tmp9_);
#line 901 "../src/worm.vala"
	_tmp10_ = board_length1;
#line 901 "../src/worm.vala"
	_tmp11_ = board_length2;
#line 901 "../src/worm.vala"
	angle_set_wrapping (&self->max, _tmp10_, _tmp11_);
#line 4544 "worm.c"
}

void
slice_add_angle (Slice* self,
                 Angle* a)
{
	gboolean _tmp0_ = FALSE;
#line 904 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 904 "../src/worm.vala"
	g_return_if_fail (a != NULL);
#line 906 "../src/worm.vala"
	if (!self->priv->min_set) {
#line 906 "../src/worm.vala"
		_tmp0_ = !self->priv->max_set;
#line 4560 "worm.c"
	} else {
#line 906 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 4564 "worm.c"
	}
#line 906 "../src/worm.vala"
	if (_tmp0_) {
#line 4568 "worm.c"
		Angle _tmp1_;
#line 908 "../src/worm.vala"
		_tmp1_ = *a;
#line 908 "../src/worm.vala"
		angle_assign (&self->min, &_tmp1_);
#line 909 "../src/worm.vala"
		self->priv->min_set = TRUE;
#line 4576 "worm.c"
	} else {
#line 911 "../src/worm.vala"
		if (!self->priv->min_set) {
#line 4580 "worm.c"
			Angle _tmp2_;
#line 913 "../src/worm.vala"
			_tmp2_ = self->max;
#line 913 "../src/worm.vala"
			if (angle_greater_than (a, &_tmp2_)) {
#line 4586 "worm.c"
				Angle _tmp3_;
				Angle _tmp4_;
#line 915 "../src/worm.vala"
				_tmp3_ = self->max;
#line 915 "../src/worm.vala"
				angle_assign (&self->min, &_tmp3_);
#line 916 "../src/worm.vala"
				_tmp4_ = *a;
#line 916 "../src/worm.vala"
				angle_assign (&self->max, &_tmp4_);
#line 4597 "worm.c"
			} else {
				Angle _tmp5_;
#line 919 "../src/worm.vala"
				_tmp5_ = *a;
#line 919 "../src/worm.vala"
				angle_assign (&self->min, &_tmp5_);
#line 4604 "worm.c"
			}
#line 920 "../src/worm.vala"
			self->priv->min_set = TRUE;
#line 4608 "worm.c"
		} else {
#line 922 "../src/worm.vala"
			if (!self->priv->max_set) {
#line 4612 "worm.c"
				Angle _tmp6_;
#line 924 "../src/worm.vala"
				_tmp6_ = self->min;
#line 924 "../src/worm.vala"
				if (angle_greater_than (a, &_tmp6_)) {
#line 4618 "worm.c"
					Angle _tmp7_;
#line 925 "../src/worm.vala"
					_tmp7_ = *a;
#line 925 "../src/worm.vala"
					angle_assign (&self->max, &_tmp7_);
#line 4624 "worm.c"
				} else {
					Angle _tmp8_;
					Angle _tmp9_;
#line 928 "../src/worm.vala"
					_tmp8_ = self->min;
#line 928 "../src/worm.vala"
					angle_assign (&self->max, &_tmp8_);
#line 929 "../src/worm.vala"
					_tmp9_ = *a;
#line 929 "../src/worm.vala"
					angle_assign (&self->min, &_tmp9_);
#line 4636 "worm.c"
				}
#line 931 "../src/worm.vala"
				self->priv->max_set = TRUE;
#line 4640 "worm.c"
			} else {
				Angle _tmp10_;
#line 935 "../src/worm.vala"
				_tmp10_ = self->min;
#line 935 "../src/worm.vala"
				if (angle_less_than (a, &_tmp10_)) {
#line 4647 "worm.c"
					Angle _tmp11_;
#line 936 "../src/worm.vala"
					_tmp11_ = *a;
#line 936 "../src/worm.vala"
					angle_assign (&self->min, &_tmp11_);
#line 4653 "worm.c"
				} else {
					Angle _tmp12_;
#line 937 "../src/worm.vala"
					_tmp12_ = self->max;
#line 937 "../src/worm.vala"
					if (angle_greater_than (a, &_tmp12_)) {
#line 4660 "worm.c"
						Angle _tmp13_;
#line 938 "../src/worm.vala"
						_tmp13_ = *a;
#line 938 "../src/worm.vala"
						angle_assign (&self->max, &_tmp13_);
#line 4666 "worm.c"
					}
				}
			}
		}
	}
}

void
slice_set_from_position (Slice* self,
                         Position* origin,
                         gint64 x,
                         gint64 y,
                         gint size)
{
	Position _tmp0_;
	Position _tmp1_;
	Angle _tmp2_ = {0};
	Position _tmp3_;
	Position _tmp4_;
	Angle _tmp5_ = {0};
	Position _tmp6_;
	Position _tmp7_;
	Angle _tmp8_ = {0};
	Position _tmp9_;
	Position _tmp10_;
	Angle _tmp11_ = {0};
#line 942 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 942 "../src/worm.vala"
	g_return_if_fail (origin != NULL);
#line 950 "../src/worm.vala"
	self->priv->min_set = FALSE;
#line 951 "../src/worm.vala"
	self->priv->max_set = FALSE;
#line 966 "../src/worm.vala"
	_tmp0_ = *origin;
#line 966 "../src/worm.vala"
	_tmp1_ = *origin;
#line 966 "../src/worm.vala"
	_tmp2_.x = (x * 2) - ((_tmp0_.x * 2) + 1);
#line 966 "../src/worm.vala"
	_tmp2_.y = (y * 2) - ((_tmp1_.y * 2) + 1);
#line 966 "../src/worm.vala"
	slice_add_angle (self, &_tmp2_);
#line 967 "../src/worm.vala"
	_tmp3_ = *origin;
#line 967 "../src/worm.vala"
	_tmp4_ = *origin;
#line 967 "../src/worm.vala"
	_tmp5_.x = ((x + (1 * size)) * 2) - ((_tmp3_.x * 2) + 1);
#line 967 "../src/worm.vala"
	_tmp5_.y = (y * 2) - ((_tmp4_.y * 2) + 1);
#line 967 "../src/worm.vala"
	slice_add_angle (self, &_tmp5_);
#line 968 "../src/worm.vala"
	_tmp6_ = *origin;
#line 968 "../src/worm.vala"
	_tmp7_ = *origin;
#line 968 "../src/worm.vala"
	_tmp8_.x = (x * 2) - ((_tmp6_.x * 2) + 1);
#line 968 "../src/worm.vala"
	_tmp8_.y = ((y + (1 * size)) * 2) - ((_tmp7_.y * 2) + 1);
#line 968 "../src/worm.vala"
	slice_add_angle (self, &_tmp8_);
#line 969 "../src/worm.vala"
	_tmp9_ = *origin;
#line 969 "../src/worm.vala"
	_tmp10_ = *origin;
#line 969 "../src/worm.vala"
	_tmp11_.x = ((x + (1 * size)) * 2) - ((_tmp9_.x * 2) + 1);
#line 969 "../src/worm.vala"
	_tmp11_.y = ((y + (1 * size)) * 2) - ((_tmp10_.y * 2) + 1);
#line 969 "../src/worm.vala"
	slice_add_angle (self, &_tmp11_);
#line 4741 "worm.c"
}

void
slice_intersection_by_position (Slice* self,
                                Position* origin,
                                guint8 _x,
                                guint8 _y,
                                gint size)
{
	gint64 x = 0LL;
	gint64 y = 0LL;
	gboolean _tmp0_ = FALSE;
	Angle _tmp1_;
	Angle old_min = {0};
	Angle _tmp20_ = {0};
	Angle _tmp21_;
	Angle old_max = {0};
	Angle _tmp22_ = {0};
	Angle _tmp23_;
	Position _tmp24_;
	Angle _tmp25_;
	Angle _tmp27_;
#line 972 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 972 "../src/worm.vala"
	g_return_if_fail (origin != NULL);
#line 979 "../src/worm.vala"
	x = (gint64) _x;
#line 980 "../src/worm.vala"
	y = (gint64) _y;
#line 981 "../src/worm.vala"
	_tmp1_ = self->min;
#line 981 "../src/worm.vala"
	if (_tmp1_.x >= ((gint64) 0)) {
#line 4776 "worm.c"
		Angle _tmp2_;
#line 981 "../src/worm.vala"
		_tmp2_ = self->max;
#line 981 "../src/worm.vala"
		_tmp0_ = _tmp2_.x >= ((gint64) 0);
#line 4782 "worm.c"
	} else {
#line 981 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 4786 "worm.c"
	}
#line 981 "../src/worm.vala"
	if (_tmp0_) {
#line 4790 "worm.c"
		Position _tmp3_;
#line 983 "../src/worm.vala"
		_tmp3_ = *origin;
#line 983 "../src/worm.vala"
		if (!((x + (size - 1)) > ((gint64) _tmp3_.x))) {
#line 4796 "worm.c"
			Angle _tmp4_;
#line 984 "../src/worm.vala"
			_tmp4_ = self->min;
#line 984 "../src/worm.vala"
			x += _tmp4_.x_max;
#line 4802 "worm.c"
		}
	} else {
		gboolean _tmp5_ = FALSE;
		Angle _tmp6_;
#line 986 "../src/worm.vala"
		_tmp6_ = self->min;
#line 986 "../src/worm.vala"
		if (_tmp6_.x < ((gint64) 0)) {
#line 4811 "worm.c"
			Angle _tmp7_;
#line 986 "../src/worm.vala"
			_tmp7_ = self->max;
#line 986 "../src/worm.vala"
			_tmp5_ = _tmp7_.x < ((gint64) 0);
#line 4817 "worm.c"
		} else {
#line 986 "../src/worm.vala"
			_tmp5_ = FALSE;
#line 4821 "worm.c"
		}
#line 986 "../src/worm.vala"
		if (_tmp5_) {
#line 4825 "worm.c"
			Position _tmp8_;
#line 988 "../src/worm.vala"
			_tmp8_ = *origin;
#line 988 "../src/worm.vala"
			if (!(x < ((gint64) _tmp8_.x))) {
#line 4831 "worm.c"
				Angle _tmp9_;
#line 989 "../src/worm.vala"
				_tmp9_ = self->min;
#line 989 "../src/worm.vala"
				x -= _tmp9_.x_max;
#line 4837 "worm.c"
			}
		} else {
			gboolean _tmp10_ = FALSE;
			Angle _tmp11_;
#line 991 "../src/worm.vala"
			_tmp11_ = self->min;
#line 991 "../src/worm.vala"
			if (_tmp11_.y >= ((gint64) 0)) {
#line 4846 "worm.c"
				Angle _tmp12_;
#line 991 "../src/worm.vala"
				_tmp12_ = self->max;
#line 991 "../src/worm.vala"
				_tmp10_ = _tmp12_.y >= ((gint64) 0);
#line 4852 "worm.c"
			} else {
#line 991 "../src/worm.vala"
				_tmp10_ = FALSE;
#line 4856 "worm.c"
			}
#line 991 "../src/worm.vala"
			if (_tmp10_) {
#line 4860 "worm.c"
				Position _tmp13_;
#line 993 "../src/worm.vala"
				_tmp13_ = *origin;
#line 993 "../src/worm.vala"
				if (!((y + (size - 1)) > ((gint64) _tmp13_.y))) {
#line 4866 "worm.c"
					Angle _tmp14_;
#line 994 "../src/worm.vala"
					_tmp14_ = self->min;
#line 994 "../src/worm.vala"
					y += _tmp14_.y_max;
#line 4872 "worm.c"
				}
			} else {
				gboolean _tmp15_ = FALSE;
				Angle _tmp16_;
#line 996 "../src/worm.vala"
				_tmp16_ = self->min;
#line 996 "../src/worm.vala"
				if (_tmp16_.y < ((gint64) 0)) {
#line 4881 "worm.c"
					Angle _tmp17_;
#line 996 "../src/worm.vala"
					_tmp17_ = self->max;
#line 996 "../src/worm.vala"
					_tmp15_ = _tmp17_.y < ((gint64) 0);
#line 4887 "worm.c"
				} else {
#line 996 "../src/worm.vala"
					_tmp15_ = FALSE;
#line 4891 "worm.c"
				}
#line 996 "../src/worm.vala"
				if (_tmp15_) {
#line 4895 "worm.c"
					Position _tmp18_;
#line 998 "../src/worm.vala"
					_tmp18_ = *origin;
#line 998 "../src/worm.vala"
					if (!(y < ((gint64) _tmp18_.y))) {
#line 4901 "worm.c"
						Angle _tmp19_;
#line 999 "../src/worm.vala"
						_tmp19_ = self->min;
#line 999 "../src/worm.vala"
						y -= _tmp19_.y_max;
#line 4907 "worm.c"
					}
				}
			}
		}
	}
#line 1001 "../src/worm.vala"
	old_min = _tmp20_;
#line 1002 "../src/worm.vala"
	_tmp21_ = self->min;
#line 1002 "../src/worm.vala"
	angle_assign (&old_min, &_tmp21_);
#line 1003 "../src/worm.vala"
	old_max = _tmp22_;
#line 1004 "../src/worm.vala"
	_tmp23_ = self->max;
#line 1004 "../src/worm.vala"
	angle_assign (&old_max, &_tmp23_);
#line 1005 "../src/worm.vala"
	_tmp24_ = *origin;
#line 1005 "../src/worm.vala"
	slice_set_from_position (self, &_tmp24_, x, y, size);
#line 1006 "../src/worm.vala"
	_tmp25_ = self->min;
#line 1006 "../src/worm.vala"
	if (angle_greater_than (&old_min, &_tmp25_)) {
#line 4933 "worm.c"
		Angle _tmp26_;
#line 1007 "../src/worm.vala"
		_tmp26_ = old_min;
#line 1007 "../src/worm.vala"
		angle_assign (&self->min, &_tmp26_);
#line 4939 "worm.c"
	}
#line 1008 "../src/worm.vala"
	_tmp27_ = self->max;
#line 1008 "../src/worm.vala"
	if (angle_less_than (&old_max, &_tmp27_)) {
#line 4945 "worm.c"
		Angle _tmp28_;
#line 1009 "../src/worm.vala"
		_tmp28_ = old_max;
#line 1009 "../src/worm.vala"
		angle_assign (&self->max, &_tmp28_);
#line 4951 "worm.c"
	}
}

gboolean
slice_is_empty (Slice* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 1012 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1015 "../src/worm.vala"
	if (!self->priv->min_set) {
#line 1015 "../src/worm.vala"
		_tmp1_ = TRUE;
#line 4967 "worm.c"
	} else {
#line 1015 "../src/worm.vala"
		_tmp1_ = !self->priv->max_set;
#line 4971 "worm.c"
	}
#line 1015 "../src/worm.vala"
	if (_tmp1_) {
#line 1015 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 4977 "worm.c"
	} else {
		Angle _tmp2_;
#line 1015 "../src/worm.vala"
		_tmp2_ = self->max;
#line 1015 "../src/worm.vala"
		_tmp0_ = angle_greater_than_or_equal_to (&self->min, &_tmp2_);
#line 4984 "worm.c"
	}
#line 1015 "../src/worm.vala"
	result = _tmp0_;
#line 1015 "../src/worm.vala"
	return result;
#line 4990 "worm.c"
}

static gboolean
slice_is_bonus_at (Slice* self,
                   guint8 x,
                   guint8 y,
                   Bonus* b)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	guint8 _tmp4_;
	guint8 _tmp5_;
	gboolean result;
#line 1018 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1018 "../src/worm.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 1020 "../src/worm.vala"
	_tmp4_ = bonus_get_x (b);
#line 1020 "../src/worm.vala"
	_tmp5_ = _tmp4_;
#line 1020 "../src/worm.vala"
	if (_tmp5_ == x) {
#line 5016 "worm.c"
		guint8 _tmp6_;
		guint8 _tmp7_;
#line 1020 "../src/worm.vala"
		_tmp6_ = bonus_get_y (b);
#line 1020 "../src/worm.vala"
		_tmp7_ = _tmp6_;
#line 1020 "../src/worm.vala"
		_tmp3_ = _tmp7_ == y;
#line 5025 "worm.c"
	} else {
#line 1020 "../src/worm.vala"
		_tmp3_ = FALSE;
#line 5029 "worm.c"
	}
#line 1020 "../src/worm.vala"
	if (_tmp3_) {
#line 1020 "../src/worm.vala"
		_tmp2_ = TRUE;
#line 5035 "worm.c"
	} else {
		gboolean _tmp8_ = FALSE;
		guint8 _tmp9_;
		guint8 _tmp10_;
#line 1021 "../src/worm.vala"
		_tmp9_ = bonus_get_x (b);
#line 1021 "../src/worm.vala"
		_tmp10_ = _tmp9_;
#line 1021 "../src/worm.vala"
		if ((_tmp10_ + 1) == ((gint) x)) {
#line 5046 "worm.c"
			guint8 _tmp11_;
			guint8 _tmp12_;
#line 1021 "../src/worm.vala"
			_tmp11_ = bonus_get_y (b);
#line 1021 "../src/worm.vala"
			_tmp12_ = _tmp11_;
#line 1021 "../src/worm.vala"
			_tmp8_ = _tmp12_ == y;
#line 5055 "worm.c"
		} else {
#line 1021 "../src/worm.vala"
			_tmp8_ = FALSE;
#line 5059 "worm.c"
		}
#line 1021 "../src/worm.vala"
		_tmp2_ = _tmp8_;
#line 5063 "worm.c"
	}
#line 1020 "../src/worm.vala"
	if (_tmp2_) {
#line 1020 "../src/worm.vala"
		_tmp1_ = TRUE;
#line 5069 "worm.c"
	} else {
		gboolean _tmp13_ = FALSE;
		guint8 _tmp14_;
		guint8 _tmp15_;
#line 1022 "../src/worm.vala"
		_tmp14_ = bonus_get_x (b);
#line 1022 "../src/worm.vala"
		_tmp15_ = _tmp14_;
#line 1022 "../src/worm.vala"
		if (_tmp15_ == x) {
#line 5080 "worm.c"
			guint8 _tmp16_;
			guint8 _tmp17_;
#line 1022 "../src/worm.vala"
			_tmp16_ = bonus_get_y (b);
#line 1022 "../src/worm.vala"
			_tmp17_ = _tmp16_;
#line 1022 "../src/worm.vala"
			_tmp13_ = (_tmp17_ + 1) == ((gint) y);
#line 5089 "worm.c"
		} else {
#line 1022 "../src/worm.vala"
			_tmp13_ = FALSE;
#line 5093 "worm.c"
		}
#line 1022 "../src/worm.vala"
		_tmp1_ = _tmp13_;
#line 5097 "worm.c"
	}
#line 1020 "../src/worm.vala"
	if (_tmp1_) {
#line 1020 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 5103 "worm.c"
	} else {
		gboolean _tmp18_ = FALSE;
		guint8 _tmp19_;
		guint8 _tmp20_;
#line 1023 "../src/worm.vala"
		_tmp19_ = bonus_get_x (b);
#line 1023 "../src/worm.vala"
		_tmp20_ = _tmp19_;
#line 1023 "../src/worm.vala"
		if ((_tmp20_ + 1) == ((gint) x)) {
#line 5114 "worm.c"
			guint8 _tmp21_;
			guint8 _tmp22_;
#line 1023 "../src/worm.vala"
			_tmp21_ = bonus_get_y (b);
#line 1023 "../src/worm.vala"
			_tmp22_ = _tmp21_;
#line 1023 "../src/worm.vala"
			_tmp18_ = (_tmp22_ + 1) == ((gint) y);
#line 5123 "worm.c"
		} else {
#line 1023 "../src/worm.vala"
			_tmp18_ = FALSE;
#line 5127 "worm.c"
		}
#line 1023 "../src/worm.vala"
		_tmp0_ = _tmp18_;
#line 5131 "worm.c"
	}
#line 1020 "../src/worm.vala"
	result = _tmp0_;
#line 1020 "../src/worm.vala"
	return result;
#line 5137 "worm.c"
}

static gboolean
slice_is_position_occupied (Slice* self,
                            Position* p,
                            gint* board,
                            gint board_length1,
                            gint board_length2,
                            WormMap* worm_map)
{
	gboolean _tmp0_ = FALSE;
	Position _tmp1_;
	Position _tmp2_;
	gint _tmp3_;
	gboolean result;
#line 1026 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1026 "../src/worm.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 1026 "../src/worm.vala"
	g_return_val_if_fail (worm_map != NULL, FALSE);
#line 1028 "../src/worm.vala"
	_tmp1_ = *p;
#line 1028 "../src/worm.vala"
	_tmp2_ = *p;
#line 1028 "../src/worm.vala"
	_tmp3_ = board[(_tmp1_.x * board_length2) + _tmp2_.y];
#line 1028 "../src/worm.vala"
	if (_tmp3_ > ((gint) NIBBLES_GAME_EMPTYCHAR)) {
#line 1028 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 5169 "worm.c"
	} else {
		Position _tmp4_;
#line 1028 "../src/worm.vala"
		_tmp4_ = *p;
#line 1028 "../src/worm.vala"
		_tmp0_ = worm_map_contain_position (worm_map, &_tmp4_);
#line 5176 "worm.c"
	}
#line 1028 "../src/worm.vala"
	result = _tmp0_;
#line 1028 "../src/worm.vala"
	return result;
#line 5182 "worm.c"
}

gint64
slice_is_visible (Slice* self,
                  Position* origin,
                  gint* board,
                  gint board_length1,
                  gint board_length2,
                  WormMap* worm_map,
                  Bonus* bonus)
{
	GeeArrayList* checked_positions = NULL;
	GeeArrayList* _tmp0_;
	gint64 result;
#line 1031 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 1031 "../src/worm.vala"
	g_return_val_if_fail (origin != NULL, 0LL);
#line 1031 "../src/worm.vala"
	g_return_val_if_fail (worm_map != NULL, 0LL);
#line 1031 "../src/worm.vala"
	g_return_val_if_fail (bonus != NULL, 0LL);
#line 1039 "../src/worm.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL);
#line 1039 "../src/worm.vala"
	checked_positions = _tmp0_;
#line 5209 "worm.c"
	{
		gboolean _tmp1_ = FALSE;
#line 1042 "../src/worm.vala"
		_tmp1_ = TRUE;
#line 1042 "../src/worm.vala"
		while (TRUE) {
#line 5216 "worm.c"
			gint64 distance = 0LL;
			Position _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
#line 1042 "../src/worm.vala"
			if (!_tmp1_) {
#line 5223 "worm.c"
			}
#line 1042 "../src/worm.vala"
			_tmp1_ = FALSE;
#line 1042 "../src/worm.vala"
			if (!(!slice_is_empty (self))) {
#line 1042 "../src/worm.vala"
				break;
#line 5231 "worm.c"
			}
#line 1044 "../src/worm.vala"
			distance = (gint64) 0;
#line 1045 "../src/worm.vala"
			_tmp2_ = *origin;
#line 1045 "../src/worm.vala"
			angle_set_origin (&self->min, &_tmp2_);
#line 1046 "../src/worm.vala"
			_tmp3_ = board_length1;
#line 1046 "../src/worm.vala"
			_tmp4_ = board_length2;
#line 1046 "../src/worm.vala"
			angle_set_wrapping (&self->min, _tmp3_, _tmp4_);
#line 5245 "worm.c"
			{
				AngleIterator* _p_it = NULL;
				AngleIterator* _tmp5_;
#line 1047 "../src/worm.vala"
				_tmp5_ = angle_iterator (&self->min);
#line 1047 "../src/worm.vala"
				_p_it = _tmp5_;
#line 1047 "../src/worm.vala"
				while (TRUE) {
#line 5255 "worm.c"
					AngleIterator* _tmp6_;
					SignedPosition p = {0};
					AngleIterator* _tmp7_;
					SignedPosition _tmp8_ = {0};
					gint64 _tmp9_;
					GeeArrayList* _tmp10_;
#line 1047 "../src/worm.vala"
					_tmp6_ = _p_it;
#line 1047 "../src/worm.vala"
					if (!angle_iterator_next (_tmp6_)) {
#line 1047 "../src/worm.vala"
						break;
#line 5268 "worm.c"
					}
#line 1047 "../src/worm.vala"
					_tmp7_ = _p_it;
#line 1047 "../src/worm.vala"
					angle_iterator_get (_tmp7_, &_tmp8_);
#line 1047 "../src/worm.vala"
					p = _tmp8_;
#line 1049 "../src/worm.vala"
					_tmp9_ = distance;
#line 1049 "../src/worm.vala"
					distance = _tmp9_ + 1;
#line 1050 "../src/worm.vala"
					_tmp10_ = checked_positions;
#line 1050 "../src/worm.vala"
					if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp10_, (gpointer) ((guintptr) signed_position_wrap_xy (&p)))) {
#line 1052 "../src/worm.vala"
						if (slice_is_bonus_at (self, signed_position_wrap_x (&p), signed_position_wrap_y (&p), bonus)) {
#line 5286 "worm.c"
							gint64 _tmp11_ = 0LL;
#line 1054 "../src/worm.vala"
							if (angle_step_along_x (&self->min)) {
#line 5290 "worm.c"
								Position _tmp12_;
								SignedPosition _tmp13_;
#line 1054 "../src/worm.vala"
								_tmp12_ = *origin;
#line 1054 "../src/worm.vala"
								_tmp13_ = p;
#line 1054 "../src/worm.vala"
								_tmp11_ = distance + llabs (_tmp12_.y - _tmp13_.y);
#line 5299 "worm.c"
							} else {
								Position _tmp14_;
								SignedPosition _tmp15_;
#line 1055 "../src/worm.vala"
								_tmp14_ = *origin;
#line 1055 "../src/worm.vala"
								_tmp15_ = p;
#line 1055 "../src/worm.vala"
								_tmp11_ = distance + llabs (_tmp14_.x - _tmp15_.x);
#line 5309 "worm.c"
							}
#line 1054 "../src/worm.vala"
							result = _tmp11_;
#line 1054 "../src/worm.vala"
							_angle_iterator_unref0 (_p_it);
#line 1054 "../src/worm.vala"
							_g_object_unref0 (checked_positions);
#line 1054 "../src/worm.vala"
							return result;
#line 5319 "worm.c"
						} else {
							gboolean _tmp16_ = FALSE;
							gint _tmp17_ = 0;
#line 1057 "../src/worm.vala"
							if (angle_step_along_x (&self->min)) {
#line 5325 "worm.c"
								gint _tmp18_;
#line 1057 "../src/worm.vala"
								_tmp18_ = board_length1;
#line 1057 "../src/worm.vala"
								_tmp17_ = _tmp18_;
#line 5331 "worm.c"
							} else {
								gint _tmp19_;
#line 1057 "../src/worm.vala"
								_tmp19_ = board_length2;
#line 1057 "../src/worm.vala"
								_tmp17_ = _tmp19_;
#line 5338 "worm.c"
							}
#line 1057 "../src/worm.vala"
							if (distance > ((gint64) (_tmp17_ * 2))) {
#line 1057 "../src/worm.vala"
								_tmp16_ = TRUE;
#line 5344 "worm.c"
							} else {
								Position _tmp20_ = {0};
#line 1058 "../src/worm.vala"
								_tmp20_.x = signed_position_wrap_x (&p);
#line 1058 "../src/worm.vala"
								_tmp20_.y = signed_position_wrap_y (&p);
#line 1058 "../src/worm.vala"
								_tmp16_ = slice_is_position_occupied (self, &_tmp20_, board, (gint) board_length1, (gint) board_length2, worm_map);
#line 5353 "worm.c"
							}
#line 1057 "../src/worm.vala"
							if (_tmp16_) {
#line 5357 "worm.c"
								GeeArrayList* _tmp21_;
								Slice* s = NULL;
								Slice* _tmp22_;
								Slice* _tmp23_;
								Position _tmp24_;
								SignedPosition _tmp25_;
								SignedPosition _tmp26_;
								Slice* _tmp27_;
								Angle _tmp28_;
#line 1060 "../src/worm.vala"
								_tmp21_ = checked_positions;
#line 1060 "../src/worm.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, (gpointer) ((guintptr) signed_position_wrap_xy (&p)));
#line 1062 "../src/worm.vala"
								_tmp22_ = slice_new (NULL);
#line 1062 "../src/worm.vala"
								s = _tmp22_;
#line 1063 "../src/worm.vala"
								_tmp23_ = s;
#line 1063 "../src/worm.vala"
								_tmp24_ = *origin;
#line 1063 "../src/worm.vala"
								_tmp25_ = p;
#line 1063 "../src/worm.vala"
								_tmp26_ = p;
#line 1063 "../src/worm.vala"
								slice_set_from_position (_tmp23_, &_tmp24_, _tmp25_.x, _tmp26_.y, 1);
#line 1064 "../src/worm.vala"
								_tmp27_ = s;
#line 1064 "../src/worm.vala"
								_tmp28_ = _tmp27_->max;
#line 1064 "../src/worm.vala"
								angle_assign (&self->min, &_tmp28_);
#line 1065 "../src/worm.vala"
								_g_object_unref0 (s);
#line 1065 "../src/worm.vala"
								break;
#line 5395 "worm.c"
							}
						}
					}
				}
#line 1047 "../src/worm.vala"
				_angle_iterator_unref0 (_p_it);
#line 5402 "worm.c"
			}
		}
	}
#line 1070 "../src/worm.vala"
	result = G_MAXINT64;
#line 1070 "../src/worm.vala"
	_g_object_unref0 (checked_positions);
#line 1070 "../src/worm.vala"
	return result;
#line 5412 "worm.c"
}

static void
slice_class_init (SliceClass * klass,
                  gpointer klass_data)
{
#line 804 "../src/worm.vala"
	slice_parent_class = g_type_class_peek_parent (klass);
#line 804 "../src/worm.vala"
	g_type_class_adjust_private_offset (klass, &Slice_private_offset);
#line 804 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->finalize = slice_finalize;
#line 5425 "worm.c"
}

static void
slice_instance_init (Slice * self,
                     gpointer klass)
{
#line 804 "../src/worm.vala"
	self->priv = slice_get_instance_private (self);
#line 5434 "worm.c"
}

static void
slice_finalize (GObject * obj)
{
	Slice * self;
#line 804 "../src/worm.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SLICE, Slice);
#line 804 "../src/worm.vala"
	G_OBJECT_CLASS (slice_parent_class)->finalize (obj);
#line 5445 "worm.c"
}

 G_GNUC_NO_INLINE static GType
slice_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SliceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) slice_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Slice), 0, (GInstanceInitFunc) slice_instance_init, NULL };
	GType slice_type_id;
	slice_type_id = g_type_register_static (G_TYPE_OBJECT, "Slice", &g_define_type_info, 0);
	Slice_private_offset = g_type_add_instance_private (slice_type_id, sizeof (SlicePrivate));
	return slice_type_id;
}

GType
slice_get_type (void)
{
	static gsize slice_type_id__once = 0;
	if (g_once_init_enter (&slice_type_id__once)) {
		GType slice_type_id;
		slice_type_id = slice_get_type_once ();
		g_once_init_leave (&slice_type_id__once, slice_type_id);
	}
	return slice_type_id__once;
}

static inline gpointer
worm_properties_get_instance_private (WormProperties* self)
{
	return G_STRUCT_MEMBER_P (self, WormProperties_private_offset);
}

WormProperties*
worm_properties_construct (GType object_type)
{
	WormProperties * self = NULL;
#line 1074 "../src/worm.vala"
	self = (WormProperties*) g_object_new (object_type, NULL);
#line 1074 "../src/worm.vala"
	return self;
#line 5484 "worm.c"
}

WormProperties*
worm_properties_new (void)
{
#line 1074 "../src/worm.vala"
	return worm_properties_construct (TYPE_WORM_PROPERTIES);
#line 5492 "worm.c"
}

gint
worm_properties_get_color (WormProperties* self)
{
	gint result;
#line 1076 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1076 "../src/worm.vala"
	result = self->priv->_color;
#line 1076 "../src/worm.vala"
	return result;
#line 5505 "worm.c"
}

void
worm_properties_set_color (WormProperties* self,
                           gint value)
{
	gint old_value;
#line 1076 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1076 "../src/worm.vala"
	old_value = worm_properties_get_color (self);
#line 1076 "../src/worm.vala"
	if (old_value != value) {
#line 1076 "../src/worm.vala"
		self->priv->_color = value;
#line 1076 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_COLOR_PROPERTY]);
#line 5523 "worm.c"
	}
}

guint
worm_properties_get_up (WormProperties* self)
{
	guint result;
#line 1077 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1077 "../src/worm.vala"
	result = self->priv->_up;
#line 1077 "../src/worm.vala"
	return result;
#line 5537 "worm.c"
}

void
worm_properties_set_up (WormProperties* self,
                        guint value)
{
	guint old_value;
#line 1077 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1077 "../src/worm.vala"
	old_value = worm_properties_get_up (self);
#line 1077 "../src/worm.vala"
	if (old_value != value) {
#line 1077 "../src/worm.vala"
		self->priv->_up = value;
#line 1077 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_UP_PROPERTY]);
#line 5555 "worm.c"
	}
}

guint
worm_properties_get_down (WormProperties* self)
{
	guint result;
#line 1078 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1078 "../src/worm.vala"
	result = self->priv->_down;
#line 1078 "../src/worm.vala"
	return result;
#line 5569 "worm.c"
}

void
worm_properties_set_down (WormProperties* self,
                          guint value)
{
	guint old_value;
#line 1078 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1078 "../src/worm.vala"
	old_value = worm_properties_get_down (self);
#line 1078 "../src/worm.vala"
	if (old_value != value) {
#line 1078 "../src/worm.vala"
		self->priv->_down = value;
#line 1078 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_DOWN_PROPERTY]);
#line 5587 "worm.c"
	}
}

guint
worm_properties_get_left (WormProperties* self)
{
	guint result;
#line 1079 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1079 "../src/worm.vala"
	result = self->priv->_left;
#line 1079 "../src/worm.vala"
	return result;
#line 5601 "worm.c"
}

void
worm_properties_set_left (WormProperties* self,
                          guint value)
{
	guint old_value;
#line 1079 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1079 "../src/worm.vala"
	old_value = worm_properties_get_left (self);
#line 1079 "../src/worm.vala"
	if (old_value != value) {
#line 1079 "../src/worm.vala"
		self->priv->_left = value;
#line 1079 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_LEFT_PROPERTY]);
#line 5619 "worm.c"
	}
}

guint
worm_properties_get_right (WormProperties* self)
{
	guint result;
#line 1080 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1080 "../src/worm.vala"
	result = self->priv->_right;
#line 1080 "../src/worm.vala"
	return result;
#line 5633 "worm.c"
}

void
worm_properties_set_right (WormProperties* self,
                           guint value)
{
	guint old_value;
#line 1080 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1080 "../src/worm.vala"
	old_value = worm_properties_get_right (self);
#line 1080 "../src/worm.vala"
	if (old_value != value) {
#line 1080 "../src/worm.vala"
		self->priv->_right = value;
#line 1080 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_RIGHT_PROPERTY]);
#line 5651 "worm.c"
	}
}

gint
worm_properties_get_raw_up (WormProperties* self)
{
	gint result;
#line 1081 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1081 "../src/worm.vala"
	result = self->priv->_raw_up;
#line 1081 "../src/worm.vala"
	return result;
#line 5665 "worm.c"
}

void
worm_properties_set_raw_up (WormProperties* self,
                            gint value)
{
	gint old_value;
#line 1081 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1081 "../src/worm.vala"
	old_value = worm_properties_get_raw_up (self);
#line 1081 "../src/worm.vala"
	if (old_value != value) {
#line 1081 "../src/worm.vala"
		self->priv->_raw_up = value;
#line 1081 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_RAW_UP_PROPERTY]);
#line 5683 "worm.c"
	}
}

gint
worm_properties_get_raw_down (WormProperties* self)
{
	gint result;
#line 1082 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1082 "../src/worm.vala"
	result = self->priv->_raw_down;
#line 1082 "../src/worm.vala"
	return result;
#line 5697 "worm.c"
}

void
worm_properties_set_raw_down (WormProperties* self,
                              gint value)
{
	gint old_value;
#line 1082 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1082 "../src/worm.vala"
	old_value = worm_properties_get_raw_down (self);
#line 1082 "../src/worm.vala"
	if (old_value != value) {
#line 1082 "../src/worm.vala"
		self->priv->_raw_down = value;
#line 1082 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_RAW_DOWN_PROPERTY]);
#line 5715 "worm.c"
	}
}

gint
worm_properties_get_raw_left (WormProperties* self)
{
	gint result;
#line 1083 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1083 "../src/worm.vala"
	result = self->priv->_raw_left;
#line 1083 "../src/worm.vala"
	return result;
#line 5729 "worm.c"
}

void
worm_properties_set_raw_left (WormProperties* self,
                              gint value)
{
	gint old_value;
#line 1083 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1083 "../src/worm.vala"
	old_value = worm_properties_get_raw_left (self);
#line 1083 "../src/worm.vala"
	if (old_value != value) {
#line 1083 "../src/worm.vala"
		self->priv->_raw_left = value;
#line 1083 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_RAW_LEFT_PROPERTY]);
#line 5747 "worm.c"
	}
}

gint
worm_properties_get_raw_right (WormProperties* self)
{
	gint result;
#line 1084 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1084 "../src/worm.vala"
	result = self->priv->_raw_right;
#line 1084 "../src/worm.vala"
	return result;
#line 5761 "worm.c"
}

void
worm_properties_set_raw_right (WormProperties* self,
                               gint value)
{
	gint old_value;
#line 1084 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1084 "../src/worm.vala"
	old_value = worm_properties_get_raw_right (self);
#line 1084 "../src/worm.vala"
	if (old_value != value) {
#line 1084 "../src/worm.vala"
		self->priv->_raw_right = value;
#line 1084 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_RAW_RIGHT_PROPERTY]);
#line 5779 "worm.c"
	}
}

static void
worm_properties_class_init (WormPropertiesClass * klass,
                            gpointer klass_data)
{
#line 1074 "../src/worm.vala"
	worm_properties_parent_class = g_type_class_peek_parent (klass);
#line 1074 "../src/worm.vala"
	g_type_class_adjust_private_offset (klass, &WormProperties_private_offset);
#line 1074 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_worm_properties_get_property;
#line 1074 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_worm_properties_set_property;
#line 1074 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->finalize = worm_properties_finalize;
#line 1074 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_COLOR_PROPERTY, worm_properties_properties[WORM_PROPERTIES_COLOR_PROPERTY] = g_param_spec_int ("color", "color", "color", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1074 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_UP_PROPERTY, worm_properties_properties[WORM_PROPERTIES_UP_PROPERTY] = g_param_spec_uint ("up", "up", "up", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1074 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_DOWN_PROPERTY, worm_properties_properties[WORM_PROPERTIES_DOWN_PROPERTY] = g_param_spec_uint ("down", "down", "down", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1074 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_LEFT_PROPERTY, worm_properties_properties[WORM_PROPERTIES_LEFT_PROPERTY] = g_param_spec_uint ("left", "left", "left", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1074 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_RIGHT_PROPERTY, worm_properties_properties[WORM_PROPERTIES_RIGHT_PROPERTY] = g_param_spec_uint ("right", "right", "right", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1074 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_RAW_UP_PROPERTY, worm_properties_properties[WORM_PROPERTIES_RAW_UP_PROPERTY] = g_param_spec_int ("raw-up", "raw-up", "raw-up", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1074 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_RAW_DOWN_PROPERTY, worm_properties_properties[WORM_PROPERTIES_RAW_DOWN_PROPERTY] = g_param_spec_int ("raw-down", "raw-down", "raw-down", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1074 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_RAW_LEFT_PROPERTY, worm_properties_properties[WORM_PROPERTIES_RAW_LEFT_PROPERTY] = g_param_spec_int ("raw-left", "raw-left", "raw-left", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1074 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_RAW_RIGHT_PROPERTY, worm_properties_properties[WORM_PROPERTIES_RAW_RIGHT_PROPERTY] = g_param_spec_int ("raw-right", "raw-right", "raw-right", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5815 "worm.c"
}

static void
worm_properties_instance_init (WormProperties * self,
                               gpointer klass)
{
#line 1074 "../src/worm.vala"
	self->priv = worm_properties_get_instance_private (self);
#line 5824 "worm.c"
}

static void
worm_properties_finalize (GObject * obj)
{
	WormProperties * self;
#line 1074 "../src/worm.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WORM_PROPERTIES, WormProperties);
#line 1074 "../src/worm.vala"
	G_OBJECT_CLASS (worm_properties_parent_class)->finalize (obj);
#line 5835 "worm.c"
}

 G_GNUC_NO_INLINE static GType
worm_properties_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WormPropertiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) worm_properties_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WormProperties), 0, (GInstanceInitFunc) worm_properties_instance_init, NULL };
	GType worm_properties_type_id;
	worm_properties_type_id = g_type_register_static (G_TYPE_OBJECT, "WormProperties", &g_define_type_info, 0);
	WormProperties_private_offset = g_type_add_instance_private (worm_properties_type_id, sizeof (WormPropertiesPrivate));
	return worm_properties_type_id;
}

GType
worm_properties_get_type (void)
{
	static gsize worm_properties_type_id__once = 0;
	if (g_once_init_enter (&worm_properties_type_id__once)) {
		GType worm_properties_type_id;
		worm_properties_type_id = worm_properties_get_type_once ();
		g_once_init_leave (&worm_properties_type_id__once, worm_properties_type_id);
	}
	return worm_properties_type_id__once;
}

static void
_vala_worm_properties_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	WormProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM_PROPERTIES, WormProperties);
#line 1074 "../src/worm.vala"
	switch (property_id) {
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_COLOR_PROPERTY:
#line 1074 "../src/worm.vala"
		g_value_set_int (value, worm_properties_get_color (self));
#line 1074 "../src/worm.vala"
		break;
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_UP_PROPERTY:
#line 1074 "../src/worm.vala"
		g_value_set_uint (value, worm_properties_get_up (self));
#line 1074 "../src/worm.vala"
		break;
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_DOWN_PROPERTY:
#line 1074 "../src/worm.vala"
		g_value_set_uint (value, worm_properties_get_down (self));
#line 1074 "../src/worm.vala"
		break;
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_LEFT_PROPERTY:
#line 1074 "../src/worm.vala"
		g_value_set_uint (value, worm_properties_get_left (self));
#line 1074 "../src/worm.vala"
		break;
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_RIGHT_PROPERTY:
#line 1074 "../src/worm.vala"
		g_value_set_uint (value, worm_properties_get_right (self));
#line 1074 "../src/worm.vala"
		break;
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_RAW_UP_PROPERTY:
#line 1074 "../src/worm.vala"
		g_value_set_int (value, worm_properties_get_raw_up (self));
#line 1074 "../src/worm.vala"
		break;
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_RAW_DOWN_PROPERTY:
#line 1074 "../src/worm.vala"
		g_value_set_int (value, worm_properties_get_raw_down (self));
#line 1074 "../src/worm.vala"
		break;
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_RAW_LEFT_PROPERTY:
#line 1074 "../src/worm.vala"
		g_value_set_int (value, worm_properties_get_raw_left (self));
#line 1074 "../src/worm.vala"
		break;
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_RAW_RIGHT_PROPERTY:
#line 1074 "../src/worm.vala"
		g_value_set_int (value, worm_properties_get_raw_right (self));
#line 1074 "../src/worm.vala"
		break;
#line 5924 "worm.c"
		default:
#line 1074 "../src/worm.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1074 "../src/worm.vala"
		break;
#line 5930 "worm.c"
	}
}

static void
_vala_worm_properties_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	WormProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM_PROPERTIES, WormProperties);
#line 1074 "../src/worm.vala"
	switch (property_id) {
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_COLOR_PROPERTY:
#line 1074 "../src/worm.vala"
		worm_properties_set_color (self, g_value_get_int (value));
#line 1074 "../src/worm.vala"
		break;
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_UP_PROPERTY:
#line 1074 "../src/worm.vala"
		worm_properties_set_up (self, g_value_get_uint (value));
#line 1074 "../src/worm.vala"
		break;
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_DOWN_PROPERTY:
#line 1074 "../src/worm.vala"
		worm_properties_set_down (self, g_value_get_uint (value));
#line 1074 "../src/worm.vala"
		break;
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_LEFT_PROPERTY:
#line 1074 "../src/worm.vala"
		worm_properties_set_left (self, g_value_get_uint (value));
#line 1074 "../src/worm.vala"
		break;
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_RIGHT_PROPERTY:
#line 1074 "../src/worm.vala"
		worm_properties_set_right (self, g_value_get_uint (value));
#line 1074 "../src/worm.vala"
		break;
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_RAW_UP_PROPERTY:
#line 1074 "../src/worm.vala"
		worm_properties_set_raw_up (self, g_value_get_int (value));
#line 1074 "../src/worm.vala"
		break;
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_RAW_DOWN_PROPERTY:
#line 1074 "../src/worm.vala"
		worm_properties_set_raw_down (self, g_value_get_int (value));
#line 1074 "../src/worm.vala"
		break;
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_RAW_LEFT_PROPERTY:
#line 1074 "../src/worm.vala"
		worm_properties_set_raw_left (self, g_value_get_int (value));
#line 1074 "../src/worm.vala"
		break;
#line 1074 "../src/worm.vala"
		case WORM_PROPERTIES_RAW_RIGHT_PROPERTY:
#line 1074 "../src/worm.vala"
		worm_properties_set_raw_right (self, g_value_get_int (value));
#line 1074 "../src/worm.vala"
		break;
#line 5998 "worm.c"
		default:
#line 1074 "../src/worm.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1074 "../src/worm.vala"
		break;
#line 6004 "worm.c"
	}
}

gboolean
worm_positions_append_position (WormPositions* self,
                                Position* p)
{
	Position _tmp0_;
	Position _tmp1_;
	gboolean result;
#line 1089 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1089 "../src/worm.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 1091 "../src/worm.vala"
	_tmp0_ = *p;
#line 1091 "../src/worm.vala"
	_tmp1_ = *p;
#line 1091 "../src/worm.vala"
	result = gee_abstract_collection_add ((GeeAbstractCollection*) self, (gpointer) ((guintptr) ((((guint16) _tmp0_.x) << 8) | _tmp1_.y)));
#line 1091 "../src/worm.vala"
	return result;
#line 6027 "worm.c"
}

void
worm_positions_get_head (WormPositions* self,
                         Position* result)
{
	guint16 head = 0U;
	gpointer _tmp0_;
	Position _tmp1_ = {0};
#line 1093 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1095 "../src/worm.vala"
	_tmp0_ = gee_linked_list_first ((GeeLinkedList*) self);
#line 1095 "../src/worm.vala"
	head = (guint16) ((guintptr) _tmp0_);
#line 1096 "../src/worm.vala"
	_tmp1_.x = (guint8) (head >> 8);
#line 1096 "../src/worm.vala"
	_tmp1_.y = (guint8) head;
#line 1096 "../src/worm.vala"
	*result = _tmp1_;
#line 1096 "../src/worm.vala"
	return;
#line 6051 "worm.c"
}

void
worm_positions_set_head (WormPositions* self,
                         Position* p)
{
	Position _tmp0_;
	Position _tmp1_;
#line 1098 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1098 "../src/worm.vala"
	g_return_if_fail (p != NULL);
#line 1100 "../src/worm.vala"
	_tmp0_ = *p;
#line 1100 "../src/worm.vala"
	_tmp1_ = *p;
#line 1100 "../src/worm.vala"
	gee_abstract_list_set ((GeeAbstractList*) self, 0, (gpointer) ((guintptr) ((((guint16) _tmp0_.x) << 8) | _tmp1_.y)));
#line 6070 "worm.c"
}

gboolean
worm_positions_prepend_position (WormPositions* self,
                                 Position* p)
{
	gint _tmp0_;
	gint _tmp1_;
	gboolean result;
#line 1102 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1102 "../src/worm.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 1104 "../src/worm.vala"
	_tmp0_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) self);
#line 1104 "../src/worm.vala"
	_tmp1_ = _tmp0_;
#line 1104 "../src/worm.vala"
	if (_tmp1_ > 0) {
#line 6090 "worm.c"
		Position _tmp2_;
		Position _tmp3_;
#line 1105 "../src/worm.vala"
		_tmp2_ = *p;
#line 1105 "../src/worm.vala"
		_tmp3_ = *p;
#line 1105 "../src/worm.vala"
		result = gee_deque_offer_head ((GeeDeque*) self, (gpointer) ((guintptr) ((((guint16) _tmp2_.x) << 8) | _tmp3_.y)));
#line 1105 "../src/worm.vala"
		return result;
#line 6101 "worm.c"
	} else {
		Position _tmp4_;
#line 1107 "../src/worm.vala"
		_tmp4_ = *p;
#line 1107 "../src/worm.vala"
		result = worm_positions_append_position (self, &_tmp4_);
#line 1107 "../src/worm.vala"
		return result;
#line 6110 "worm.c"
	}
}

void
worm_positions_remove_tail (WormPositions* self,
                            Position* result)
{
	guint16 tail = 0U;
	gpointer _tmp0_;
	Position _tmp1_ = {0};
#line 1109 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1111 "../src/worm.vala"
	_tmp0_ = gee_deque_poll_tail ((GeeDeque*) self);
#line 1111 "../src/worm.vala"
	tail = (guint16) ((guintptr) _tmp0_);
#line 1112 "../src/worm.vala"
	_tmp1_.x = (guint8) (tail >> 8);
#line 1112 "../src/worm.vala"
	_tmp1_.y = (guint8) tail;
#line 1112 "../src/worm.vala"
	*result = _tmp1_;
#line 1112 "../src/worm.vala"
	return;
#line 6135 "worm.c"
}

WormPositions*
worm_positions_construct (GType object_type)
{
	WormPositions * self = NULL;
#line 1087 "../src/worm.vala"
	self = (WormPositions*) gee_linked_list_construct (object_type, G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL);
#line 1087 "../src/worm.vala"
	return self;
#line 6146 "worm.c"
}

WormPositions*
worm_positions_new (void)
{
#line 1087 "../src/worm.vala"
	return worm_positions_construct (TYPE_WORM_POSITIONS);
#line 6154 "worm.c"
}

static void
worm_positions_class_init (WormPositionsClass * klass,
                           gpointer klass_data)
{
#line 1087 "../src/worm.vala"
	worm_positions_parent_class = g_type_class_peek_parent (klass);
#line 6163 "worm.c"
}

static void
worm_positions_instance_init (WormPositions * self,
                              gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
worm_positions_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WormPositionsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) worm_positions_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WormPositions), 0, (GInstanceInitFunc) worm_positions_instance_init, NULL };
	GType worm_positions_type_id;
	worm_positions_type_id = g_type_register_static (GEE_TYPE_LINKED_LIST, "WormPositions", &g_define_type_info, 0);
	return worm_positions_type_id;
}

GType
worm_positions_get_type (void)
{
	static gsize worm_positions_type_id__once = 0;
	if (g_once_init_enter (&worm_positions_type_id__once)) {
		GType worm_positions_type_id;
		worm_positions_type_id = worm_positions_get_type_once ();
		g_once_init_leave (&worm_positions_type_id__once, worm_positions_type_id);
	}
	return worm_positions_type_id__once;
}

static inline gpointer
worm_get_instance_private (Worm* self)
{
	return G_STRUCT_MEMBER_P (self, Worm_private_offset);
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 1186 "../src/worm.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 1186 "../src/worm.vala"
	return _data11_;
#line 6206 "worm.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 1186 "../src/worm.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 6216 "worm.c"
		Worm* self;
#line 1186 "../src/worm.vala"
		self = _data11_->self;
#line 1186 "../src/worm.vala"
		_g_object_unref0 (self);
#line 1186 "../src/worm.vala"
		g_slice_free (Block11Data, _data11_);
#line 6224 "worm.c"
	}
}

static GeeList*
__lambda4_ (Block11Data* _data11_,
            Worm* worm)
{
	Worm* self;
	GeeList* _tmp0_;
	GeeList* result;
#line 1190 "../src/worm.vala"
	self = _data11_->self;
#line 1190 "../src/worm.vala"
	g_return_val_if_fail (worm != NULL, NULL);
#line 1190 "../src/worm.vala"
	_tmp0_ = _data11_->cb0 (worm, _data11_->cb0_target);
#line 1190 "../src/worm.vala"
	result = _tmp0_;
#line 1190 "../src/worm.vala"
	return result;
#line 6245 "worm.c"
}

static GeeList*
___lambda4__worm_get_other_worms_type (Worm* _self_,
                                       gpointer self)
{
	GeeList* result;
	result = __lambda4_ (self, _self_);
#line 1190 "../src/worm.vala"
	return result;
#line 6256 "worm.c"
}

static GeeList*
__lambda5_ (Block11Data* _data11_)
{
	Worm* self;
	GeeList* _tmp0_;
	GeeList* result;
#line 1191 "../src/worm.vala"
	self = _data11_->self;
#line 1191 "../src/worm.vala"
	_tmp0_ = _data11_->cb1 (_data11_->cb1_target);
#line 1191 "../src/worm.vala"
	result = _tmp0_;
#line 1191 "../src/worm.vala"
	return result;
#line 6273 "worm.c"
}

static GeeList*
___lambda5__worm_get_bonuses_type (gpointer self)
{
	GeeList* result;
	result = __lambda5_ (self);
#line 1191 "../src/worm.vala"
	return result;
#line 6283 "worm.c"
}

Worm*
worm_construct (GType object_type,
                gint id,
                guint8 width,
                guint8 height,
                WormGetOtherWormsType cb0,
                gpointer cb0_target,
                WormGetBonusesType cb1,
                gpointer cb1_target)
{
	Worm * self = NULL;
	Block11Data* _data11_;
	gint capacity = 0;
#line 1186 "../src/worm.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 1186 "../src/worm.vala"
	_data11_->_ref_count_ = 1;
#line 1186 "../src/worm.vala"
	_data11_->cb0 = cb0;
#line 1186 "../src/worm.vala"
	_data11_->cb0_target = cb0_target;
#line 1186 "../src/worm.vala"
	_data11_->cb1 = cb1;
#line 1186 "../src/worm.vala"
	_data11_->cb1_target = cb1_target;
#line 1188 "../src/worm.vala"
	capacity = (gint) (width * height);
#line 1189 "../src/worm.vala"
	self = (Worm*) g_object_new (object_type, "id", id, "width", width, "height", height, "capacity", capacity, NULL);
#line 1189 "../src/worm.vala"
	_data11_->self = g_object_ref (self);
#line 1190 "../src/worm.vala"
	(self->priv->get_other_worms_target_destroy_notify == NULL) ? NULL : (self->priv->get_other_worms_target_destroy_notify (self->priv->get_other_worms_target), NULL);
#line 1190 "../src/worm.vala"
	self->priv->get_other_worms = NULL;
#line 1190 "../src/worm.vala"
	self->priv->get_other_worms_target = NULL;
#line 1190 "../src/worm.vala"
	self->priv->get_other_worms_target_destroy_notify = NULL;
#line 1190 "../src/worm.vala"
	self->priv->get_other_worms = ___lambda4__worm_get_other_worms_type;
#line 1190 "../src/worm.vala"
	self->priv->get_other_worms_target = block11_data_ref (_data11_);
#line 1190 "../src/worm.vala"
	self->priv->get_other_worms_target_destroy_notify = block11_data_unref;
#line 1191 "../src/worm.vala"
	(self->priv->get_bonuses_target_destroy_notify == NULL) ? NULL : (self->priv->get_bonuses_target_destroy_notify (self->priv->get_bonuses_target), NULL);
#line 1191 "../src/worm.vala"
	self->priv->get_bonuses = NULL;
#line 1191 "../src/worm.vala"
	self->priv->get_bonuses_target = NULL;
#line 1191 "../src/worm.vala"
	self->priv->get_bonuses_target_destroy_notify = NULL;
#line 1191 "../src/worm.vala"
	self->priv->get_bonuses = ___lambda5__worm_get_bonuses_type;
#line 1191 "../src/worm.vala"
	self->priv->get_bonuses_target = block11_data_ref (_data11_);
#line 1191 "../src/worm.vala"
	self->priv->get_bonuses_target_destroy_notify = block11_data_unref;
#line 1186 "../src/worm.vala"
	block11_data_unref (_data11_);
#line 1186 "../src/worm.vala"
	_data11_ = NULL;
#line 1186 "../src/worm.vala"
	return self;
#line 6351 "worm.c"
}

Worm*
worm_new (gint id,
          guint8 width,
          guint8 height,
          WormGetOtherWormsType cb0,
          gpointer cb0_target,
          WormGetBonusesType cb1,
          gpointer cb1_target)
{
#line 1186 "../src/worm.vala"
	return worm_construct (TYPE_WORM, id, width, height, cb0, cb0_target, cb1, cb1_target);
#line 6365 "worm.c"
}

void
worm_set_start (Worm* self,
                guint8 x,
                guint8 y,
                WormDirection direction)
{
	WormPositions* _tmp0_;
	GeeArrayList* _tmp1_;
	Position _tmp2_ = {0};
	WormPositions* _tmp3_;
	Position _tmp4_;
	GeeArrayQueue* _tmp5_;
#line 1194 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1196 "../src/worm.vala"
	_tmp0_ = self->list;
#line 1196 "../src/worm.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 1198 "../src/worm.vala"
	_tmp1_ = self->priv->bonus_eaten;
#line 1198 "../src/worm.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
#line 1200 "../src/worm.vala"
	_tmp2_.x = x;
#line 1200 "../src/worm.vala"
	_tmp2_.y = y;
#line 1200 "../src/worm.vala"
	worm_set_starting_position (self, &_tmp2_);
#line 1201 "../src/worm.vala"
	_tmp3_ = self->list;
#line 1201 "../src/worm.vala"
	_tmp4_ = self->priv->_starting_position;
#line 1201 "../src/worm.vala"
	worm_positions_append_position (_tmp3_, &_tmp4_);
#line 1203 "../src/worm.vala"
	self->priv->starting_direction = direction;
#line 1204 "../src/worm.vala"
	worm_set_direction (self, direction);
#line 1205 "../src/worm.vala"
	worm_set_change (self, 0);
#line 1206 "../src/worm.vala"
	_tmp5_ = self->priv->key_queue;
#line 1206 "../src/worm.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp5_);
#line 6412 "worm.c"
}

void
worm_move_part_1 (Worm* self)
{
	Position position = {0};
	Position _tmp0_ = {0};
	Position _tmp1_;
	WormDirection _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	WormPositions* _tmp5_;
	Position _tmp6_;
#line 1209 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1211 "../src/worm.vala"
	if (self->is_human) {
#line 1212 "../src/worm.vala"
		self->keypress = FALSE;
#line 6432 "worm.c"
	}
#line 1214 "../src/worm.vala"
	worm_get_head (self, &_tmp0_);
#line 1214 "../src/worm.vala"
	_tmp1_ = _tmp0_;
#line 1214 "../src/worm.vala"
	position = _tmp1_;
#line 1215 "../src/worm.vala"
	_tmp2_ = self->priv->_direction;
#line 1215 "../src/worm.vala"
	_tmp3_ = self->priv->_width;
#line 1215 "../src/worm.vala"
	_tmp4_ = self->priv->_height;
#line 1215 "../src/worm.vala"
	position_move (&position, _tmp2_, _tmp3_, _tmp4_);
#line 1218 "../src/worm.vala"
	_tmp5_ = self->list;
#line 1218 "../src/worm.vala"
	_tmp6_ = position;
#line 1218 "../src/worm.vala"
	worm_positions_prepend_position (_tmp5_, &_tmp6_);
#line 6454 "worm.c"
}

void
worm_move_part_2 (Worm* self,
                  gint* board,
                  gint board_length1,
                  gint board_length2,
                  Position* head_position)
{
	gint _tmp1_;
	GeeArrayQueue* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
#line 1221 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1223 "../src/worm.vala"
	if (head_position != NULL) {
#line 6472 "worm.c"
		Position _tmp0_ = {0};
#line 1224 "../src/worm.vala"
		memset (&_tmp0_, 0, sizeof (Position));
#line 1224 "../src/worm.vala"
		_tmp0_.x = (*head_position).x;
#line 1224 "../src/worm.vala"
		_tmp0_.y = (*head_position).y;
#line 1224 "../src/worm.vala"
		worm_set_head (self, &_tmp0_);
#line 6482 "worm.c"
	}
#line 1226 "../src/worm.vala"
	_tmp1_ = self->priv->_change;
#line 1226 "../src/worm.vala"
	if (_tmp1_ > 0) {
#line 6488 "worm.c"
		gint _tmp2_;
#line 1229 "../src/worm.vala"
		_tmp2_ = self->priv->_change;
#line 1229 "../src/worm.vala"
		worm_set_change (self, _tmp2_ - 1);
#line 6494 "worm.c"
	} else {
		WormPositions* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		WormPositions* _tmp6_;
		Position _tmp7_ = {0};
#line 1234 "../src/worm.vala"
		_tmp3_ = self->list;
#line 1234 "../src/worm.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 1234 "../src/worm.vala"
		_tmp5_ = _tmp4_;
#line 1234 "../src/worm.vala"
		_vala_assert (_tmp5_ > 0, "list.size > 0");
#line 1235 "../src/worm.vala"
		_tmp6_ = self->list;
#line 1235 "../src/worm.vala"
		worm_positions_remove_tail (_tmp6_, &_tmp7_);
#line 1235 "../src/worm.vala"
		worm_remove_bonus_eaten_position (self, &_tmp7_);
#line 6515 "worm.c"
	}
#line 1239 "../src/worm.vala"
	g_signal_emit (self, worm_signals[WORM_BONUS_FOUND_SIGNAL], 0);
#line 1242 "../src/worm.vala"
	if (self->priv->rounds_to_stay_dematerialized > 1) {
#line 1243 "../src/worm.vala"
		self->priv->rounds_to_stay_dematerialized = self->priv->rounds_to_stay_dematerialized - 1;
#line 6523 "worm.c"
	}
#line 1245 "../src/worm.vala"
	_tmp8_ = self->priv->key_queue;
#line 1245 "../src/worm.vala"
	_tmp9_ = gee_array_queue_get_is_empty (_tmp8_);
#line 1245 "../src/worm.vala"
	_tmp10_ = _tmp9_;
#line 1245 "../src/worm.vala"
	if (!_tmp10_) {
#line 1246 "../src/worm.vala"
		worm_dequeue_keypress (self);
#line 6535 "worm.c"
	}
#line 1249 "../src/worm.vala"
	if (self->priv->rounds_to_stay_dematerialized == 1) {
#line 1250 "../src/worm.vala"
		worm_materialize (self, board, (gint) board_length1, (gint) board_length2);
#line 6541 "worm.c"
	}
}

void
worm_remove_bonus_eaten_position (Worm* self,
                                  Position* p)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 1253 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1253 "../src/worm.vala"
	g_return_if_fail (p != NULL);
#line 1255 "../src/worm.vala"
	_tmp0_ = self->priv->bonus_eaten;
#line 1255 "../src/worm.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 1255 "../src/worm.vala"
	_tmp2_ = _tmp1_;
#line 1255 "../src/worm.vala"
	if (_tmp2_ > 0) {
#line 6564 "worm.c"
		guint16 a = 0U;
		Position _tmp3_;
		Position _tmp4_;
		GeeArrayList* _tmp5_;
#line 1257 "../src/worm.vala"
		_tmp3_ = *p;
#line 1257 "../src/worm.vala"
		_tmp4_ = *p;
#line 1257 "../src/worm.vala"
		a = (guint16) ((((guint16) _tmp3_.x) << 8) | _tmp4_.y);
#line 1258 "../src/worm.vala"
		_tmp5_ = self->priv->bonus_eaten;
#line 1258 "../src/worm.vala"
		if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp5_, (gpointer) ((guintptr) a))) {
#line 6579 "worm.c"
			GeeArrayList* _tmp6_;
#line 1259 "../src/worm.vala"
			_tmp6_ = self->priv->bonus_eaten;
#line 1259 "../src/worm.vala"
			gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp6_, (gpointer) ((guintptr) a));
#line 6585 "worm.c"
		}
	}
}

void
worm_add_bonus_eaten_position (Worm* self,
                               guint8 x,
                               guint8 y)
{
	GeeArrayList* _tmp0_;
#line 1264 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1267 "../src/worm.vala"
	_tmp0_ = self->priv->bonus_eaten;
#line 1267 "../src/worm.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (gpointer) ((guintptr) ((((guint16) x) << 8) | y)));
#line 6602 "worm.c"
}

gboolean
worm_was_bonus_eaten_at_this_position (Worm* self,
                                       guint16 position)
{
	GeeArrayList* _tmp0_;
	gboolean result;
#line 1270 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1272 "../src/worm.vala"
	_tmp0_ = self->priv->bonus_eaten;
#line 1272 "../src/worm.vala"
	result = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (gpointer) ((guintptr) position));
#line 1272 "../src/worm.vala"
	return result;
#line 6619 "worm.c"
}

void
worm_reduce_tail (Worm* self,
                  gint erase_size)
{
#line 1276 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1278 "../src/worm.vala"
	if (erase_size > 0) {
#line 6630 "worm.c"
		{
			gint i = 0;
#line 1280 "../src/worm.vala"
			i = 0;
#line 6635 "worm.c"
			{
				gboolean _tmp0_ = FALSE;
#line 1280 "../src/worm.vala"
				_tmp0_ = TRUE;
#line 1280 "../src/worm.vala"
				while (TRUE) {
#line 6642 "worm.c"
					WormPositions* _tmp2_;
					gint _tmp3_;
					gint _tmp4_;
					WormPositions* _tmp5_;
					Position _tmp6_ = {0};
#line 1280 "../src/worm.vala"
					if (!_tmp0_) {
#line 6650 "worm.c"
						gint _tmp1_;
#line 1280 "../src/worm.vala"
						_tmp1_ = i;
#line 1280 "../src/worm.vala"
						i = _tmp1_ + 1;
#line 6656 "worm.c"
					}
#line 1280 "../src/worm.vala"
					_tmp0_ = FALSE;
#line 1280 "../src/worm.vala"
					if (!(i < erase_size)) {
#line 1280 "../src/worm.vala"
						break;
#line 6664 "worm.c"
					}
#line 1283 "../src/worm.vala"
					_tmp2_ = self->list;
#line 1283 "../src/worm.vala"
					_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 1283 "../src/worm.vala"
					_tmp4_ = _tmp3_;
#line 1283 "../src/worm.vala"
					_vala_assert (_tmp4_ > 0, "list.size > 0");
#line 1284 "../src/worm.vala"
					_tmp5_ = self->list;
#line 1284 "../src/worm.vala"
					worm_positions_remove_tail (_tmp5_, &_tmp6_);
#line 1284 "../src/worm.vala"
					worm_remove_bonus_eaten_position (self, &_tmp6_);
#line 6680 "worm.c"
				}
			}
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 1301 "../src/worm.vala"
	return self ? g_object_ref (self) : NULL;
#line 6692 "worm.c"
}

void
worm_reverse (Worm* self)
{
	gboolean _tmp0_ = FALSE;
#line 1289 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1291 "../src/worm.vala"
	if (!self->is_stopped) {
#line 6703 "worm.c"
		WormPositions* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 1291 "../src/worm.vala"
		_tmp1_ = self->list;
#line 1291 "../src/worm.vala"
		_tmp2_ = gee_collection_get_is_empty ((GeeCollection*) _tmp1_);
#line 1291 "../src/worm.vala"
		_tmp3_ = _tmp2_;
#line 1291 "../src/worm.vala"
		_tmp0_ = !_tmp3_;
#line 6715 "worm.c"
	} else {
#line 1291 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 6719 "worm.c"
	}
#line 1291 "../src/worm.vala"
	if (_tmp0_) {
#line 6723 "worm.c"
		WormPositions* reversed_list = NULL;
		WormPositions* _tmp4_;
		WormPositions* _tmp18_;
		WormPositions* _tmp19_;
		WormPositions* _tmp20_;
		gpointer _tmp21_;
		WormPositions* _tmp22_;
		gpointer _tmp23_;
#line 1293 "../src/worm.vala"
		_tmp4_ = worm_positions_new ();
#line 1293 "../src/worm.vala"
		reversed_list = _tmp4_;
#line 6736 "worm.c"
		{
			WormPositions* _pos_list = NULL;
			WormPositions* _tmp5_;
			gint _pos_size = 0;
			WormPositions* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _pos_index = 0;
#line 1294 "../src/worm.vala"
			_tmp5_ = self->list;
#line 1294 "../src/worm.vala"
			_pos_list = _tmp5_;
#line 1294 "../src/worm.vala"
			_tmp6_ = _pos_list;
#line 1294 "../src/worm.vala"
			_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 1294 "../src/worm.vala"
			_tmp8_ = _tmp7_;
#line 1294 "../src/worm.vala"
			_pos_size = _tmp8_;
#line 1294 "../src/worm.vala"
			_pos_index = -1;
#line 1294 "../src/worm.vala"
			while (TRUE) {
#line 6761 "worm.c"
				gint _tmp9_;
				gint _tmp10_;
				guint16 pos = 0U;
				WormPositions* _tmp11_;
				gpointer _tmp12_;
				WormPositions* _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
#line 1294 "../src/worm.vala"
				_pos_index = _pos_index + 1;
#line 1294 "../src/worm.vala"
				_tmp9_ = _pos_index;
#line 1294 "../src/worm.vala"
				_tmp10_ = _pos_size;
#line 1294 "../src/worm.vala"
				if (!(_tmp9_ < _tmp10_)) {
#line 1294 "../src/worm.vala"
					break;
#line 6780 "worm.c"
				}
#line 1294 "../src/worm.vala"
				_tmp11_ = _pos_list;
#line 1294 "../src/worm.vala"
				_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _pos_index);
#line 1294 "../src/worm.vala"
				pos = (guint16) ((guintptr) _tmp12_);
#line 1296 "../src/worm.vala"
				_tmp13_ = reversed_list;
#line 1296 "../src/worm.vala"
				_tmp14_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp13_);
#line 1296 "../src/worm.vala"
				_tmp15_ = _tmp14_;
#line 1296 "../src/worm.vala"
				if (_tmp15_ > 0) {
#line 6796 "worm.c"
					WormPositions* _tmp16_;
#line 1297 "../src/worm.vala"
					_tmp16_ = reversed_list;
#line 1297 "../src/worm.vala"
					gee_deque_offer_head ((GeeDeque*) _tmp16_, (gpointer) ((guintptr) pos));
#line 6802 "worm.c"
				} else {
					WormPositions* _tmp17_;
#line 1299 "../src/worm.vala"
					_tmp17_ = reversed_list;
#line 1299 "../src/worm.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, (gpointer) ((guintptr) pos));
#line 6809 "worm.c"
				}
			}
		}
#line 1301 "../src/worm.vala"
		_tmp18_ = reversed_list;
#line 1301 "../src/worm.vala"
		_tmp19_ = _g_object_ref0 (_tmp18_);
#line 1301 "../src/worm.vala"
		_g_object_unref0 (self->list);
#line 1301 "../src/worm.vala"
		self->list = _tmp19_;
#line 1304 "../src/worm.vala"
		_tmp20_ = self->list;
#line 1304 "../src/worm.vala"
		_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, 0);
#line 1304 "../src/worm.vala"
		_tmp22_ = self->list;
#line 1304 "../src/worm.vala"
		_tmp23_ = gee_abstract_list_get ((GeeAbstractList*) _tmp22_, 1);
#line 1304 "../src/worm.vala"
		if (((guint8) ((guint16) ((guintptr) _tmp21_))) == ((guint8) ((guint16) ((guintptr) _tmp23_)))) {
#line 6831 "worm.c"
			WormDirection _tmp24_ = 0;
			WormPositions* _tmp25_;
			gpointer _tmp26_;
			WormPositions* _tmp27_;
			gpointer _tmp28_;
#line 1305 "../src/worm.vala"
			_tmp25_ = self->list;
#line 1305 "../src/worm.vala"
			_tmp26_ = gee_abstract_list_get ((GeeAbstractList*) _tmp25_, 0);
#line 1305 "../src/worm.vala"
			_tmp27_ = self->list;
#line 1305 "../src/worm.vala"
			_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, 1);
#line 1305 "../src/worm.vala"
			if ((((guint16) ((guintptr) _tmp26_)) >> 8) > (((guint16) ((guintptr) _tmp28_)) >> 8)) {
#line 1305 "../src/worm.vala"
				_tmp24_ = WORM_DIRECTION_RIGHT;
#line 6849 "worm.c"
			} else {
#line 1305 "../src/worm.vala"
				_tmp24_ = WORM_DIRECTION_LEFT;
#line 6853 "worm.c"
			}
#line 1305 "../src/worm.vala"
			worm_set_direction (self, _tmp24_);
#line 6857 "worm.c"
		} else {
			WormDirection _tmp29_ = 0;
			WormPositions* _tmp30_;
			gpointer _tmp31_;
			WormPositions* _tmp32_;
			gpointer _tmp33_;
#line 1307 "../src/worm.vala"
			_tmp30_ = self->list;
#line 1307 "../src/worm.vala"
			_tmp31_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, 0);
#line 1307 "../src/worm.vala"
			_tmp32_ = self->list;
#line 1307 "../src/worm.vala"
			_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) _tmp32_, 1);
#line 1307 "../src/worm.vala"
			if (((guint8) ((guint16) ((guintptr) _tmp31_))) > ((guint8) ((guint16) ((guintptr) _tmp33_)))) {
#line 1307 "../src/worm.vala"
				_tmp29_ = WORM_DIRECTION_DOWN;
#line 6876 "worm.c"
			} else {
#line 1307 "../src/worm.vala"
				_tmp29_ = WORM_DIRECTION_UP;
#line 6880 "worm.c"
			}
#line 1307 "../src/worm.vala"
			worm_set_direction (self, _tmp29_);
#line 6884 "worm.c"
		}
#line 1291 "../src/worm.vala"
		_g_object_unref0 (reversed_list);
#line 6888 "worm.c"
	}
}

static gboolean
worm_does_list_contain_position (WormPositions* position_list,
                                 guint16 position)
{
	gboolean result;
#line 1311 "../src/worm.vala"
	g_return_val_if_fail (position_list != NULL, FALSE);
#line 1313 "../src/worm.vala"
	if (position_list != NULL) {
#line 6901 "worm.c"
		{
			WormPositions* _p_list = NULL;
			gint _p_size = 0;
			WormPositions* _tmp0_;
			gint _tmp1_;
			gint _tmp2_;
			gint _p_index = 0;
#line 1314 "../src/worm.vala"
			_p_list = position_list;
#line 1314 "../src/worm.vala"
			_tmp0_ = _p_list;
#line 1314 "../src/worm.vala"
			_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 1314 "../src/worm.vala"
			_tmp2_ = _tmp1_;
#line 1314 "../src/worm.vala"
			_p_size = _tmp2_;
#line 1314 "../src/worm.vala"
			_p_index = -1;
#line 1314 "../src/worm.vala"
			while (TRUE) {
#line 6923 "worm.c"
				gint _tmp3_;
				gint _tmp4_;
				guint16 p = 0U;
				WormPositions* _tmp5_;
				gpointer _tmp6_;
#line 1314 "../src/worm.vala"
				_p_index = _p_index + 1;
#line 1314 "../src/worm.vala"
				_tmp3_ = _p_index;
#line 1314 "../src/worm.vala"
				_tmp4_ = _p_size;
#line 1314 "../src/worm.vala"
				if (!(_tmp3_ < _tmp4_)) {
#line 1314 "../src/worm.vala"
					break;
#line 6939 "worm.c"
				}
#line 1314 "../src/worm.vala"
				_tmp5_ = _p_list;
#line 1314 "../src/worm.vala"
				_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _p_index);
#line 1314 "../src/worm.vala"
				p = (guint16) ((guintptr) _tmp6_);
#line 1315 "../src/worm.vala"
				if (p == position) {
#line 1316 "../src/worm.vala"
					result = TRUE;
#line 1316 "../src/worm.vala"
					return result;
#line 6953 "worm.c"
				}
			}
		}
	}
#line 1317 "../src/worm.vala"
	result = FALSE;
#line 1317 "../src/worm.vala"
	return result;
#line 6962 "worm.c"
}

gboolean
worm_is_position_clear_of_materialized_worms (Worm* self,
                                              GeeLinkedList* worms,
                                              Position* position)
{
	gboolean result;
#line 1320 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1320 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, FALSE);
#line 1320 "../src/worm.vala"
	g_return_val_if_fail (position != NULL, FALSE);
#line 6977 "worm.c"
	{
		GeeLinkedList* _worm_list = NULL;
		gint _worm_size = 0;
		GeeLinkedList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _worm_index = 0;
#line 1322 "../src/worm.vala"
		_worm_list = worms;
#line 1322 "../src/worm.vala"
		_tmp0_ = _worm_list;
#line 1322 "../src/worm.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 1322 "../src/worm.vala"
		_tmp2_ = _tmp1_;
#line 1322 "../src/worm.vala"
		_worm_size = _tmp2_;
#line 1322 "../src/worm.vala"
		_worm_index = -1;
#line 1322 "../src/worm.vala"
		while (TRUE) {
#line 6999 "worm.c"
			gint _tmp3_;
			gint _tmp4_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp5_;
			gpointer _tmp6_;
			gboolean _tmp7_ = FALSE;
			Worm* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 1322 "../src/worm.vala"
			_worm_index = _worm_index + 1;
#line 1322 "../src/worm.vala"
			_tmp3_ = _worm_index;
#line 1322 "../src/worm.vala"
			_tmp4_ = _worm_size;
#line 1322 "../src/worm.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 1322 "../src/worm.vala"
				break;
#line 7019 "worm.c"
			}
#line 1322 "../src/worm.vala"
			_tmp5_ = _worm_list;
#line 1322 "../src/worm.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _worm_index);
#line 1322 "../src/worm.vala"
			worm = (Worm*) _tmp6_;
#line 1323 "../src/worm.vala"
			_tmp8_ = worm;
#line 1323 "../src/worm.vala"
			_tmp9_ = worm_get_is_materialized (_tmp8_);
#line 1323 "../src/worm.vala"
			_tmp10_ = _tmp9_;
#line 1323 "../src/worm.vala"
			if (_tmp10_) {
#line 7035 "worm.c"
				Worm* _tmp11_;
				WormPositions* _tmp12_;
				Position _tmp13_;
				Position _tmp14_;
#line 1323 "../src/worm.vala"
				_tmp11_ = worm;
#line 1323 "../src/worm.vala"
				_tmp12_ = _tmp11_->list;
#line 1323 "../src/worm.vala"
				_tmp13_ = *position;
#line 1323 "../src/worm.vala"
				_tmp14_ = *position;
#line 1323 "../src/worm.vala"
				_tmp7_ = worm_does_list_contain_position (_tmp12_, (guint16) ((((guint16) _tmp13_.x) << 8) | _tmp14_.y));
#line 7050 "worm.c"
			} else {
#line 1323 "../src/worm.vala"
				_tmp7_ = FALSE;
#line 7054 "worm.c"
			}
#line 1323 "../src/worm.vala"
			if (_tmp7_) {
#line 1324 "../src/worm.vala"
				result = FALSE;
#line 1324 "../src/worm.vala"
				_g_object_unref0 (worm);
#line 1324 "../src/worm.vala"
				return result;
#line 7064 "worm.c"
			}
#line 1322 "../src/worm.vala"
			_g_object_unref0 (worm);
#line 7068 "worm.c"
		}
	}
#line 1325 "../src/worm.vala"
	result = TRUE;
#line 1325 "../src/worm.vala"
	return result;
#line 7075 "worm.c"
}

static gboolean
worm_is_board_position_occupied (Position* p,
                                 gint* board,
                                 gint board_length1,
                                 gint board_length2)
{
	Position _tmp0_;
	Position _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 1328 "../src/worm.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 1330 "../src/worm.vala"
	_tmp0_ = *p;
#line 1330 "../src/worm.vala"
	_tmp1_ = *p;
#line 1330 "../src/worm.vala"
	_tmp2_ = board[(_tmp0_.x * board_length2) + _tmp1_.y];
#line 1330 "../src/worm.vala"
	result = _tmp2_ > ((gint) NIBBLES_GAME_EMPTYCHAR);
#line 1330 "../src/worm.vala"
	return result;
#line 7100 "worm.c"
}

gboolean
worm_can_move_to (Worm* self,
                  gint* board,
                  gint board_length1,
                  gint board_length2,
                  GeeLinkedList* worms,
                  Position* position)
{
	Position _tmp0_;
	gboolean result;
#line 1333 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1333 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, FALSE);
#line 1333 "../src/worm.vala"
	g_return_val_if_fail (position != NULL, FALSE);
#line 1335 "../src/worm.vala"
	_tmp0_ = *position;
#line 1335 "../src/worm.vala"
	if (worm_is_board_position_occupied (&_tmp0_, board, (gint) board_length1, (gint) board_length2)) {
#line 1336 "../src/worm.vala"
		result = FALSE;
#line 1336 "../src/worm.vala"
		return result;
#line 7127 "worm.c"
	} else {
		Position _tmp1_;
#line 1337 "../src/worm.vala"
		_tmp1_ = *position;
#line 1337 "../src/worm.vala"
		if (!worm_is_position_clear_of_materialized_worms (self, worms, &_tmp1_)) {
#line 7134 "worm.c"
			gboolean _tmp2_;
			gboolean _tmp3_;
#line 1338 "../src/worm.vala"
			_tmp2_ = worm_get_is_materialized (self);
#line 1338 "../src/worm.vala"
			_tmp3_ = _tmp2_;
#line 1338 "../src/worm.vala"
			result = !_tmp3_;
#line 1338 "../src/worm.vala"
			return result;
#line 7145 "worm.c"
		} else {
#line 1340 "../src/worm.vala"
			result = TRUE;
#line 1340 "../src/worm.vala"
			return result;
#line 7151 "worm.c"
		}
	}
}

gboolean
worm_can_move_to_map (Worm* self,
                      gint* board,
                      gint board_length1,
                      gint board_length2,
                      WormMap* worm_map,
                      Position* position)
{
	Position _tmp0_;
	gboolean result;
#line 1343 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1343 "../src/worm.vala"
	g_return_val_if_fail (worm_map != NULL, FALSE);
#line 1343 "../src/worm.vala"
	g_return_val_if_fail (position != NULL, FALSE);
#line 1345 "../src/worm.vala"
	_tmp0_ = *position;
#line 1345 "../src/worm.vala"
	if (worm_is_board_position_occupied (&_tmp0_, board, (gint) board_length1, (gint) board_length2)) {
#line 1346 "../src/worm.vala"
		result = FALSE;
#line 1346 "../src/worm.vala"
		return result;
#line 7180 "worm.c"
	} else {
		Position _tmp1_;
#line 1347 "../src/worm.vala"
		_tmp1_ = *position;
#line 1347 "../src/worm.vala"
		if (worm_map_contain_position (worm_map, &_tmp1_)) {
#line 7187 "worm.c"
			gboolean _tmp2_;
			gboolean _tmp3_;
#line 1348 "../src/worm.vala"
			_tmp2_ = worm_get_is_materialized (self);
#line 1348 "../src/worm.vala"
			_tmp3_ = _tmp2_;
#line 1348 "../src/worm.vala"
			result = !_tmp3_;
#line 1348 "../src/worm.vala"
			return result;
#line 7198 "worm.c"
		} else {
#line 1350 "../src/worm.vala"
			result = TRUE;
#line 1350 "../src/worm.vala"
			return result;
#line 7204 "worm.c"
		}
	}
}

gboolean
worm_can_move_direction (Worm* self,
                         gint* board,
                         gint board_length1,
                         gint board_length2,
                         GeeLinkedList* worms,
                         WormDirection direction)
{
	Position position = {0};
	WormPositions* _tmp0_;
	Position _tmp1_ = {0};
	guint8 _tmp2_;
	guint8 _tmp3_;
	Position _tmp4_;
	gboolean result;
#line 1353 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1353 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, FALSE);
#line 1355 "../src/worm.vala"
	_tmp0_ = self->list;
#line 1355 "../src/worm.vala"
	worm_positions_get_head (_tmp0_, &_tmp1_);
#line 1355 "../src/worm.vala"
	position = _tmp1_;
#line 1356 "../src/worm.vala"
	_tmp2_ = self->priv->_width;
#line 1356 "../src/worm.vala"
	_tmp3_ = self->priv->_height;
#line 1356 "../src/worm.vala"
	position_move (&position, direction, _tmp2_, _tmp3_);
#line 1357 "../src/worm.vala"
	_tmp4_ = position;
#line 1357 "../src/worm.vala"
	result = worm_can_move_to (self, board, (gint) board_length1, (gint) board_length2, worms, &_tmp4_);
#line 1357 "../src/worm.vala"
	return result;
#line 7246 "worm.c"
}

void
worm_spawn (Worm* self,
            gint* board,
            gint board_length1,
            gint board_length2)
{
#line 1360 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1362 "../src/worm.vala"
	_vala_assert (WORM_STARTING_LENGTH > 0, "STARTING_LENGTH > 0");
#line 1363 "../src/worm.vala"
	worm_set_change (self, WORM_STARTING_LENGTH - 1);
#line 1364 "../src/worm.vala"
	self->priv->rounds_to_stay_dematerialized = WORM_STARTING_LENGTH;
#line 7263 "worm.c"
	{
		gint i = 0;
#line 1365 "../src/worm.vala"
		i = 0;
#line 7268 "worm.c"
		{
			gboolean _tmp0_ = FALSE;
#line 1365 "../src/worm.vala"
			_tmp0_ = TRUE;
#line 1365 "../src/worm.vala"
			while (TRUE) {
#line 1365 "../src/worm.vala"
				if (!_tmp0_) {
#line 7277 "worm.c"
					gint _tmp1_;
#line 1365 "../src/worm.vala"
					_tmp1_ = i;
#line 1365 "../src/worm.vala"
					i = _tmp1_ + 1;
#line 7283 "worm.c"
				}
#line 1365 "../src/worm.vala"
				_tmp0_ = FALSE;
#line 1365 "../src/worm.vala"
				if (!(i < WORM_STARTING_LENGTH)) {
#line 1365 "../src/worm.vala"
					break;
#line 7291 "worm.c"
				}
#line 1367 "../src/worm.vala"
				worm_move_part_1 (self);
#line 1368 "../src/worm.vala"
				worm_move_part_2 (self, board, (gint) board_length1, (gint) board_length2, NULL);
#line 7297 "worm.c"
			}
		}
	}
}

static void
worm_materialize (Worm* self,
                  gint* board,
                  gint board_length1,
                  gint board_length2)
{
	WormMap* worm_map = NULL;
	WormGetOtherWormsType _tmp0_;
	gpointer _tmp0__target;
	GeeList* _tmp1_;
	GeeList* _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	WormMap* _tmp5_;
	WormMap* _tmp6_;
	WormMap* _tmp7_;
	WormPositions* _tmp8_;
	Position position = {0};
	Position _tmp9_ = {0};
	Position _tmp10_;
#line 1372 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1380 "../src/worm.vala"
	_tmp0_ = self->priv->get_other_worms;
#line 1380 "../src/worm.vala"
	_tmp0__target = self->priv->get_other_worms_target;
#line 1380 "../src/worm.vala"
	_tmp1_ = _tmp0_ (self, _tmp0__target);
#line 1380 "../src/worm.vala"
	_tmp2_ = _tmp1_;
#line 1380 "../src/worm.vala"
	_tmp3_ = self->priv->_width;
#line 1380 "../src/worm.vala"
	_tmp4_ = self->priv->_height;
#line 1380 "../src/worm.vala"
	_tmp5_ = worm_map_new (_tmp2_, _tmp3_, _tmp4_);
#line 1380 "../src/worm.vala"
	_tmp6_ = _tmp5_;
#line 1380 "../src/worm.vala"
	_g_object_unref0 (_tmp2_);
#line 1380 "../src/worm.vala"
	worm_map = _tmp6_;
#line 1381 "../src/worm.vala"
	_tmp7_ = worm_map;
#line 1381 "../src/worm.vala"
	_tmp8_ = self->list;
#line 1381 "../src/worm.vala"
	if (worm_map_contains (_tmp7_, _tmp8_)) {
#line 1383 "../src/worm.vala"
		self->priv->rounds_to_stay_dematerialized = self->priv->rounds_to_stay_dematerialized + 1;
#line 1384 "../src/worm.vala"
		_g_object_unref0 (worm_map);
#line 1384 "../src/worm.vala"
		return;
#line 7357 "worm.c"
	}
#line 1386 "../src/worm.vala"
	worm_get_head (self, &_tmp9_);
#line 1386 "../src/worm.vala"
	_tmp10_ = _tmp9_;
#line 1386 "../src/worm.vala"
	position = _tmp10_;
#line 7365 "worm.c"
	{
		gint i = 0;
#line 1387 "../src/worm.vala"
		i = 12;
#line 7370 "worm.c"
		{
			gboolean _tmp11_ = FALSE;
#line 1387 "../src/worm.vala"
			_tmp11_ = TRUE;
#line 1387 "../src/worm.vala"
			while (TRUE) {
#line 7377 "worm.c"
				Position _tmp13_;
				WormDirection _tmp14_;
				Position _tmp15_ = {0};
				Position _tmp16_;
				WormMap* _tmp17_;
				Position _tmp18_;
#line 1387 "../src/worm.vala"
				if (!_tmp11_) {
#line 7386 "worm.c"
					gint _tmp12_;
#line 1387 "../src/worm.vala"
					_tmp12_ = i;
#line 1387 "../src/worm.vala"
					i = _tmp12_ - 1;
#line 7392 "worm.c"
				}
#line 1387 "../src/worm.vala"
				_tmp11_ = FALSE;
#line 1387 "../src/worm.vala"
				if (!(i > 0)) {
#line 1387 "../src/worm.vala"
					break;
#line 7400 "worm.c"
				}
#line 1389 "../src/worm.vala"
				_tmp13_ = position;
#line 1389 "../src/worm.vala"
				_tmp14_ = self->priv->_direction;
#line 1389 "../src/worm.vala"
				worm_get_position_after_direction_move (self, &_tmp13_, _tmp14_, &_tmp15_);
#line 1389 "../src/worm.vala"
				position = _tmp15_;
#line 1390 "../src/worm.vala"
				_tmp16_ = position;
#line 1390 "../src/worm.vala"
				if (worm_is_board_position_occupied (&_tmp16_, board, (gint) board_length1, (gint) board_length2)) {
#line 1392 "../src/worm.vala"
					self->priv->rounds_to_stay_dematerialized = 0;
#line 1393 "../src/worm.vala"
					_g_object_unref0 (worm_map);
#line 1393 "../src/worm.vala"
					return;
#line 7420 "worm.c"
				}
#line 1395 "../src/worm.vala"
				_tmp17_ = worm_map;
#line 1395 "../src/worm.vala"
				_tmp18_ = position;
#line 1395 "../src/worm.vala"
				if (worm_map_contain_position (_tmp17_, &_tmp18_)) {
#line 1397 "../src/worm.vala"
					self->priv->rounds_to_stay_dematerialized = self->priv->rounds_to_stay_dematerialized + 1;
#line 1398 "../src/worm.vala"
					_g_object_unref0 (worm_map);
#line 1398 "../src/worm.vala"
					return;
#line 7434 "worm.c"
				}
			}
		}
	}
#line 1401 "../src/worm.vala"
	self->priv->rounds_to_stay_dematerialized = 0;
#line 1372 "../src/worm.vala"
	_g_object_unref0 (worm_map);
#line 7443 "worm.c"
}

void
worm_dematerialize (Worm* self,
                    gint rounds,
                    gint gamedelay)
{
	gint _tmp0_ = 0;
#line 1404 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1407 "../src/worm.vala"
	if (rounds > 1) {
#line 1407 "../src/worm.vala"
		_tmp0_ = rounds;
#line 7458 "worm.c"
	} else {
#line 1407 "../src/worm.vala"
		_tmp0_ = 1;
#line 7462 "worm.c"
	}
#line 1407 "../src/worm.vala"
	self->priv->rounds_to_stay_dematerialized = _tmp0_;
#line 1409 "../src/worm.vala"
	self->rounds_to_stay_still = 2;
#line 7468 "worm.c"
}

void
worm_add_life (Worm* self)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
#line 1412 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1414 "../src/worm.vala"
	_tmp0_ = self->priv->_lives;
#line 1414 "../src/worm.vala"
	if (_tmp0_ > WORM_MAX_LIVES) {
#line 1415 "../src/worm.vala"
		return;
#line 7484 "worm.c"
	}
#line 1417 "../src/worm.vala"
	_tmp1_ = self->priv->_lives;
#line 1417 "../src/worm.vala"
	worm_set_lives (self, _tmp1_ + 1);
#line 7490 "worm.c"
}

static inline void
worm_lose_life (Worm* self)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
#line 1420 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1422 "../src/worm.vala"
	_tmp0_ = self->priv->_lives;
#line 1422 "../src/worm.vala"
	if (((gint) _tmp0_) == 0) {
#line 1423 "../src/worm.vala"
		return;
#line 7506 "worm.c"
	}
#line 1425 "../src/worm.vala"
	_tmp1_ = self->priv->_lives;
#line 1425 "../src/worm.vala"
	worm_set_lives (self, _tmp1_ - 1);
#line 7512 "worm.c"
}

void
worm_reset (Worm* self,
            gint* board,
            gint board_length1,
            gint board_length2)
{
	GeeArrayQueue* _tmp0_;
	WormPositions* _tmp1_;
	GeeArrayList* _tmp2_;
	guint8 _tmp3_;
#line 1428 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1430 "../src/worm.vala"
	self->is_stopped = TRUE;
#line 1431 "../src/worm.vala"
	self->priv->rounds_to_stay_dematerialized = 0;
#line 1433 "../src/worm.vala"
	_tmp0_ = self->priv->key_queue;
#line 1433 "../src/worm.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 1435 "../src/worm.vala"
	worm_lose_life (self);
#line 1437 "../src/worm.vala"
	_tmp1_ = self->list;
#line 1437 "../src/worm.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
#line 1439 "../src/worm.vala"
	_tmp2_ = self->priv->bonus_eaten;
#line 1439 "../src/worm.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp2_);
#line 1441 "../src/worm.vala"
	_tmp3_ = self->priv->_lives;
#line 1441 "../src/worm.vala"
	if (((gint) _tmp3_) > 0) {
#line 7549 "worm.c"
		WormPositions* _tmp4_;
		Position _tmp5_;
#line 1443 "../src/worm.vala"
		_tmp4_ = self->list;
#line 1443 "../src/worm.vala"
		_tmp5_ = self->priv->_starting_position;
#line 1443 "../src/worm.vala"
		worm_positions_append_position (_tmp4_, &_tmp5_);
#line 1445 "../src/worm.vala"
		worm_set_direction (self, self->priv->starting_direction);
#line 1446 "../src/worm.vala"
		worm_spawn (self, board, (gint) board_length1, (gint) board_length2);
#line 1448 "../src/worm.vala"
		worm_dematerialize (self, 3, 35);
#line 7564 "worm.c"
	}
}

void
worm_position_move (Worm* self,
                    Position* result)
{
	Position position = {0};
	Position _tmp0_ = {0};
	Position _tmp1_;
	Position _tmp2_ = {0};
	Position _tmp3_;
	Position _tmp4_ = {0};
	WormDirection _tmp5_;
	guint8 _tmp6_;
	guint8 _tmp7_;
#line 1452 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1454 "../src/worm.vala"
	worm_get_head (self, &_tmp0_);
#line 1454 "../src/worm.vala"
	_tmp1_ = _tmp0_;
#line 1454 "../src/worm.vala"
	worm_get_head (self, &_tmp2_);
#line 1454 "../src/worm.vala"
	_tmp3_ = _tmp2_;
#line 1454 "../src/worm.vala"
	_tmp4_.x = _tmp1_.x;
#line 1454 "../src/worm.vala"
	_tmp4_.y = _tmp3_.y;
#line 1454 "../src/worm.vala"
	position = _tmp4_;
#line 1455 "../src/worm.vala"
	_tmp5_ = self->priv->_direction;
#line 1455 "../src/worm.vala"
	_tmp6_ = self->priv->_width;
#line 1455 "../src/worm.vala"
	_tmp7_ = self->priv->_height;
#line 1455 "../src/worm.vala"
	position_move (&position, _tmp5_, _tmp6_, _tmp7_);
#line 1456 "../src/worm.vala"
	*result = position;
#line 1456 "../src/worm.vala"
	return;
#line 7609 "worm.c"
}

void
worm_get_position_after_direction_move (Worm* self,
                                        Position* origin,
                                        WormDirection direction,
                                        Position* result)
{
	Position position = {0};
	Position _tmp0_;
	Position _tmp1_;
	Position _tmp2_ = {0};
	guint8 _tmp3_;
	guint8 _tmp4_;
#line 1459 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1459 "../src/worm.vala"
	g_return_if_fail (origin != NULL);
#line 1461 "../src/worm.vala"
	_tmp0_ = *origin;
#line 1461 "../src/worm.vala"
	_tmp1_ = *origin;
#line 1461 "../src/worm.vala"
	_tmp2_.x = _tmp0_.x;
#line 1461 "../src/worm.vala"
	_tmp2_.y = _tmp1_.y;
#line 1461 "../src/worm.vala"
	position = _tmp2_;
#line 1462 "../src/worm.vala"
	_tmp3_ = self->priv->_width;
#line 1462 "../src/worm.vala"
	_tmp4_ = self->priv->_height;
#line 1462 "../src/worm.vala"
	position_move (&position, direction, _tmp3_, _tmp4_);
#line 1463 "../src/worm.vala"
	*result = position;
#line 1463 "../src/worm.vala"
	return;
#line 7648 "worm.c"
}

static void
worm_direction_set (Worm* self,
                    WormDirection dir)
{
#line 1466 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1466 "../src/worm.vala"
	_vala_return_if_fail (dir != WORM_DIRECTION_NONE, "dir != WormDirection.NONE");
#line 1469 "../src/worm.vala"
	if (!self->is_human) {
#line 1470 "../src/worm.vala"
		return;
#line 7663 "worm.c"
	}
#line 1472 "../src/worm.vala"
	if (self->keypress) {
#line 1474 "../src/worm.vala"
		worm_queue_keypress (self, dir);
#line 1475 "../src/worm.vala"
		return;
#line 7671 "worm.c"
	}
#line 1478 "../src/worm.vala"
	worm_set_direction (self, dir);
#line 1479 "../src/worm.vala"
	self->keypress = TRUE;
#line 7677 "worm.c"
}

static WormDirection
worm_uturn (Worm* self,
            gint* board,
            gint board_length1,
            gint board_length2,
            GeeLinkedList* worms,
            WormDirection direction)
{
	Position tmp = {0};
	WormDirection dirA = 0;
	WormDirection dirB = 0;
	gint length_posA = 0;
	gint length_posB = 0;
	gboolean _tmp0_ = FALSE;
	WormDirection result;
#line 1488 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1488 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, 0);
#line 1494 "../src/worm.vala"
	length_posA = 0;
#line 1494 "../src/worm.vala"
	length_posB = 0;
#line 1495 "../src/worm.vala"
	if (direction == WORM_DIRECTION_DOWN) {
#line 1495 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 7707 "worm.c"
	} else {
#line 1495 "../src/worm.vala"
		_tmp0_ = direction == WORM_DIRECTION_UP;
#line 7711 "worm.c"
	}
#line 1495 "../src/worm.vala"
	if (_tmp0_) {
#line 7715 "worm.c"
		WormPositions* _tmp1_;
		gpointer _tmp2_;
		WormPositions* _tmp3_;
		gpointer _tmp4_;
		Position _tmp5_ = {0};
		guint8 _tmp6_;
		guint8 _tmp7_;
		WormPositions* _tmp15_;
		gpointer _tmp16_;
		WormPositions* _tmp17_;
		gpointer _tmp18_;
		Position _tmp19_ = {0};
		guint8 _tmp20_;
		guint8 _tmp21_;
#line 1498 "../src/worm.vala"
		_tmp1_ = self->list;
#line 1498 "../src/worm.vala"
		_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _tmp1_, 0);
#line 1498 "../src/worm.vala"
		_tmp3_ = self->list;
#line 1498 "../src/worm.vala"
		_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, 0);
#line 1498 "../src/worm.vala"
		_tmp5_.x = (guint8) (((guint16) ((guintptr) _tmp2_)) >> 8);
#line 1498 "../src/worm.vala"
		_tmp5_.y = (guint8) ((guint16) ((guintptr) _tmp4_));
#line 1498 "../src/worm.vala"
		tmp = _tmp5_;
#line 1499 "../src/worm.vala"
		dirA = WORM_DIRECTION_LEFT;
#line 1500 "../src/worm.vala"
		_tmp6_ = self->priv->_width;
#line 1500 "../src/worm.vala"
		_tmp7_ = self->priv->_height;
#line 1500 "../src/worm.vala"
		position_move (&tmp, dirA, _tmp6_, _tmp7_);
#line 7752 "worm.c"
		{
			gboolean _tmp8_ = FALSE;
#line 1501 "../src/worm.vala"
			length_posA = 0;
#line 1501 "../src/worm.vala"
			_tmp8_ = TRUE;
#line 1501 "../src/worm.vala"
			while (TRUE) {
#line 7761 "worm.c"
				gboolean _tmp12_ = FALSE;
				guint8 _tmp13_;
#line 1501 "../src/worm.vala"
				if (!_tmp8_) {
#line 7766 "worm.c"
					gint _tmp9_;
					guint8 _tmp10_;
					guint8 _tmp11_;
#line 1501 "../src/worm.vala"
					_tmp9_ = length_posA;
#line 1501 "../src/worm.vala"
					length_posA = _tmp9_ + 1;
#line 1501 "../src/worm.vala"
					_tmp10_ = self->priv->_width;
#line 1501 "../src/worm.vala"
					_tmp11_ = self->priv->_height;
#line 1501 "../src/worm.vala"
					position_move (&tmp, direction, _tmp10_, _tmp11_);
#line 7780 "worm.c"
				}
#line 1501 "../src/worm.vala"
				_tmp8_ = FALSE;
#line 1501 "../src/worm.vala"
				_tmp13_ = self->priv->_height;
#line 1501 "../src/worm.vala"
				if (length_posA < ((gint) _tmp13_)) {
#line 7788 "worm.c"
					Position _tmp14_;
#line 1501 "../src/worm.vala"
					_tmp14_ = tmp;
#line 1501 "../src/worm.vala"
					_tmp12_ = worm_can_move_to (self, board, (gint) board_length1, (gint) board_length2, worms, &_tmp14_);
#line 7794 "worm.c"
				} else {
#line 1501 "../src/worm.vala"
					_tmp12_ = FALSE;
#line 7798 "worm.c"
				}
#line 1501 "../src/worm.vala"
				if (!_tmp12_) {
#line 1501 "../src/worm.vala"
					break;
#line 7804 "worm.c"
				}
			}
		}
#line 1503 "../src/worm.vala"
		_tmp15_ = self->list;
#line 1503 "../src/worm.vala"
		_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, 0);
#line 1503 "../src/worm.vala"
		_tmp17_ = self->list;
#line 1503 "../src/worm.vala"
		_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, 0);
#line 1503 "../src/worm.vala"
		_tmp19_.x = (guint8) (((guint16) ((guintptr) _tmp16_)) >> 8);
#line 1503 "../src/worm.vala"
		_tmp19_.y = (guint8) ((guint16) ((guintptr) _tmp18_));
#line 1503 "../src/worm.vala"
		tmp = _tmp19_;
#line 1504 "../src/worm.vala"
		dirB = WORM_DIRECTION_RIGHT;
#line 1505 "../src/worm.vala"
		_tmp20_ = self->priv->_width;
#line 1505 "../src/worm.vala"
		_tmp21_ = self->priv->_height;
#line 1505 "../src/worm.vala"
		position_move (&tmp, dirB, _tmp20_, _tmp21_);
#line 7830 "worm.c"
		{
			gboolean _tmp22_ = FALSE;
#line 1506 "../src/worm.vala"
			length_posB = 0;
#line 1506 "../src/worm.vala"
			_tmp22_ = TRUE;
#line 1506 "../src/worm.vala"
			while (TRUE) {
#line 7839 "worm.c"
				gboolean _tmp26_ = FALSE;
				guint8 _tmp27_;
#line 1506 "../src/worm.vala"
				if (!_tmp22_) {
#line 7844 "worm.c"
					gint _tmp23_;
					guint8 _tmp24_;
					guint8 _tmp25_;
#line 1506 "../src/worm.vala"
					_tmp23_ = length_posB;
#line 1506 "../src/worm.vala"
					length_posB = _tmp23_ + 1;
#line 1506 "../src/worm.vala"
					_tmp24_ = self->priv->_width;
#line 1506 "../src/worm.vala"
					_tmp25_ = self->priv->_height;
#line 1506 "../src/worm.vala"
					position_move (&tmp, direction, _tmp24_, _tmp25_);
#line 7858 "worm.c"
				}
#line 1506 "../src/worm.vala"
				_tmp22_ = FALSE;
#line 1506 "../src/worm.vala"
				_tmp27_ = self->priv->_height;
#line 1506 "../src/worm.vala"
				if (length_posB < ((gint) _tmp27_)) {
#line 7866 "worm.c"
					Position _tmp28_;
#line 1506 "../src/worm.vala"
					_tmp28_ = tmp;
#line 1506 "../src/worm.vala"
					_tmp26_ = worm_can_move_to (self, board, (gint) board_length1, (gint) board_length2, worms, &_tmp28_);
#line 7872 "worm.c"
				} else {
#line 1506 "../src/worm.vala"
					_tmp26_ = FALSE;
#line 7876 "worm.c"
				}
#line 1506 "../src/worm.vala"
				if (!_tmp26_) {
#line 1506 "../src/worm.vala"
					break;
#line 7882 "worm.c"
				}
			}
		}
	} else {
		WormPositions* _tmp29_;
		gpointer _tmp30_;
		WormPositions* _tmp31_;
		gpointer _tmp32_;
		Position _tmp33_ = {0};
		guint8 _tmp34_;
		guint8 _tmp35_;
		WormPositions* _tmp43_;
		gpointer _tmp44_;
		WormPositions* _tmp45_;
		gpointer _tmp46_;
		Position _tmp47_ = {0};
		guint8 _tmp48_;
		guint8 _tmp49_;
#line 1511 "../src/worm.vala"
		_tmp29_ = self->list;
#line 1511 "../src/worm.vala"
		_tmp30_ = gee_abstract_list_get ((GeeAbstractList*) _tmp29_, 0);
#line 1511 "../src/worm.vala"
		_tmp31_ = self->list;
#line 1511 "../src/worm.vala"
		_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp31_, 0);
#line 1511 "../src/worm.vala"
		_tmp33_.x = (guint8) (((guint16) ((guintptr) _tmp30_)) >> 8);
#line 1511 "../src/worm.vala"
		_tmp33_.y = (guint8) ((guint16) ((guintptr) _tmp32_));
#line 1511 "../src/worm.vala"
		tmp = _tmp33_;
#line 1512 "../src/worm.vala"
		dirA = WORM_DIRECTION_UP;
#line 1513 "../src/worm.vala"
		_tmp34_ = self->priv->_width;
#line 1513 "../src/worm.vala"
		_tmp35_ = self->priv->_height;
#line 1513 "../src/worm.vala"
		position_move (&tmp, dirA, _tmp34_, _tmp35_);
#line 7923 "worm.c"
		{
			gboolean _tmp36_ = FALSE;
#line 1514 "../src/worm.vala"
			length_posA = 0;
#line 1514 "../src/worm.vala"
			_tmp36_ = TRUE;
#line 1514 "../src/worm.vala"
			while (TRUE) {
#line 7932 "worm.c"
				gboolean _tmp40_ = FALSE;
				guint8 _tmp41_;
#line 1514 "../src/worm.vala"
				if (!_tmp36_) {
#line 7937 "worm.c"
					gint _tmp37_;
					guint8 _tmp38_;
					guint8 _tmp39_;
#line 1514 "../src/worm.vala"
					_tmp37_ = length_posA;
#line 1514 "../src/worm.vala"
					length_posA = _tmp37_ + 1;
#line 1514 "../src/worm.vala"
					_tmp38_ = self->priv->_width;
#line 1514 "../src/worm.vala"
					_tmp39_ = self->priv->_height;
#line 1514 "../src/worm.vala"
					position_move (&tmp, direction, _tmp38_, _tmp39_);
#line 7951 "worm.c"
				}
#line 1514 "../src/worm.vala"
				_tmp36_ = FALSE;
#line 1514 "../src/worm.vala"
				_tmp41_ = self->priv->_width;
#line 1514 "../src/worm.vala"
				if (length_posA < ((gint) _tmp41_)) {
#line 7959 "worm.c"
					Position _tmp42_;
#line 1514 "../src/worm.vala"
					_tmp42_ = tmp;
#line 1514 "../src/worm.vala"
					_tmp40_ = worm_can_move_to (self, board, (gint) board_length1, (gint) board_length2, worms, &_tmp42_);
#line 7965 "worm.c"
				} else {
#line 1514 "../src/worm.vala"
					_tmp40_ = FALSE;
#line 7969 "worm.c"
				}
#line 1514 "../src/worm.vala"
				if (!_tmp40_) {
#line 1514 "../src/worm.vala"
					break;
#line 7975 "worm.c"
				}
			}
		}
#line 1516 "../src/worm.vala"
		_tmp43_ = self->list;
#line 1516 "../src/worm.vala"
		_tmp44_ = gee_abstract_list_get ((GeeAbstractList*) _tmp43_, 0);
#line 1516 "../src/worm.vala"
		_tmp45_ = self->list;
#line 1516 "../src/worm.vala"
		_tmp46_ = gee_abstract_list_get ((GeeAbstractList*) _tmp45_, 0);
#line 1516 "../src/worm.vala"
		_tmp47_.x = (guint8) (((guint16) ((guintptr) _tmp44_)) >> 8);
#line 1516 "../src/worm.vala"
		_tmp47_.y = (guint8) ((guint16) ((guintptr) _tmp46_));
#line 1516 "../src/worm.vala"
		tmp = _tmp47_;
#line 1517 "../src/worm.vala"
		dirB = WORM_DIRECTION_DOWN;
#line 1518 "../src/worm.vala"
		_tmp48_ = self->priv->_width;
#line 1518 "../src/worm.vala"
		_tmp49_ = self->priv->_height;
#line 1518 "../src/worm.vala"
		position_move (&tmp, dirB, _tmp48_, _tmp49_);
#line 8001 "worm.c"
		{
			gboolean _tmp50_ = FALSE;
#line 1519 "../src/worm.vala"
			length_posB = 0;
#line 1519 "../src/worm.vala"
			_tmp50_ = TRUE;
#line 1519 "../src/worm.vala"
			while (TRUE) {
#line 8010 "worm.c"
				gboolean _tmp54_ = FALSE;
				guint8 _tmp55_;
#line 1519 "../src/worm.vala"
				if (!_tmp50_) {
#line 8015 "worm.c"
					gint _tmp51_;
					guint8 _tmp52_;
					guint8 _tmp53_;
#line 1519 "../src/worm.vala"
					_tmp51_ = length_posB;
#line 1519 "../src/worm.vala"
					length_posB = _tmp51_ + 1;
#line 1519 "../src/worm.vala"
					_tmp52_ = self->priv->_width;
#line 1519 "../src/worm.vala"
					_tmp53_ = self->priv->_height;
#line 1519 "../src/worm.vala"
					position_move (&tmp, direction, _tmp52_, _tmp53_);
#line 8029 "worm.c"
				}
#line 1519 "../src/worm.vala"
				_tmp50_ = FALSE;
#line 1519 "../src/worm.vala"
				_tmp55_ = self->priv->_width;
#line 1519 "../src/worm.vala"
				if (length_posB < ((gint) _tmp55_)) {
#line 8037 "worm.c"
					Position _tmp56_;
#line 1519 "../src/worm.vala"
					_tmp56_ = tmp;
#line 1519 "../src/worm.vala"
					_tmp54_ = worm_can_move_to (self, board, (gint) board_length1, (gint) board_length2, worms, &_tmp56_);
#line 8043 "worm.c"
				} else {
#line 1519 "../src/worm.vala"
					_tmp54_ = FALSE;
#line 8047 "worm.c"
				}
#line 1519 "../src/worm.vala"
				if (!_tmp54_) {
#line 1519 "../src/worm.vala"
					break;
#line 8053 "worm.c"
				}
			}
		}
	}
#line 1521 "../src/worm.vala"
	if (length_posA > length_posB) {
#line 1523 "../src/worm.vala"
		self->priv->LastUturnA = TRUE;
#line 1524 "../src/worm.vala"
		result = dirA;
#line 1524 "../src/worm.vala"
		return result;
#line 8066 "worm.c"
	} else {
#line 1526 "../src/worm.vala"
		if (length_posA < length_posB) {
#line 1528 "../src/worm.vala"
			self->priv->LastUturnA = FALSE;
#line 1529 "../src/worm.vala"
			result = dirB;
#line 1529 "../src/worm.vala"
			return result;
#line 8076 "worm.c"
		} else {
#line 1531 "../src/worm.vala"
			if (length_posA > 0) {
#line 1533 "../src/worm.vala"
				if (self->priv->LastUturnA) {
#line 1534 "../src/worm.vala"
					result = dirA;
#line 1534 "../src/worm.vala"
					return result;
#line 8086 "worm.c"
				} else {
#line 1536 "../src/worm.vala"
					result = dirB;
#line 1536 "../src/worm.vala"
					return result;
#line 8092 "worm.c"
				}
			} else {
#line 1539 "../src/worm.vala"
				result = worm_direction_reverse (direction);
#line 1539 "../src/worm.vala"
				return result;
#line 8099 "worm.c"
			}
		}
	}
}

static gint
worm_get_raw_key (Worm* self,
                  guint keyval)
{
	GdkKeymapKey* keys = NULL;
	gint keys_length1 = 0;
	gint _keys_size_ = 0;
	GdkDisplay* _tmp0_;
	GdkKeymapKey* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gboolean _tmp3_;
	gint result;
#line 1542 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1545 "../src/worm.vala"
	_tmp0_ = gdk_display_get_default ();
#line 1545 "../src/worm.vala"
	_tmp3_ = gdk_display_map_keyval (_tmp0_, keyval, &_tmp1_, &_tmp2_);
#line 1545 "../src/worm.vala"
	keys = (g_free (keys), NULL);
#line 1545 "../src/worm.vala"
	keys = _tmp1_;
#line 1545 "../src/worm.vala"
	keys_length1 = _tmp2_;
#line 1545 "../src/worm.vala"
	_keys_size_ = keys_length1;
#line 1545 "../src/worm.vala"
	if (_tmp3_) {
#line 8133 "worm.c"
		GdkKeymapKey* _tmp4_;
		gint _tmp4__length1;
#line 1547 "../src/worm.vala"
		_tmp4_ = keys;
#line 1547 "../src/worm.vala"
		_tmp4__length1 = keys_length1;
#line 1547 "../src/worm.vala"
		if (_tmp4__length1 > 0) {
#line 8142 "worm.c"
			GdkKeymapKey* _tmp5_;
			gint _tmp5__length1;
			GdkKeymapKey _tmp6_;
#line 1548 "../src/worm.vala"
			_tmp5_ = keys;
#line 1548 "../src/worm.vala"
			_tmp5__length1 = keys_length1;
#line 1548 "../src/worm.vala"
			_tmp6_ = _tmp5_[0];
#line 1548 "../src/worm.vala"
			result = (gint) _tmp6_.keycode;
#line 1548 "../src/worm.vala"
			keys = (g_free (keys), NULL);
#line 1548 "../src/worm.vala"
			return result;
#line 8158 "worm.c"
		}
	}
#line 1550 "../src/worm.vala"
	result = -1;
#line 1550 "../src/worm.vala"
	keys = (g_free (keys), NULL);
#line 1550 "../src/worm.vala"
	return result;
#line 8167 "worm.c"
}

gboolean
worm_handle_keypress (Worm* self,
                      guint keycode,
                      GeeHashMap* worm_props,
                      gint* board,
                      gint board_length1,
                      gint board_length2,
                      GeeLinkedList* worms)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	guint8 _tmp2_;
	WormProperties* properties = NULL;
	gpointer _tmp6_;
	WormProperties* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	WormProperties* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	WormProperties* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	WormProperties* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	WormProperties* _tmp35_;
	gint _tmp36_;
	gint _tmp37_;
	WormProperties* _tmp42_;
	gint _tmp43_;
	gint _tmp44_;
	WormProperties* _tmp49_;
	gint _tmp50_;
	gint _tmp51_;
	WormProperties* _tmp56_;
	gint _tmp57_;
	gint _tmp58_;
	gboolean result;
#line 1553 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1553 "../src/worm.vala"
	g_return_val_if_fail (worm_props != NULL, FALSE);
#line 1553 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, FALSE);
#line 1555 "../src/worm.vala"
	_tmp2_ = self->priv->_lives;
#line 1555 "../src/worm.vala"
	if (((gint) _tmp2_) == 0) {
#line 1555 "../src/worm.vala"
		_tmp1_ = TRUE;
#line 8221 "worm.c"
	} else {
#line 1555 "../src/worm.vala"
		_tmp1_ = self->is_stopped;
#line 8225 "worm.c"
	}
#line 1555 "../src/worm.vala"
	if (_tmp1_) {
#line 1555 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 8231 "worm.c"
	} else {
		WormPositions* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 1555 "../src/worm.vala"
		_tmp3_ = self->list;
#line 1555 "../src/worm.vala"
		_tmp4_ = gee_collection_get_is_empty ((GeeCollection*) _tmp3_);
#line 1555 "../src/worm.vala"
		_tmp5_ = _tmp4_;
#line 1555 "../src/worm.vala"
		_tmp0_ = _tmp5_;
#line 8244 "worm.c"
	}
#line 1555 "../src/worm.vala"
	if (_tmp0_) {
#line 1556 "../src/worm.vala"
		result = FALSE;
#line 1556 "../src/worm.vala"
		return result;
#line 8252 "worm.c"
	}
#line 1558 "../src/worm.vala"
	_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) worm_props, self);
#line 1558 "../src/worm.vala"
	properties = (WormProperties*) _tmp6_;
#line 1560 "../src/worm.vala"
	_tmp7_ = properties;
#line 1560 "../src/worm.vala"
	_tmp8_ = worm_properties_get_raw_up (_tmp7_);
#line 1560 "../src/worm.vala"
	_tmp9_ = _tmp8_;
#line 1560 "../src/worm.vala"
	if (_tmp9_ < 0) {
#line 8266 "worm.c"
		WormProperties* _tmp10_;
		WormProperties* _tmp11_;
		guint _tmp12_;
		guint _tmp13_;
#line 1561 "../src/worm.vala"
		_tmp10_ = properties;
#line 1561 "../src/worm.vala"
		_tmp11_ = properties;
#line 1561 "../src/worm.vala"
		_tmp12_ = worm_properties_get_up (_tmp11_);
#line 1561 "../src/worm.vala"
		_tmp13_ = _tmp12_;
#line 1561 "../src/worm.vala"
		worm_properties_set_raw_up (_tmp10_, worm_get_raw_key (self, _tmp13_));
#line 8281 "worm.c"
	}
#line 1562 "../src/worm.vala"
	_tmp14_ = properties;
#line 1562 "../src/worm.vala"
	_tmp15_ = worm_properties_get_raw_up (_tmp14_);
#line 1562 "../src/worm.vala"
	_tmp16_ = _tmp15_;
#line 1562 "../src/worm.vala"
	if (keycode == ((guint) _tmp16_)) {
#line 8291 "worm.c"
		WormDirection _tmp17_;
#line 1564 "../src/worm.vala"
		_tmp17_ = self->priv->_direction;
#line 1564 "../src/worm.vala"
		if (_tmp17_ == WORM_DIRECTION_DOWN) {
#line 8297 "worm.c"
			gboolean _tmp18_ = FALSE;
			WormDirection _tmp19_;
#line 1566 "../src/worm.vala"
			worm_direction_set (self, worm_uturn (self, board, (gint) board_length1, (gint) board_length2, worms, WORM_DIRECTION_UP));
#line 1567 "../src/worm.vala"
			_tmp19_ = self->priv->_direction;
#line 1567 "../src/worm.vala"
			if (_tmp19_ != WORM_DIRECTION_UP) {
#line 8306 "worm.c"
				WormDirection _tmp20_;
#line 1567 "../src/worm.vala"
				_tmp20_ = self->priv->_direction;
#line 1567 "../src/worm.vala"
				_tmp18_ = _tmp20_ != WORM_DIRECTION_DOWN;
#line 8312 "worm.c"
			} else {
#line 1567 "../src/worm.vala"
				_tmp18_ = FALSE;
#line 8316 "worm.c"
			}
#line 1567 "../src/worm.vala"
			if (_tmp18_) {
#line 1568 "../src/worm.vala"
				worm_queue_keypress (self, WORM_DIRECTION_UP);
#line 8322 "worm.c"
			}
#line 1569 "../src/worm.vala"
			result = TRUE;
#line 1569 "../src/worm.vala"
			_g_object_unref0 (properties);
#line 1569 "../src/worm.vala"
			return result;
#line 8330 "worm.c"
		} else {
#line 1571 "../src/worm.vala"
			if (worm_can_move_direction (self, board, (gint) board_length1, (gint) board_length2, worms, WORM_DIRECTION_UP)) {
#line 1573 "../src/worm.vala"
				worm_direction_set (self, WORM_DIRECTION_UP);
#line 1574 "../src/worm.vala"
				result = TRUE;
#line 1574 "../src/worm.vala"
				_g_object_unref0 (properties);
#line 1574 "../src/worm.vala"
				return result;
#line 8342 "worm.c"
			}
		}
	}
#line 1577 "../src/worm.vala"
	_tmp21_ = properties;
#line 1577 "../src/worm.vala"
	_tmp22_ = worm_properties_get_raw_down (_tmp21_);
#line 1577 "../src/worm.vala"
	_tmp23_ = _tmp22_;
#line 1577 "../src/worm.vala"
	if (_tmp23_ < 0) {
#line 8354 "worm.c"
		WormProperties* _tmp24_;
		WormProperties* _tmp25_;
		guint _tmp26_;
		guint _tmp27_;
#line 1578 "../src/worm.vala"
		_tmp24_ = properties;
#line 1578 "../src/worm.vala"
		_tmp25_ = properties;
#line 1578 "../src/worm.vala"
		_tmp26_ = worm_properties_get_down (_tmp25_);
#line 1578 "../src/worm.vala"
		_tmp27_ = _tmp26_;
#line 1578 "../src/worm.vala"
		worm_properties_set_raw_down (_tmp24_, worm_get_raw_key (self, _tmp27_));
#line 8369 "worm.c"
	}
#line 1579 "../src/worm.vala"
	_tmp28_ = properties;
#line 1579 "../src/worm.vala"
	_tmp29_ = worm_properties_get_raw_down (_tmp28_);
#line 1579 "../src/worm.vala"
	_tmp30_ = _tmp29_;
#line 1579 "../src/worm.vala"
	if (keycode == ((guint) _tmp30_)) {
#line 8379 "worm.c"
		WormDirection _tmp31_;
#line 1581 "../src/worm.vala"
		_tmp31_ = self->priv->_direction;
#line 1581 "../src/worm.vala"
		if (_tmp31_ == WORM_DIRECTION_UP) {
#line 8385 "worm.c"
			gboolean _tmp32_ = FALSE;
			WormDirection _tmp33_;
#line 1583 "../src/worm.vala"
			worm_direction_set (self, worm_uturn (self, board, (gint) board_length1, (gint) board_length2, worms, WORM_DIRECTION_DOWN));
#line 1584 "../src/worm.vala"
			_tmp33_ = self->priv->_direction;
#line 1584 "../src/worm.vala"
			if (_tmp33_ != WORM_DIRECTION_DOWN) {
#line 8394 "worm.c"
				WormDirection _tmp34_;
#line 1584 "../src/worm.vala"
				_tmp34_ = self->priv->_direction;
#line 1584 "../src/worm.vala"
				_tmp32_ = _tmp34_ != WORM_DIRECTION_UP;
#line 8400 "worm.c"
			} else {
#line 1584 "../src/worm.vala"
				_tmp32_ = FALSE;
#line 8404 "worm.c"
			}
#line 1584 "../src/worm.vala"
			if (_tmp32_) {
#line 1585 "../src/worm.vala"
				worm_queue_keypress (self, WORM_DIRECTION_DOWN);
#line 8410 "worm.c"
			}
#line 1586 "../src/worm.vala"
			result = TRUE;
#line 1586 "../src/worm.vala"
			_g_object_unref0 (properties);
#line 1586 "../src/worm.vala"
			return result;
#line 8418 "worm.c"
		} else {
#line 1588 "../src/worm.vala"
			if (worm_can_move_direction (self, board, (gint) board_length1, (gint) board_length2, worms, WORM_DIRECTION_DOWN)) {
#line 1590 "../src/worm.vala"
				worm_direction_set (self, WORM_DIRECTION_DOWN);
#line 1591 "../src/worm.vala"
				result = TRUE;
#line 1591 "../src/worm.vala"
				_g_object_unref0 (properties);
#line 1591 "../src/worm.vala"
				return result;
#line 8430 "worm.c"
			}
		}
	}
#line 1594 "../src/worm.vala"
	_tmp35_ = properties;
#line 1594 "../src/worm.vala"
	_tmp36_ = worm_properties_get_raw_right (_tmp35_);
#line 1594 "../src/worm.vala"
	_tmp37_ = _tmp36_;
#line 1594 "../src/worm.vala"
	if (_tmp37_ < 0) {
#line 8442 "worm.c"
		WormProperties* _tmp38_;
		WormProperties* _tmp39_;
		guint _tmp40_;
		guint _tmp41_;
#line 1595 "../src/worm.vala"
		_tmp38_ = properties;
#line 1595 "../src/worm.vala"
		_tmp39_ = properties;
#line 1595 "../src/worm.vala"
		_tmp40_ = worm_properties_get_right (_tmp39_);
#line 1595 "../src/worm.vala"
		_tmp41_ = _tmp40_;
#line 1595 "../src/worm.vala"
		worm_properties_set_raw_right (_tmp38_, worm_get_raw_key (self, _tmp41_));
#line 8457 "worm.c"
	}
#line 1596 "../src/worm.vala"
	_tmp42_ = properties;
#line 1596 "../src/worm.vala"
	_tmp43_ = worm_properties_get_raw_right (_tmp42_);
#line 1596 "../src/worm.vala"
	_tmp44_ = _tmp43_;
#line 1596 "../src/worm.vala"
	if (keycode == ((guint) _tmp44_)) {
#line 8467 "worm.c"
		WormDirection _tmp45_;
#line 1598 "../src/worm.vala"
		_tmp45_ = self->priv->_direction;
#line 1598 "../src/worm.vala"
		if (_tmp45_ == WORM_DIRECTION_LEFT) {
#line 8473 "worm.c"
			gboolean _tmp46_ = FALSE;
			WormDirection _tmp47_;
#line 1600 "../src/worm.vala"
			worm_direction_set (self, worm_uturn (self, board, (gint) board_length1, (gint) board_length2, worms, WORM_DIRECTION_RIGHT));
#line 1601 "../src/worm.vala"
			_tmp47_ = self->priv->_direction;
#line 1601 "../src/worm.vala"
			if (_tmp47_ != WORM_DIRECTION_RIGHT) {
#line 8482 "worm.c"
				WormDirection _tmp48_;
#line 1601 "../src/worm.vala"
				_tmp48_ = self->priv->_direction;
#line 1601 "../src/worm.vala"
				_tmp46_ = _tmp48_ != WORM_DIRECTION_LEFT;
#line 8488 "worm.c"
			} else {
#line 1601 "../src/worm.vala"
				_tmp46_ = FALSE;
#line 8492 "worm.c"
			}
#line 1601 "../src/worm.vala"
			if (_tmp46_) {
#line 1602 "../src/worm.vala"
				worm_queue_keypress (self, WORM_DIRECTION_RIGHT);
#line 8498 "worm.c"
			}
#line 1603 "../src/worm.vala"
			result = TRUE;
#line 1603 "../src/worm.vala"
			_g_object_unref0 (properties);
#line 1603 "../src/worm.vala"
			return result;
#line 8506 "worm.c"
		} else {
#line 1605 "../src/worm.vala"
			if (worm_can_move_direction (self, board, (gint) board_length1, (gint) board_length2, worms, WORM_DIRECTION_RIGHT)) {
#line 1607 "../src/worm.vala"
				worm_direction_set (self, WORM_DIRECTION_RIGHT);
#line 1608 "../src/worm.vala"
				result = TRUE;
#line 1608 "../src/worm.vala"
				_g_object_unref0 (properties);
#line 1608 "../src/worm.vala"
				return result;
#line 8518 "worm.c"
			}
		}
	}
#line 1611 "../src/worm.vala"
	_tmp49_ = properties;
#line 1611 "../src/worm.vala"
	_tmp50_ = worm_properties_get_raw_left (_tmp49_);
#line 1611 "../src/worm.vala"
	_tmp51_ = _tmp50_;
#line 1611 "../src/worm.vala"
	if (_tmp51_ < 0) {
#line 8530 "worm.c"
		WormProperties* _tmp52_;
		WormProperties* _tmp53_;
		guint _tmp54_;
		guint _tmp55_;
#line 1612 "../src/worm.vala"
		_tmp52_ = properties;
#line 1612 "../src/worm.vala"
		_tmp53_ = properties;
#line 1612 "../src/worm.vala"
		_tmp54_ = worm_properties_get_left (_tmp53_);
#line 1612 "../src/worm.vala"
		_tmp55_ = _tmp54_;
#line 1612 "../src/worm.vala"
		worm_properties_set_raw_left (_tmp52_, worm_get_raw_key (self, _tmp55_));
#line 8545 "worm.c"
	}
#line 1613 "../src/worm.vala"
	_tmp56_ = properties;
#line 1613 "../src/worm.vala"
	_tmp57_ = worm_properties_get_raw_left (_tmp56_);
#line 1613 "../src/worm.vala"
	_tmp58_ = _tmp57_;
#line 1613 "../src/worm.vala"
	if (keycode == ((guint) _tmp58_)) {
#line 8555 "worm.c"
		WormDirection _tmp59_;
#line 1615 "../src/worm.vala"
		_tmp59_ = self->priv->_direction;
#line 1615 "../src/worm.vala"
		if (_tmp59_ == WORM_DIRECTION_RIGHT) {
#line 8561 "worm.c"
			gboolean _tmp60_ = FALSE;
			WormDirection _tmp61_;
#line 1617 "../src/worm.vala"
			worm_direction_set (self, worm_uturn (self, board, (gint) board_length1, (gint) board_length2, worms, WORM_DIRECTION_LEFT));
#line 1618 "../src/worm.vala"
			_tmp61_ = self->priv->_direction;
#line 1618 "../src/worm.vala"
			if (_tmp61_ != WORM_DIRECTION_LEFT) {
#line 8570 "worm.c"
				WormDirection _tmp62_;
#line 1618 "../src/worm.vala"
				_tmp62_ = self->priv->_direction;
#line 1618 "../src/worm.vala"
				_tmp60_ = _tmp62_ != WORM_DIRECTION_RIGHT;
#line 8576 "worm.c"
			} else {
#line 1618 "../src/worm.vala"
				_tmp60_ = FALSE;
#line 8580 "worm.c"
			}
#line 1618 "../src/worm.vala"
			if (_tmp60_) {
#line 1619 "../src/worm.vala"
				worm_queue_keypress (self, WORM_DIRECTION_LEFT);
#line 8586 "worm.c"
			}
#line 1620 "../src/worm.vala"
			result = TRUE;
#line 1620 "../src/worm.vala"
			_g_object_unref0 (properties);
#line 1620 "../src/worm.vala"
			return result;
#line 8594 "worm.c"
		} else {
#line 1622 "../src/worm.vala"
			if (worm_can_move_direction (self, board, (gint) board_length1, (gint) board_length2, worms, WORM_DIRECTION_LEFT)) {
#line 1624 "../src/worm.vala"
				worm_direction_set (self, WORM_DIRECTION_LEFT);
#line 1625 "../src/worm.vala"
				result = TRUE;
#line 1625 "../src/worm.vala"
				_g_object_unref0 (properties);
#line 1625 "../src/worm.vala"
				return result;
#line 8606 "worm.c"
			}
		}
	}
#line 1629 "../src/worm.vala"
	result = FALSE;
#line 1629 "../src/worm.vala"
	_g_object_unref0 (properties);
#line 1629 "../src/worm.vala"
	return result;
#line 8616 "worm.c"
}

static void
worm_queue_keypress (Worm* self,
                     WormDirection dir)
{
	gboolean _tmp0_ = FALSE;
	GeeArrayQueue* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GeeArrayQueue* _tmp6_;
#line 1632 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1637 "../src/worm.vala"
	_tmp1_ = self->priv->key_queue;
#line 1637 "../src/worm.vala"
	_tmp2_ = gee_array_queue_get_is_empty (_tmp1_);
#line 1637 "../src/worm.vala"
	_tmp3_ = _tmp2_;
#line 1637 "../src/worm.vala"
	if (!_tmp3_) {
#line 8638 "worm.c"
		GeeArrayQueue* _tmp4_;
		gpointer _tmp5_;
#line 1637 "../src/worm.vala"
		_tmp4_ = self->priv->key_queue;
#line 1637 "../src/worm.vala"
		_tmp5_ = gee_abstract_queue_peek ((GeeAbstractQueue*) _tmp4_);
#line 1637 "../src/worm.vala"
		_tmp0_ = dir == ((WormDirection) ((gintptr) _tmp5_));
#line 8647 "worm.c"
	} else {
#line 1637 "../src/worm.vala"
		_tmp0_ = FALSE;
#line 8651 "worm.c"
	}
#line 1637 "../src/worm.vala"
	if (_tmp0_) {
#line 1638 "../src/worm.vala"
		return;
#line 8657 "worm.c"
	}
#line 1640 "../src/worm.vala"
	_tmp6_ = self->priv->key_queue;
#line 1640 "../src/worm.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, (gpointer) ((gintptr) dir));
#line 8663 "worm.c"
}

static void
worm_dequeue_keypress (Worm* self)
{
	GeeArrayQueue* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GeeArrayQueue* _tmp3_;
	gpointer _tmp4_;
#line 1643 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1643 "../src/worm.vala"
	_tmp0_ = self->priv->key_queue;
#line 1643 "../src/worm.vala"
	_tmp1_ = gee_array_queue_get_is_empty (_tmp0_);
#line 1643 "../src/worm.vala"
	_tmp2_ = _tmp1_;
#line 1643 "../src/worm.vala"
	_vala_return_if_fail (!_tmp2_, "!key_queue.is_empty");
#line 1646 "../src/worm.vala"
	_tmp3_ = self->priv->key_queue;
#line 1646 "../src/worm.vala"
	_tmp4_ = gee_abstract_queue_poll ((GeeAbstractQueue*) _tmp3_);
#line 1646 "../src/worm.vala"
	worm_direction_set (self, (WormDirection) ((gintptr) _tmp4_));
#line 8690 "worm.c"
}

static void
_vala_array_add8 (Position* * array,
                  gint* length,
                  gint* size,
                  const Position* value)
{
#line 1681 "../src/worm.vala"
	if ((*length) == (*size)) {
#line 1681 "../src/worm.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1681 "../src/worm.vala"
		*array = g_renew (Position, *array, *size);
#line 8705 "worm.c"
	}
#line 1681 "../src/worm.vala"
	(*array)[(*length)++] = *value;
#line 8709 "worm.c"
}

static gint
worm_ai_deadend (gint* board,
                 gint board_length1,
                 gint board_length2,
                 WormMap* worm_map,
                 Position* position,
                 gint length)
{
	Position* p = NULL;
	Position _tmp0_;
	Position* _tmp1_;
	gint p_length1;
	gint _p_size_;
	gint _tmp27_ = 0;
	Position* _tmp28_;
	gint _tmp28__length1;
	gint result;
#line 1667 "../src/worm.vala"
	g_return_val_if_fail (worm_map != NULL, 0);
#line 1667 "../src/worm.vala"
	g_return_val_if_fail (position != NULL, 0);
#line 1669 "../src/worm.vala"
	_tmp0_ = *position;
#line 1669 "../src/worm.vala"
	_tmp1_ = g_new0 (Position, 1);
#line 1669 "../src/worm.vala"
	_tmp1_[0] = _tmp0_;
#line 1669 "../src/worm.vala"
	p = _tmp1_;
#line 1669 "../src/worm.vala"
	p_length1 = 1;
#line 1669 "../src/worm.vala"
	_p_size_ = p_length1;
#line 8745 "worm.c"
	{
		guint i = 0U;
#line 1670 "../src/worm.vala"
		i = (guint) 0;
#line 8750 "worm.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1670 "../src/worm.vala"
			_tmp2_ = TRUE;
#line 1670 "../src/worm.vala"
			while (TRUE) {
#line 8757 "worm.c"
				gboolean _tmp4_ = FALSE;
				Position* _tmp5_;
				gint _tmp5__length1;
#line 1670 "../src/worm.vala"
				if (!_tmp2_) {
#line 8763 "worm.c"
					guint _tmp3_;
#line 1670 "../src/worm.vala"
					_tmp3_ = i;
#line 1670 "../src/worm.vala"
					i = _tmp3_ + 1;
#line 8769 "worm.c"
				}
#line 1670 "../src/worm.vala"
				_tmp2_ = FALSE;
#line 1670 "../src/worm.vala"
				_tmp5_ = p;
#line 1670 "../src/worm.vala"
				_tmp5__length1 = p_length1;
#line 1670 "../src/worm.vala"
				if (((guint) _tmp5__length1) > i) {
#line 8779 "worm.c"
					Position* _tmp6_;
					gint _tmp6__length1;
#line 1670 "../src/worm.vala"
					_tmp6_ = p;
#line 1670 "../src/worm.vala"
					_tmp6__length1 = p_length1;
#line 1670 "../src/worm.vala"
					_tmp4_ = (_tmp6__length1 - 1) < length;
#line 8788 "worm.c"
				} else {
#line 1670 "../src/worm.vala"
					_tmp4_ = FALSE;
#line 8792 "worm.c"
				}
#line 1670 "../src/worm.vala"
				if (!_tmp4_) {
#line 1670 "../src/worm.vala"
					break;
#line 8798 "worm.c"
				}
				{
					guint dir = 0U;
#line 1672 "../src/worm.vala"
					dir = (guint) 4;
#line 8804 "worm.c"
					{
						gboolean _tmp7_ = FALSE;
#line 1672 "../src/worm.vala"
						_tmp7_ = TRUE;
#line 1672 "../src/worm.vala"
						while (TRUE) {
#line 8811 "worm.c"
							gboolean _tmp9_ = FALSE;
							Position new_position = {0};
							Position* _tmp11_;
							gint _tmp11__length1;
							Position _tmp12_;
							gint _tmp13_;
							gint _tmp14_;
							gboolean _tmp15_ = FALSE;
							gboolean _tmp16_ = FALSE;
							guint* _tmp17_;
							gint _tmp17__length1;
							gint _tmp17__length2;
							Position _tmp18_;
							Position _tmp19_;
							guint _tmp20_;
#line 1672 "../src/worm.vala"
							if (!_tmp7_) {
#line 8829 "worm.c"
								guint _tmp8_;
#line 1672 "../src/worm.vala"
								_tmp8_ = dir;
#line 1672 "../src/worm.vala"
								dir = _tmp8_ - 1;
#line 8835 "worm.c"
							}
#line 1672 "../src/worm.vala"
							_tmp7_ = FALSE;
#line 1672 "../src/worm.vala"
							if (dir > ((guint) 0)) {
#line 8841 "worm.c"
								Position* _tmp10_;
								gint _tmp10__length1;
#line 1672 "../src/worm.vala"
								_tmp10_ = p;
#line 1672 "../src/worm.vala"
								_tmp10__length1 = p_length1;
#line 1672 "../src/worm.vala"
								_tmp9_ = (_tmp10__length1 - 1) < length;
#line 8850 "worm.c"
							} else {
#line 1672 "../src/worm.vala"
								_tmp9_ = FALSE;
#line 8854 "worm.c"
							}
#line 1672 "../src/worm.vala"
							if (!_tmp9_) {
#line 1672 "../src/worm.vala"
								break;
#line 8860 "worm.c"
							}
#line 1674 "../src/worm.vala"
							_tmp11_ = p;
#line 1674 "../src/worm.vala"
							_tmp11__length1 = p_length1;
#line 1674 "../src/worm.vala"
							_tmp12_ = _tmp11_[i];
#line 1674 "../src/worm.vala"
							new_position = _tmp12_;
#line 1675 "../src/worm.vala"
							_tmp13_ = board_length1;
#line 1675 "../src/worm.vala"
							_tmp14_ = board_length2;
#line 1675 "../src/worm.vala"
							position_move (&new_position, (WormDirection) dir, (guint8) _tmp13_, (guint8) _tmp14_);
#line 1676 "../src/worm.vala"
							_tmp17_ = worm_deadend_board;
#line 1676 "../src/worm.vala"
							_tmp17__length1 = worm_deadend_board_length1;
#line 1676 "../src/worm.vala"
							_tmp17__length2 = worm_deadend_board_length2;
#line 1676 "../src/worm.vala"
							_tmp18_ = new_position;
#line 1676 "../src/worm.vala"
							_tmp19_ = new_position;
#line 1676 "../src/worm.vala"
							_tmp20_ = _tmp17_[(_tmp18_.x * _tmp17__length2) + _tmp19_.y];
#line 1676 "../src/worm.vala"
							if (_tmp20_ != worm_deadend_runnumber) {
#line 8890 "worm.c"
								Position _tmp21_;
#line 1677 "../src/worm.vala"
								_tmp21_ = new_position;
#line 1677 "../src/worm.vala"
								_tmp16_ = !worm_is_board_position_occupied (&_tmp21_, board, (gint) board_length1, (gint) board_length2);
#line 8896 "worm.c"
							} else {
#line 1676 "../src/worm.vala"
								_tmp16_ = FALSE;
#line 8900 "worm.c"
							}
#line 1676 "../src/worm.vala"
							if (_tmp16_) {
#line 8904 "worm.c"
								Position _tmp22_;
#line 1678 "../src/worm.vala"
								_tmp22_ = new_position;
#line 1678 "../src/worm.vala"
								_tmp15_ = !worm_map_contain_position (worm_map, &_tmp22_);
#line 8910 "worm.c"
							} else {
#line 1676 "../src/worm.vala"
								_tmp15_ = FALSE;
#line 8914 "worm.c"
							}
#line 1676 "../src/worm.vala"
							if (_tmp15_) {
#line 8918 "worm.c"
								guint* _tmp23_;
								gint _tmp23__length1;
								gint _tmp23__length2;
								Position _tmp24_;
								Position _tmp25_;
								Position _tmp26_;
#line 1680 "../src/worm.vala"
								_tmp23_ = worm_deadend_board;
#line 1680 "../src/worm.vala"
								_tmp23__length1 = worm_deadend_board_length1;
#line 1680 "../src/worm.vala"
								_tmp23__length2 = worm_deadend_board_length2;
#line 1680 "../src/worm.vala"
								_tmp24_ = new_position;
#line 1680 "../src/worm.vala"
								_tmp25_ = new_position;
#line 1680 "../src/worm.vala"
								_tmp23_[(_tmp24_.x * _tmp23__length2) + _tmp25_.y] = worm_deadend_runnumber;
#line 1681 "../src/worm.vala"
								_tmp26_ = new_position;
#line 1681 "../src/worm.vala"
								_vala_array_add8 (&p, &p_length1, &_p_size_, &_tmp26_);
#line 8941 "worm.c"
							}
						}
					}
				}
			}
		}
	}
#line 1685 "../src/worm.vala"
	_tmp28_ = p;
#line 1685 "../src/worm.vala"
	_tmp28__length1 = p_length1;
#line 1685 "../src/worm.vala"
	if ((_tmp28__length1 - 1) > length) {
#line 1685 "../src/worm.vala"
		_tmp27_ = 0;
#line 8957 "worm.c"
	} else {
		Position* _tmp29_;
		gint _tmp29__length1;
#line 1685 "../src/worm.vala"
		_tmp29_ = p;
#line 1685 "../src/worm.vala"
		_tmp29__length1 = p_length1;
#line 1685 "../src/worm.vala"
		_tmp27_ = length - (_tmp29__length1 - 1);
#line 8967 "worm.c"
	}
#line 1685 "../src/worm.vala"
	result = _tmp27_;
#line 1685 "../src/worm.vala"
	p = (g_free (p), NULL);
#line 1685 "../src/worm.vala"
	return result;
#line 8975 "worm.c"
}

gint
worm_ai_deadend_after (gint* board,
                       gint board_length1,
                       gint board_length2,
                       GeeLinkedList* worms,
                       WormMap* worm_map,
                       Position* old_position,
                       WormDirection direction,
                       gint length)
{
	guint8 width = 0U;
	gint _tmp0_;
	guint8 height = 0U;
	gint _tmp1_;
	guint _tmp2_;
	Position new_position = {0};
	Position _tmp47_;
	guint* _tmp48_;
	gint _tmp48__length1;
	gint _tmp48__length2;
	Position _tmp49_;
	Position _tmp50_;
	guint* _tmp51_;
	gint _tmp51__length1;
	gint _tmp51__length2;
	Position _tmp52_;
	Position _tmp53_;
	gint cl = 0;
	Position _tmp54_;
	gint result;
#line 1697 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, 0);
#line 1697 "../src/worm.vala"
	g_return_val_if_fail (worm_map != NULL, 0);
#line 1697 "../src/worm.vala"
	g_return_val_if_fail (old_position != NULL, 0);
#line 1699 "../src/worm.vala"
	_tmp0_ = board_length1;
#line 1699 "../src/worm.vala"
	width = (guint8) _tmp0_;
#line 1700 "../src/worm.vala"
	_tmp1_ = board_length2;
#line 1700 "../src/worm.vala"
	height = (guint8) _tmp1_;
#line 1702 "../src/worm.vala"
	worm_deadend_runnumber = worm_deadend_runnumber + 1;
#line 1702 "../src/worm.vala"
	_tmp2_ = worm_deadend_runnumber;
#line 1702 "../src/worm.vala"
	if (_tmp2_ == ((guint) 0)) {
#line 9028 "worm.c"
		guint _tmp12_;
		{
			gint x = 0;
#line 1704 "../src/worm.vala"
			x = 0;
#line 9034 "worm.c"
			{
				gboolean _tmp3_ = FALSE;
#line 1704 "../src/worm.vala"
				_tmp3_ = TRUE;
#line 1704 "../src/worm.vala"
				while (TRUE) {
#line 9041 "worm.c"
					guint* _tmp5_;
					gint _tmp5__length1;
					gint _tmp5__length2;
					gint _tmp6_;
#line 1704 "../src/worm.vala"
					if (!_tmp3_) {
#line 9048 "worm.c"
						gint _tmp4_;
#line 1704 "../src/worm.vala"
						_tmp4_ = x;
#line 1704 "../src/worm.vala"
						x = _tmp4_ + 1;
#line 9054 "worm.c"
					}
#line 1704 "../src/worm.vala"
					_tmp3_ = FALSE;
#line 1704 "../src/worm.vala"
					_tmp5_ = worm_deadend_board;
#line 1704 "../src/worm.vala"
					_tmp5__length1 = worm_deadend_board_length1;
#line 1704 "../src/worm.vala"
					_tmp5__length2 = worm_deadend_board_length2;
#line 1704 "../src/worm.vala"
					_tmp6_ = _tmp5__length1;
#line 1704 "../src/worm.vala"
					if (!(x < _tmp6_)) {
#line 1704 "../src/worm.vala"
						break;
#line 9070 "worm.c"
					}
					{
						gint y = 0;
#line 1705 "../src/worm.vala"
						y = 0;
#line 9076 "worm.c"
						{
							gboolean _tmp7_ = FALSE;
#line 1705 "../src/worm.vala"
							_tmp7_ = TRUE;
#line 1705 "../src/worm.vala"
							while (TRUE) {
#line 9083 "worm.c"
								guint* _tmp9_;
								gint _tmp9__length1;
								gint _tmp9__length2;
								gint _tmp10_;
								guint* _tmp11_;
								gint _tmp11__length1;
								gint _tmp11__length2;
#line 1705 "../src/worm.vala"
								if (!_tmp7_) {
#line 9093 "worm.c"
									gint _tmp8_;
#line 1705 "../src/worm.vala"
									_tmp8_ = y;
#line 1705 "../src/worm.vala"
									y = _tmp8_ + 1;
#line 9099 "worm.c"
								}
#line 1705 "../src/worm.vala"
								_tmp7_ = FALSE;
#line 1705 "../src/worm.vala"
								_tmp9_ = worm_deadend_board;
#line 1705 "../src/worm.vala"
								_tmp9__length1 = worm_deadend_board_length1;
#line 1705 "../src/worm.vala"
								_tmp9__length2 = worm_deadend_board_length2;
#line 1705 "../src/worm.vala"
								_tmp10_ = _tmp9__length2;
#line 1705 "../src/worm.vala"
								if (!(y < _tmp10_)) {
#line 1705 "../src/worm.vala"
									break;
#line 9115 "worm.c"
								}
#line 1706 "../src/worm.vala"
								_tmp11_ = worm_deadend_board;
#line 1706 "../src/worm.vala"
								_tmp11__length1 = worm_deadend_board_length1;
#line 1706 "../src/worm.vala"
								_tmp11__length2 = worm_deadend_board_length2;
#line 1706 "../src/worm.vala"
								_tmp11_[(x * _tmp11__length2) + y] = worm_deadend_runnumber;
#line 9125 "worm.c"
							}
						}
					}
				}
			}
		}
#line 1707 "../src/worm.vala"
		_tmp12_ = worm_deadend_runnumber;
#line 1707 "../src/worm.vala"
		worm_deadend_runnumber = _tmp12_ + 1;
#line 9136 "worm.c"
	}
	{
		gint i = 0;
		gint _tmp13_;
		gint _tmp14_;
#line 1710 "../src/worm.vala"
		_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) worms);
#line 1710 "../src/worm.vala"
		_tmp14_ = _tmp13_;
#line 1710 "../src/worm.vala"
		i = _tmp14_ - 1;
#line 9148 "worm.c"
		{
			gboolean _tmp15_ = FALSE;
#line 1710 "../src/worm.vala"
			_tmp15_ = TRUE;
#line 1710 "../src/worm.vala"
			while (TRUE) {
#line 9155 "worm.c"
				gboolean _tmp17_ = FALSE;
				gpointer _tmp18_;
				Worm* _tmp19_;
				gboolean _tmp20_;
#line 1710 "../src/worm.vala"
				if (!_tmp15_) {
#line 9162 "worm.c"
					gint _tmp16_;
#line 1710 "../src/worm.vala"
					_tmp16_ = i;
#line 1710 "../src/worm.vala"
					i = _tmp16_ - 1;
#line 9168 "worm.c"
				}
#line 1710 "../src/worm.vala"
				_tmp15_ = FALSE;
#line 1710 "../src/worm.vala"
				if (!(i >= 0)) {
#line 1710 "../src/worm.vala"
					break;
#line 9176 "worm.c"
				}
#line 1712 "../src/worm.vala"
				_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) worms, i);
#line 1712 "../src/worm.vala"
				_tmp19_ = (Worm*) _tmp18_;
#line 1712 "../src/worm.vala"
				_tmp20_ = !_tmp19_->is_stopped;
#line 1712 "../src/worm.vala"
				_g_object_unref0 (_tmp19_);
#line 1712 "../src/worm.vala"
				if (_tmp20_) {
#line 9188 "worm.c"
					gpointer _tmp21_;
					Worm* _tmp22_;
					WormPositions* _tmp23_;
					gboolean _tmp24_;
					gboolean _tmp25_;
#line 1712 "../src/worm.vala"
					_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) worms, i);
#line 1712 "../src/worm.vala"
					_tmp22_ = (Worm*) _tmp21_;
#line 1712 "../src/worm.vala"
					_tmp23_ = _tmp22_->list;
#line 1712 "../src/worm.vala"
					_tmp24_ = gee_collection_get_is_empty ((GeeCollection*) _tmp23_);
#line 1712 "../src/worm.vala"
					_tmp25_ = _tmp24_;
#line 1712 "../src/worm.vala"
					_tmp17_ = !_tmp25_;
#line 1712 "../src/worm.vala"
					_g_object_unref0 (_tmp22_);
#line 9208 "worm.c"
				} else {
#line 1712 "../src/worm.vala"
					_tmp17_ = FALSE;
#line 9212 "worm.c"
				}
#line 1712 "../src/worm.vala"
				if (_tmp17_) {
#line 9216 "worm.c"
					guint8 target_x = 0U;
					gpointer _tmp26_;
					Worm* _tmp27_;
					Position _tmp28_ = {0};
					Position _tmp29_;
					guint8 _tmp30_;
					guint8 target_y = 0U;
					gpointer _tmp31_;
					Worm* _tmp32_;
					Position _tmp33_ = {0};
					Position _tmp34_;
					guint8 _tmp35_;
					gboolean _tmp36_ = FALSE;
					Position _tmp37_;
#line 1714 "../src/worm.vala"
					_tmp26_ = gee_abstract_list_get ((GeeAbstractList*) worms, i);
#line 1714 "../src/worm.vala"
					_tmp27_ = (Worm*) _tmp26_;
#line 1714 "../src/worm.vala"
					worm_get_head (_tmp27_, &_tmp28_);
#line 1714 "../src/worm.vala"
					_tmp29_ = _tmp28_;
#line 1714 "../src/worm.vala"
					_tmp30_ = _tmp29_.x;
#line 1714 "../src/worm.vala"
					_g_object_unref0 (_tmp27_);
#line 1714 "../src/worm.vala"
					target_x = _tmp30_;
#line 1715 "../src/worm.vala"
					_tmp31_ = gee_abstract_list_get ((GeeAbstractList*) worms, i);
#line 1715 "../src/worm.vala"
					_tmp32_ = (Worm*) _tmp31_;
#line 1715 "../src/worm.vala"
					worm_get_head (_tmp32_, &_tmp33_);
#line 1715 "../src/worm.vala"
					_tmp34_ = _tmp33_;
#line 1715 "../src/worm.vala"
					_tmp35_ = _tmp34_.y;
#line 1715 "../src/worm.vala"
					_g_object_unref0 (_tmp32_);
#line 1715 "../src/worm.vala"
					target_y = _tmp35_;
#line 1716 "../src/worm.vala"
					_tmp37_ = *old_position;
#line 1716 "../src/worm.vala"
					if (target_x == _tmp37_.x) {
#line 9263 "worm.c"
						Position _tmp38_;
#line 1717 "../src/worm.vala"
						_tmp38_ = *old_position;
#line 1717 "../src/worm.vala"
						_tmp36_ = target_y == _tmp38_.y;
#line 9269 "worm.c"
					} else {
#line 1716 "../src/worm.vala"
						_tmp36_ = FALSE;
#line 9273 "worm.c"
					}
#line 1716 "../src/worm.vala"
					if (_tmp36_) {
#line 1718 "../src/worm.vala"
						continue;
#line 9279 "worm.c"
					}
#line 1720 "../src/worm.vala"
					if (((gint) target_x) > 0) {
#line 9283 "worm.c"
						guint* _tmp39_;
						gint _tmp39__length1;
						gint _tmp39__length2;
#line 1720 "../src/worm.vala"
						_tmp39_ = worm_deadend_board;
#line 1720 "../src/worm.vala"
						_tmp39__length1 = worm_deadend_board_length1;
#line 1720 "../src/worm.vala"
						_tmp39__length2 = worm_deadend_board_length2;
#line 1720 "../src/worm.vala"
						_tmp39_[((target_x - 1) * _tmp39__length2) + target_y] = worm_deadend_runnumber;
#line 9295 "worm.c"
					} else {
						guint* _tmp40_;
						gint _tmp40__length1;
						gint _tmp40__length2;
#line 1721 "../src/worm.vala"
						_tmp40_ = worm_deadend_board;
#line 1721 "../src/worm.vala"
						_tmp40__length1 = worm_deadend_board_length1;
#line 1721 "../src/worm.vala"
						_tmp40__length2 = worm_deadend_board_length2;
#line 1721 "../src/worm.vala"
						_tmp40_[((width - 1) * _tmp40__length2) + target_y] = worm_deadend_runnumber;
#line 9308 "worm.c"
					}
#line 1722 "../src/worm.vala"
					if (((gint) target_y) > 0) {
#line 9312 "worm.c"
						guint* _tmp41_;
						gint _tmp41__length1;
						gint _tmp41__length2;
#line 1722 "../src/worm.vala"
						_tmp41_ = worm_deadend_board;
#line 1722 "../src/worm.vala"
						_tmp41__length1 = worm_deadend_board_length1;
#line 1722 "../src/worm.vala"
						_tmp41__length2 = worm_deadend_board_length2;
#line 1722 "../src/worm.vala"
						_tmp41_[(target_x * _tmp41__length2) + (target_y - 1)] = worm_deadend_runnumber;
#line 9324 "worm.c"
					} else {
						guint* _tmp42_;
						gint _tmp42__length1;
						gint _tmp42__length2;
#line 1723 "../src/worm.vala"
						_tmp42_ = worm_deadend_board;
#line 1723 "../src/worm.vala"
						_tmp42__length1 = worm_deadend_board_length1;
#line 1723 "../src/worm.vala"
						_tmp42__length2 = worm_deadend_board_length2;
#line 1723 "../src/worm.vala"
						_tmp42_[(target_x * _tmp42__length2) + (height - 1)] = worm_deadend_runnumber;
#line 9337 "worm.c"
					}
#line 1724 "../src/worm.vala"
					if (((gint) target_x) < (width - 1)) {
#line 9341 "worm.c"
						guint* _tmp43_;
						gint _tmp43__length1;
						gint _tmp43__length2;
#line 1724 "../src/worm.vala"
						_tmp43_ = worm_deadend_board;
#line 1724 "../src/worm.vala"
						_tmp43__length1 = worm_deadend_board_length1;
#line 1724 "../src/worm.vala"
						_tmp43__length2 = worm_deadend_board_length2;
#line 1724 "../src/worm.vala"
						_tmp43_[((target_x + 1) * _tmp43__length2) + target_y] = worm_deadend_runnumber;
#line 9353 "worm.c"
					} else {
						guint* _tmp44_;
						gint _tmp44__length1;
						gint _tmp44__length2;
#line 1725 "../src/worm.vala"
						_tmp44_ = worm_deadend_board;
#line 1725 "../src/worm.vala"
						_tmp44__length1 = worm_deadend_board_length1;
#line 1725 "../src/worm.vala"
						_tmp44__length2 = worm_deadend_board_length2;
#line 1725 "../src/worm.vala"
						_tmp44_[(0 * _tmp44__length2) + target_y] = worm_deadend_runnumber;
#line 9366 "worm.c"
					}
#line 1726 "../src/worm.vala"
					if (((gint) target_y) < (height - 1)) {
#line 9370 "worm.c"
						guint* _tmp45_;
						gint _tmp45__length1;
						gint _tmp45__length2;
#line 1726 "../src/worm.vala"
						_tmp45_ = worm_deadend_board;
#line 1726 "../src/worm.vala"
						_tmp45__length1 = worm_deadend_board_length1;
#line 1726 "../src/worm.vala"
						_tmp45__length2 = worm_deadend_board_length2;
#line 1726 "../src/worm.vala"
						_tmp45_[(target_x * _tmp45__length2) + (target_y + 1)] = worm_deadend_runnumber;
#line 9382 "worm.c"
					} else {
						guint* _tmp46_;
						gint _tmp46__length1;
						gint _tmp46__length2;
#line 1727 "../src/worm.vala"
						_tmp46_ = worm_deadend_board;
#line 1727 "../src/worm.vala"
						_tmp46__length1 = worm_deadend_board_length1;
#line 1727 "../src/worm.vala"
						_tmp46__length2 = worm_deadend_board_length2;
#line 1727 "../src/worm.vala"
						_tmp46_[(target_x * _tmp46__length2) + 0] = worm_deadend_runnumber;
#line 9395 "worm.c"
					}
				}
			}
		}
	}
#line 1731 "../src/worm.vala"
	_tmp47_ = *old_position;
#line 1731 "../src/worm.vala"
	new_position = _tmp47_;
#line 1732 "../src/worm.vala"
	position_move (&new_position, direction, width, height);
#line 1734 "../src/worm.vala"
	_tmp48_ = worm_deadend_board;
#line 1734 "../src/worm.vala"
	_tmp48__length1 = worm_deadend_board_length1;
#line 1734 "../src/worm.vala"
	_tmp48__length2 = worm_deadend_board_length2;
#line 1734 "../src/worm.vala"
	_tmp49_ = *old_position;
#line 1734 "../src/worm.vala"
	_tmp50_ = *old_position;
#line 1734 "../src/worm.vala"
	_tmp48_[(_tmp49_.x * _tmp48__length2) + _tmp50_.y] = worm_deadend_runnumber;
#line 1735 "../src/worm.vala"
	_tmp51_ = worm_deadend_board;
#line 1735 "../src/worm.vala"
	_tmp51__length1 = worm_deadend_board_length1;
#line 1735 "../src/worm.vala"
	_tmp51__length2 = worm_deadend_board_length2;
#line 1735 "../src/worm.vala"
	_tmp52_ = new_position;
#line 1735 "../src/worm.vala"
	_tmp53_ = new_position;
#line 1735 "../src/worm.vala"
	_tmp51_[(_tmp52_.x * _tmp51__length2) + _tmp53_.y] = worm_deadend_runnumber;
#line 1737 "../src/worm.vala"
	cl = (length * length) / 16;
#line 1738 "../src/worm.vala"
	if (cl < ((gint) width)) {
#line 1739 "../src/worm.vala"
		cl = (gint) width;
#line 9437 "worm.c"
	}
#line 1741 "../src/worm.vala"
	_tmp54_ = new_position;
#line 1741 "../src/worm.vala"
	result = worm_ai_deadend (board, (gint) board_length1, (gint) board_length2, worm_map, &_tmp54_, cl);
#line 1741 "../src/worm.vala"
	return result;
#line 9445 "worm.c"
}

static inline gboolean
worm_ai_too_close (Worm* self,
                   GeeLinkedList* worms,
                   WormDirection direction)
{
	gboolean result;
#line 1748 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1748 "../src/worm.vala"
	g_return_val_if_fail (worms != NULL, FALSE);
#line 9458 "worm.c"
	{
		GeeLinkedList* _worm_list = NULL;
		gint _worm_size = 0;
		GeeLinkedList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _worm_index = 0;
#line 1750 "../src/worm.vala"
		_worm_list = worms;
#line 1750 "../src/worm.vala"
		_tmp0_ = _worm_list;
#line 1750 "../src/worm.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 1750 "../src/worm.vala"
		_tmp2_ = _tmp1_;
#line 1750 "../src/worm.vala"
		_worm_size = _tmp2_;
#line 1750 "../src/worm.vala"
		_worm_index = -1;
#line 1750 "../src/worm.vala"
		while (TRUE) {
#line 9480 "worm.c"
			gint _tmp3_;
			gint _tmp4_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp5_;
			gpointer _tmp6_;
			gboolean _tmp7_ = FALSE;
			gboolean _tmp8_ = FALSE;
			Worm* _tmp9_;
			gint16 dx = 0;
			Position _tmp15_ = {0};
			Position _tmp16_;
			Worm* _tmp17_;
			Position _tmp18_ = {0};
			Position _tmp19_;
			gint16 dy = 0;
			Position _tmp20_ = {0};
			Position _tmp21_;
			Worm* _tmp22_;
			Position _tmp23_ = {0};
			Position _tmp24_;
#line 1750 "../src/worm.vala"
			_worm_index = _worm_index + 1;
#line 1750 "../src/worm.vala"
			_tmp3_ = _worm_index;
#line 1750 "../src/worm.vala"
			_tmp4_ = _worm_size;
#line 1750 "../src/worm.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 1750 "../src/worm.vala"
				break;
#line 9511 "worm.c"
			}
#line 1750 "../src/worm.vala"
			_tmp5_ = _worm_list;
#line 1750 "../src/worm.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _worm_index);
#line 1750 "../src/worm.vala"
			worm = (Worm*) _tmp6_;
#line 1752 "../src/worm.vala"
			_tmp9_ = worm;
#line 1752 "../src/worm.vala"
			if (_tmp9_ == self) {
#line 1752 "../src/worm.vala"
				_tmp8_ = TRUE;
#line 9525 "worm.c"
			} else {
				Worm* _tmp10_;
#line 1752 "../src/worm.vala"
				_tmp10_ = worm;
#line 1752 "../src/worm.vala"
				_tmp8_ = _tmp10_->is_stopped;
#line 9532 "worm.c"
			}
#line 1752 "../src/worm.vala"
			if (_tmp8_) {
#line 1752 "../src/worm.vala"
				_tmp7_ = TRUE;
#line 9538 "worm.c"
			} else {
				Worm* _tmp11_;
				WormPositions* _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
#line 1752 "../src/worm.vala"
				_tmp11_ = worm;
#line 1752 "../src/worm.vala"
				_tmp12_ = _tmp11_->list;
#line 1752 "../src/worm.vala"
				_tmp13_ = gee_collection_get_is_empty ((GeeCollection*) _tmp12_);
#line 1752 "../src/worm.vala"
				_tmp14_ = _tmp13_;
#line 1752 "../src/worm.vala"
				_tmp7_ = _tmp14_;
#line 9554 "worm.c"
			}
#line 1752 "../src/worm.vala"
			if (_tmp7_) {
#line 1753 "../src/worm.vala"
				_g_object_unref0 (worm);
#line 1753 "../src/worm.vala"
				continue;
#line 9562 "worm.c"
			}
#line 1755 "../src/worm.vala"
			worm_get_head (self, &_tmp15_);
#line 1755 "../src/worm.vala"
			_tmp16_ = _tmp15_;
#line 1755 "../src/worm.vala"
			_tmp17_ = worm;
#line 1755 "../src/worm.vala"
			worm_get_head (_tmp17_, &_tmp18_);
#line 1755 "../src/worm.vala"
			_tmp19_ = _tmp18_;
#line 1755 "../src/worm.vala"
			dx = ((gint16) _tmp16_.x) - ((gint16) _tmp19_.x);
#line 1756 "../src/worm.vala"
			worm_get_head (self, &_tmp20_);
#line 1756 "../src/worm.vala"
			_tmp21_ = _tmp20_;
#line 1756 "../src/worm.vala"
			_tmp22_ = worm;
#line 1756 "../src/worm.vala"
			worm_get_head (_tmp22_, &_tmp23_);
#line 1756 "../src/worm.vala"
			_tmp24_ = _tmp23_;
#line 1756 "../src/worm.vala"
			dy = ((gint16) _tmp21_.y) - ((gint16) _tmp24_.y);
#line 1757 "../src/worm.vala"
			switch (direction) {
#line 1757 "../src/worm.vala"
				case WORM_DIRECTION_UP:
#line 9592 "worm.c"
				{
					gboolean _tmp25_ = FALSE;
					gboolean _tmp26_ = FALSE;
					gboolean _tmp27_ = FALSE;
#line 1760 "../src/worm.vala"
					if (((gint) dy) > 0) {
#line 1760 "../src/worm.vala"
						_tmp27_ = ((gint) dy) <= 3;
#line 9601 "worm.c"
					} else {
#line 1760 "../src/worm.vala"
						_tmp27_ = FALSE;
#line 9605 "worm.c"
					}
#line 1760 "../src/worm.vala"
					if (_tmp27_) {
#line 1760 "../src/worm.vala"
						_tmp26_ = ((gint) dx) >= -1;
#line 9611 "worm.c"
					} else {
#line 1760 "../src/worm.vala"
						_tmp26_ = FALSE;
#line 9615 "worm.c"
					}
#line 1760 "../src/worm.vala"
					if (_tmp26_) {
#line 1760 "../src/worm.vala"
						_tmp25_ = ((gint) dx) <= 1;
#line 9621 "worm.c"
					} else {
#line 1760 "../src/worm.vala"
						_tmp25_ = FALSE;
#line 9625 "worm.c"
					}
#line 1760 "../src/worm.vala"
					if (_tmp25_) {
#line 1761 "../src/worm.vala"
						result = TRUE;
#line 1761 "../src/worm.vala"
						_g_object_unref0 (worm);
#line 1761 "../src/worm.vala"
						return result;
#line 9635 "worm.c"
					}
#line 1762 "../src/worm.vala"
					break;
#line 9639 "worm.c"
				}
#line 1757 "../src/worm.vala"
				case WORM_DIRECTION_DOWN:
#line 9643 "worm.c"
				{
					gboolean _tmp28_ = FALSE;
					gboolean _tmp29_ = FALSE;
					gboolean _tmp30_ = FALSE;
#line 1765 "../src/worm.vala"
					if (((gint) dy) < 0) {
#line 1765 "../src/worm.vala"
						_tmp30_ = ((gint) dy) >= -3;
#line 9652 "worm.c"
					} else {
#line 1765 "../src/worm.vala"
						_tmp30_ = FALSE;
#line 9656 "worm.c"
					}
#line 1765 "../src/worm.vala"
					if (_tmp30_) {
#line 1765 "../src/worm.vala"
						_tmp29_ = ((gint) dx) >= -1;
#line 9662 "worm.c"
					} else {
#line 1765 "../src/worm.vala"
						_tmp29_ = FALSE;
#line 9666 "worm.c"
					}
#line 1765 "../src/worm.vala"
					if (_tmp29_) {
#line 1765 "../src/worm.vala"
						_tmp28_ = ((gint) dx) <= 1;
#line 9672 "worm.c"
					} else {
#line 1765 "../src/worm.vala"
						_tmp28_ = FALSE;
#line 9676 "worm.c"
					}
#line 1765 "../src/worm.vala"
					if (_tmp28_) {
#line 1766 "../src/worm.vala"
						result = TRUE;
#line 1766 "../src/worm.vala"
						_g_object_unref0 (worm);
#line 1766 "../src/worm.vala"
						return result;
#line 9686 "worm.c"
					}
#line 1767 "../src/worm.vala"
					break;
#line 9690 "worm.c"
				}
#line 1757 "../src/worm.vala"
				case WORM_DIRECTION_LEFT:
#line 9694 "worm.c"
				{
					gboolean _tmp31_ = FALSE;
					gboolean _tmp32_ = FALSE;
					gboolean _tmp33_ = FALSE;
#line 1770 "../src/worm.vala"
					if (((gint) dx) > 0) {
#line 1770 "../src/worm.vala"
						_tmp33_ = ((gint) dx) <= 3;
#line 9703 "worm.c"
					} else {
#line 1770 "../src/worm.vala"
						_tmp33_ = FALSE;
#line 9707 "worm.c"
					}
#line 1770 "../src/worm.vala"
					if (_tmp33_) {
#line 1770 "../src/worm.vala"
						_tmp32_ = ((gint) dy) >= -1;
#line 9713 "worm.c"
					} else {
#line 1770 "../src/worm.vala"
						_tmp32_ = FALSE;
#line 9717 "worm.c"
					}
#line 1770 "../src/worm.vala"
					if (_tmp32_) {
#line 1770 "../src/worm.vala"
						_tmp31_ = ((gint) dy) <= 1;
#line 9723 "worm.c"
					} else {
#line 1770 "../src/worm.vala"
						_tmp31_ = FALSE;
#line 9727 "worm.c"
					}
#line 1770 "../src/worm.vala"
					if (_tmp31_) {
#line 1771 "../src/worm.vala"
						result = TRUE;
#line 1771 "../src/worm.vala"
						_g_object_unref0 (worm);
#line 1771 "../src/worm.vala"
						return result;
#line 9737 "worm.c"
					}
#line 1772 "../src/worm.vala"
					break;
#line 9741 "worm.c"
				}
#line 1757 "../src/worm.vala"
				case WORM_DIRECTION_RIGHT:
#line 9745 "worm.c"
				{
					gboolean _tmp34_ = FALSE;
					gboolean _tmp35_ = FALSE;
					gboolean _tmp36_ = FALSE;
#line 1775 "../src/worm.vala"
					if (((gint) dx) < 0) {
#line 1775 "../src/worm.vala"
						_tmp36_ = ((gint) dx) >= -3;
#line 9754 "worm.c"
					} else {
#line 1775 "../src/worm.vala"
						_tmp36_ = FALSE;
#line 9758 "worm.c"
					}
#line 1775 "../src/worm.vala"
					if (_tmp36_) {
#line 1775 "../src/worm.vala"
						_tmp35_ = ((gint) dy) >= -1;
#line 9764 "worm.c"
					} else {
#line 1775 "../src/worm.vala"
						_tmp35_ = FALSE;
#line 9768 "worm.c"
					}
#line 1775 "../src/worm.vala"
					if (_tmp35_) {
#line 1775 "../src/worm.vala"
						_tmp34_ = ((gint) dy) <= 1;
#line 9774 "worm.c"
					} else {
#line 1775 "../src/worm.vala"
						_tmp34_ = FALSE;
#line 9778 "worm.c"
					}
#line 1775 "../src/worm.vala"
					if (_tmp34_) {
#line 1776 "../src/worm.vala"
						result = TRUE;
#line 1776 "../src/worm.vala"
						_g_object_unref0 (worm);
#line 1776 "../src/worm.vala"
						return result;
#line 9788 "worm.c"
					}
#line 1777 "../src/worm.vala"
					break;
#line 9792 "worm.c"
				}
				default:
				{
#line 1780 "../src/worm.vala"
					g_assert_not_reached ();
#line 9798 "worm.c"
				}
			}
#line 1750 "../src/worm.vala"
			_g_object_unref0 (worm);
#line 9803 "worm.c"
		}
	}
#line 1783 "../src/worm.vala"
	result = FALSE;
#line 1783 "../src/worm.vala"
	return result;
#line 9810 "worm.c"
}

gboolean
worm_ai_is_bonus_more_attractive (Worm* self,
                                  BonuseType b0,
                                  gint64 d0,
                                  BonuseType b1,
                                  gint64 d1)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean result;
#line 1786 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1789 "../src/worm.vala"
	if (b0 == BONUS_ETYPE_LIFE) {
#line 1789 "../src/worm.vala"
		_tmp3_ = b1 == BONUS_ETYPE_LIFE;
#line 9831 "worm.c"
	} else {
#line 1789 "../src/worm.vala"
		_tmp3_ = FALSE;
#line 9835 "worm.c"
	}
#line 1789 "../src/worm.vala"
	if (_tmp3_) {
#line 1789 "../src/worm.vala"
		_tmp2_ = TRUE;
#line 9841 "worm.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 1790 "../src/worm.vala"
		if (b0 != BONUS_ETYPE_LIFE) {
#line 1790 "../src/worm.vala"
			_tmp4_ = b1 != BONUS_ETYPE_LIFE;
#line 9848 "worm.c"
		} else {
#line 1790 "../src/worm.vala"
			_tmp4_ = FALSE;
#line 9852 "worm.c"
		}
#line 1790 "../src/worm.vala"
		_tmp2_ = _tmp4_;
#line 9856 "worm.c"
	}
#line 1789 "../src/worm.vala"
	if (_tmp2_) {
#line 1790 "../src/worm.vala"
		_tmp1_ = d0 < d1;
#line 9862 "worm.c"
	} else {
#line 1789 "../src/worm.vala"
		_tmp1_ = FALSE;
#line 9866 "worm.c"
	}
#line 1789 "../src/worm.vala"
	if (_tmp1_) {
#line 1789 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 9872 "worm.c"
	} else {
		gboolean _tmp5_ = FALSE;
#line 1791 "../src/worm.vala"
		if (b0 == BONUS_ETYPE_LIFE) {
#line 1791 "../src/worm.vala"
			_tmp5_ = b1 != BONUS_ETYPE_LIFE;
#line 9879 "worm.c"
		} else {
#line 1791 "../src/worm.vala"
			_tmp5_ = FALSE;
#line 9883 "worm.c"
		}
#line 1791 "../src/worm.vala"
		_tmp0_ = _tmp5_;
#line 9887 "worm.c"
	}
#line 1789 "../src/worm.vala"
	result = _tmp0_;
#line 1789 "../src/worm.vala"
	return result;
#line 9893 "worm.c"
}

gboolean
worm_ai_can_see_bonus (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       Position* origin,
                       Bonus* bonus,
                       WormDirection direction)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	Position _tmp4_;
	guint8 _tmp5_;
	guint8 _tmp6_;
	Slice* slice = NULL;
	Slice* _tmp31_;
	Slice* _tmp32_;
	Slice* _tmp33_;
	Position _tmp34_;
	guint8 _tmp35_;
	guint8 _tmp36_;
	guint8 _tmp37_;
	guint8 _tmp38_;
	Slice* _tmp39_;
	gboolean result;
#line 1794 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1794 "../src/worm.vala"
	g_return_val_if_fail (origin != NULL, FALSE);
#line 1794 "../src/worm.vala"
	g_return_val_if_fail (bonus != NULL, FALSE);
#line 1796 "../src/worm.vala"
	_tmp4_ = *origin;
#line 1796 "../src/worm.vala"
	_tmp5_ = bonus_get_x (bonus);
#line 1796 "../src/worm.vala"
	_tmp6_ = _tmp5_;
#line 1796 "../src/worm.vala"
	if (_tmp4_.x == _tmp6_) {
#line 9937 "worm.c"
		Position _tmp7_;
		guint8 _tmp8_;
		guint8 _tmp9_;
#line 1796 "../src/worm.vala"
		_tmp7_ = *origin;
#line 1796 "../src/worm.vala"
		_tmp8_ = bonus_get_y (bonus);
#line 1796 "../src/worm.vala"
		_tmp9_ = _tmp8_;
#line 1796 "../src/worm.vala"
		_tmp3_ = _tmp7_.y == _tmp9_;
#line 9949 "worm.c"
	} else {
#line 1796 "../src/worm.vala"
		_tmp3_ = FALSE;
#line 9953 "worm.c"
	}
#line 1796 "../src/worm.vala"
	if (_tmp3_) {
#line 1796 "../src/worm.vala"
		_tmp2_ = TRUE;
#line 9959 "worm.c"
	} else {
		gboolean _tmp10_ = FALSE;
		Position _tmp11_;
		guint8 _tmp12_;
		guint8 _tmp13_;
#line 1797 "../src/worm.vala"
		_tmp11_ = *origin;
#line 1797 "../src/worm.vala"
		_tmp12_ = bonus_get_x (bonus);
#line 1797 "../src/worm.vala"
		_tmp13_ = _tmp12_;
#line 1797 "../src/worm.vala"
		if (((gint) _tmp11_.x) == (_tmp13_ + 1)) {
#line 9973 "worm.c"
			Position _tmp14_;
			guint8 _tmp15_;
			guint8 _tmp16_;
#line 1797 "../src/worm.vala"
			_tmp14_ = *origin;
#line 1797 "../src/worm.vala"
			_tmp15_ = bonus_get_y (bonus);
#line 1797 "../src/worm.vala"
			_tmp16_ = _tmp15_;
#line 1797 "../src/worm.vala"
			_tmp10_ = _tmp14_.y == _tmp16_;
#line 9985 "worm.c"
		} else {
#line 1797 "../src/worm.vala"
			_tmp10_ = FALSE;
#line 9989 "worm.c"
		}
#line 1797 "../src/worm.vala"
		_tmp2_ = _tmp10_;
#line 9993 "worm.c"
	}
#line 1796 "../src/worm.vala"
	if (_tmp2_) {
#line 1796 "../src/worm.vala"
		_tmp1_ = TRUE;
#line 9999 "worm.c"
	} else {
		gboolean _tmp17_ = FALSE;
		Position _tmp18_;
		guint8 _tmp19_;
		guint8 _tmp20_;
#line 1798 "../src/worm.vala"
		_tmp18_ = *origin;
#line 1798 "../src/worm.vala"
		_tmp19_ = bonus_get_x (bonus);
#line 1798 "../src/worm.vala"
		_tmp20_ = _tmp19_;
#line 1798 "../src/worm.vala"
		if (_tmp18_.x == _tmp20_) {
#line 10013 "worm.c"
			Position _tmp21_;
			guint8 _tmp22_;
			guint8 _tmp23_;
#line 1798 "../src/worm.vala"
			_tmp21_ = *origin;
#line 1798 "../src/worm.vala"
			_tmp22_ = bonus_get_y (bonus);
#line 1798 "../src/worm.vala"
			_tmp23_ = _tmp22_;
#line 1798 "../src/worm.vala"
			_tmp17_ = ((gint) _tmp21_.y) == (_tmp23_ + 1);
#line 10025 "worm.c"
		} else {
#line 1798 "../src/worm.vala"
			_tmp17_ = FALSE;
#line 10029 "worm.c"
		}
#line 1798 "../src/worm.vala"
		_tmp1_ = _tmp17_;
#line 10033 "worm.c"
	}
#line 1796 "../src/worm.vala"
	if (_tmp1_) {
#line 1796 "../src/worm.vala"
		_tmp0_ = TRUE;
#line 10039 "worm.c"
	} else {
		gboolean _tmp24_ = FALSE;
		Position _tmp25_;
		guint8 _tmp26_;
		guint8 _tmp27_;
#line 1799 "../src/worm.vala"
		_tmp25_ = *origin;
#line 1799 "../src/worm.vala"
		_tmp26_ = bonus_get_x (bonus);
#line 1799 "../src/worm.vala"
		_tmp27_ = _tmp26_;
#line 1799 "../src/worm.vala"
		if (((gint) _tmp25_.x) == (_tmp27_ + 1)) {
#line 10053 "worm.c"
			Position _tmp28_;
			guint8 _tmp29_;
			guint8 _tmp30_;
#line 1799 "../src/worm.vala"
			_tmp28_ = *origin;
#line 1799 "../src/worm.vala"
			_tmp29_ = bonus_get_y (bonus);
#line 1799 "../src/worm.vala"
			_tmp30_ = _tmp29_;
#line 1799 "../src/worm.vala"
			_tmp24_ = ((gint) _tmp28_.y) == (_tmp30_ + 1);
#line 10065 "worm.c"
		} else {
#line 1799 "../src/worm.vala"
			_tmp24_ = FALSE;
#line 10069 "worm.c"
		}
#line 1799 "../src/worm.vala"
		_tmp0_ = _tmp24_;
#line 10073 "worm.c"
	}
#line 1796 "../src/worm.vala"
	if (_tmp0_) {
#line 1800 "../src/worm.vala"
		result = TRUE;
#line 1800 "../src/worm.vala"
		return result;
#line 10081 "worm.c"
	}
#line 1801 "../src/worm.vala"
	_tmp31_ = slice_new (NULL);
#line 1801 "../src/worm.vala"
	slice = _tmp31_;
#line 1803 "../src/worm.vala"
	_tmp32_ = slice;
#line 1803 "../src/worm.vala"
	slice_set_direction_view (_tmp32_, direction, board, (gint) board_length1, (gint) board_length2);
#line 1805 "../src/worm.vala"
	_tmp33_ = slice;
#line 1805 "../src/worm.vala"
	_tmp34_ = *origin;
#line 1805 "../src/worm.vala"
	_tmp35_ = bonus_get_x (bonus);
#line 1805 "../src/worm.vala"
	_tmp36_ = _tmp35_;
#line 1805 "../src/worm.vala"
	_tmp37_ = bonus_get_y (bonus);
#line 1805 "../src/worm.vala"
	_tmp38_ = _tmp37_;
#line 1805 "../src/worm.vala"
	slice_intersection_by_position (_tmp33_, &_tmp34_, _tmp36_, _tmp38_, 2);
#line 1806 "../src/worm.vala"
	_tmp39_ = slice;
#line 1806 "../src/worm.vala"
	result = !slice_is_empty (_tmp39_);
#line 1806 "../src/worm.vala"
	_g_object_unref0 (slice);
#line 1806 "../src/worm.vala"
	return result;
#line 10113 "worm.c"
}

gint64
worm_ai_count_distance_to_a_bonus_in_direction (Worm* self,
                                                gint* board,
                                                gint board_length1,
                                                gint board_length2,
                                                WormMap* worm_map,
                                                Position* origin,
                                                WormDirection direction,
                                                BonuseType* bonus_type)
{
	BonuseType _vala_bonus_type = 0;
	gint64 bonus_distance = 0LL;
	Slice* slice = NULL;
	Slice* _tmp0_;
	gint64 result;
#line 1809 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 1809 "../src/worm.vala"
	g_return_val_if_fail (worm_map != NULL, 0LL);
#line 1809 "../src/worm.vala"
	g_return_val_if_fail (origin != NULL, 0LL);
#line 1830 "../src/worm.vala"
	bonus_distance = G_MAXINT64;
#line 1831 "../src/worm.vala"
	_vala_bonus_type = (BonuseType) -1;
#line 1833 "../src/worm.vala"
	_tmp0_ = slice_new (NULL);
#line 1833 "../src/worm.vala"
	slice = _tmp0_;
#line 10145 "worm.c"
	{
		GeeList* _b_list = NULL;
		WormGetBonusesType _tmp1_;
		gpointer _tmp1__target;
		GeeList* _tmp2_;
		gint _b_size = 0;
		GeeList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _b_index = 0;
#line 1834 "../src/worm.vala"
		_tmp1_ = self->priv->get_bonuses;
#line 1834 "../src/worm.vala"
		_tmp1__target = self->priv->get_bonuses_target;
#line 1834 "../src/worm.vala"
		_tmp2_ = _tmp1_ (_tmp1__target);
#line 1834 "../src/worm.vala"
		_b_list = _tmp2_;
#line 1834 "../src/worm.vala"
		_tmp3_ = _b_list;
#line 1834 "../src/worm.vala"
		_tmp4_ = gee_collection_get_size ((GeeCollection*) _tmp3_);
#line 1834 "../src/worm.vala"
		_tmp5_ = _tmp4_;
#line 1834 "../src/worm.vala"
		_b_size = _tmp5_;
#line 1834 "../src/worm.vala"
		_b_index = -1;
#line 1834 "../src/worm.vala"
		while (TRUE) {
#line 10176 "worm.c"
			gint _tmp6_;
			gint _tmp7_;
			Bonus* b = NULL;
			GeeList* _tmp8_;
			gpointer _tmp9_;
			gboolean _tmp10_ = FALSE;
			gboolean _tmp11_ = FALSE;
#line 1834 "../src/worm.vala"
			_b_index = _b_index + 1;
#line 1834 "../src/worm.vala"
			_tmp6_ = _b_index;
#line 1834 "../src/worm.vala"
			_tmp7_ = _b_size;
#line 1834 "../src/worm.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 1834 "../src/worm.vala"
				break;
#line 10194 "worm.c"
			}
#line 1834 "../src/worm.vala"
			_tmp8_ = _b_list;
#line 1834 "../src/worm.vala"
			_tmp9_ = gee_list_get (_tmp8_, _b_index);
#line 1834 "../src/worm.vala"
			b = (Bonus*) _tmp9_;
#line 1836 "../src/worm.vala"
			if (_vala_bonus_type == BONUS_ETYPE_LIFE) {
#line 10204 "worm.c"
				Bonus* _tmp12_;
				BonuseType _tmp13_;
				BonuseType _tmp14_;
#line 1836 "../src/worm.vala"
				_tmp12_ = b;
#line 1836 "../src/worm.vala"
				_tmp13_ = bonus_get_etype (_tmp12_);
#line 1836 "../src/worm.vala"
				_tmp14_ = _tmp13_;
#line 1836 "../src/worm.vala"
				_tmp11_ = _tmp14_ == BONUS_ETYPE_LIFE;
#line 10216 "worm.c"
			} else {
#line 1836 "../src/worm.vala"
				_tmp11_ = FALSE;
#line 10220 "worm.c"
			}
#line 1836 "../src/worm.vala"
			if (_tmp11_) {
#line 1836 "../src/worm.vala"
				_tmp10_ = TRUE;
#line 10226 "worm.c"
			} else {
				gboolean _tmp15_ = FALSE;
#line 1837 "../src/worm.vala"
				if (_vala_bonus_type != BONUS_ETYPE_LIFE) {
#line 10231 "worm.c"
					gboolean _tmp16_ = FALSE;
					gboolean _tmp17_ = FALSE;
					gboolean _tmp18_ = FALSE;
					Bonus* _tmp19_;
					BonuseType _tmp20_;
					BonuseType _tmp21_;
#line 1838 "../src/worm.vala"
					_tmp19_ = b;
#line 1838 "../src/worm.vala"
					_tmp20_ = bonus_get_etype (_tmp19_);
#line 1838 "../src/worm.vala"
					_tmp21_ = _tmp20_;
#line 1838 "../src/worm.vala"
					if (_tmp21_ == BONUS_ETYPE_REGULAR) {
#line 1838 "../src/worm.vala"
						_tmp18_ = TRUE;
#line 10248 "worm.c"
					} else {
						Bonus* _tmp22_;
						BonuseType _tmp23_;
						BonuseType _tmp24_;
#line 1838 "../src/worm.vala"
						_tmp22_ = b;
#line 1838 "../src/worm.vala"
						_tmp23_ = bonus_get_etype (_tmp22_);
#line 1838 "../src/worm.vala"
						_tmp24_ = _tmp23_;
#line 1838 "../src/worm.vala"
						_tmp18_ = _tmp24_ == BONUS_ETYPE_DOUBLE;
#line 10261 "worm.c"
					}
#line 1838 "../src/worm.vala"
					if (_tmp18_) {
#line 1838 "../src/worm.vala"
						_tmp17_ = TRUE;
#line 10267 "worm.c"
					} else {
						Bonus* _tmp25_;
						BonuseType _tmp26_;
						BonuseType _tmp27_;
#line 1839 "../src/worm.vala"
						_tmp25_ = b;
#line 1839 "../src/worm.vala"
						_tmp26_ = bonus_get_etype (_tmp25_);
#line 1839 "../src/worm.vala"
						_tmp27_ = _tmp26_;
#line 1839 "../src/worm.vala"
						_tmp17_ = _tmp27_ == BONUS_ETYPE_LIFE;
#line 10280 "worm.c"
					}
#line 1837 "../src/worm.vala"
					if (_tmp17_) {
#line 1838 "../src/worm.vala"
						_tmp16_ = TRUE;
#line 10286 "worm.c"
					} else {
						Bonus* _tmp28_;
						BonuseType _tmp29_;
						BonuseType _tmp30_;
#line 1839 "../src/worm.vala"
						_tmp28_ = b;
#line 1839 "../src/worm.vala"
						_tmp29_ = bonus_get_etype (_tmp28_);
#line 1839 "../src/worm.vala"
						_tmp30_ = _tmp29_;
#line 1839 "../src/worm.vala"
						_tmp16_ = _tmp30_ == BONUS_ETYPE_REVERSE;
#line 10299 "worm.c"
					}
#line 1837 "../src/worm.vala"
					_tmp15_ = _tmp16_;
#line 10303 "worm.c"
				} else {
#line 1837 "../src/worm.vala"
					_tmp15_ = FALSE;
#line 10307 "worm.c"
				}
#line 1837 "../src/worm.vala"
				_tmp10_ = _tmp15_;
#line 10311 "worm.c"
			}
#line 1836 "../src/worm.vala"
			if (_tmp10_) {
#line 10315 "worm.c"
				Slice* _tmp31_;
				Slice* _tmp32_;
				Position _tmp33_;
				Bonus* _tmp34_;
				guint8 _tmp35_;
				guint8 _tmp36_;
				Bonus* _tmp37_;
				guint8 _tmp38_;
				guint8 _tmp39_;
				Slice* _tmp40_;
#line 1842 "../src/worm.vala"
				_tmp31_ = slice;
#line 1842 "../src/worm.vala"
				slice_set_direction_view (_tmp31_, direction, board, (gint) board_length1, (gint) board_length2);
#line 1844 "../src/worm.vala"
				_tmp32_ = slice;
#line 1844 "../src/worm.vala"
				_tmp33_ = *origin;
#line 1844 "../src/worm.vala"
				_tmp34_ = b;
#line 1844 "../src/worm.vala"
				_tmp35_ = bonus_get_x (_tmp34_);
#line 1844 "../src/worm.vala"
				_tmp36_ = _tmp35_;
#line 1844 "../src/worm.vala"
				_tmp37_ = b;
#line 1844 "../src/worm.vala"
				_tmp38_ = bonus_get_y (_tmp37_);
#line 1844 "../src/worm.vala"
				_tmp39_ = _tmp38_;
#line 1844 "../src/worm.vala"
				slice_intersection_by_position (_tmp32_, &_tmp33_, _tmp36_, _tmp39_, 2);
#line 1845 "../src/worm.vala"
				_tmp40_ = slice;
#line 1845 "../src/worm.vala"
				if (!slice_is_empty (_tmp40_)) {
#line 10352 "worm.c"
					gint64 distance = 0LL;
					Slice* _tmp41_;
					Position _tmp42_;
					Bonus* _tmp43_;
					gboolean _tmp44_ = FALSE;
#line 1848 "../src/worm.vala"
					_tmp41_ = slice;
#line 1848 "../src/worm.vala"
					_tmp42_ = *origin;
#line 1848 "../src/worm.vala"
					_tmp43_ = b;
#line 1848 "../src/worm.vala"
					distance = slice_is_visible (_tmp41_, &_tmp42_, board, (gint) board_length1, (gint) board_length2, worm_map, _tmp43_);
#line 1851 "../src/worm.vala"
					if (distance < bonus_distance) {
#line 10368 "worm.c"
						Position _tmp45_;
						Position _tmp46_ = {0};
						Bonus* _tmp47_;
#line 1852 "../src/worm.vala"
						_tmp45_ = *origin;
#line 1852 "../src/worm.vala"
						worm_get_position_after_direction_move (self, &_tmp45_, direction, &_tmp46_);
#line 1852 "../src/worm.vala"
						_tmp47_ = b;
#line 1852 "../src/worm.vala"
						_tmp44_ = worm_ai_can_see_bonus (self, board, (gint) board_length1, (gint) board_length2, &_tmp46_, _tmp47_, direction);
#line 10380 "worm.c"
					} else {
#line 1851 "../src/worm.vala"
						_tmp44_ = FALSE;
#line 10384 "worm.c"
					}
#line 1851 "../src/worm.vala"
					if (_tmp44_) {
#line 10388 "worm.c"
						Bonus* _tmp48_;
						BonuseType _tmp49_;
						BonuseType _tmp50_;
#line 1854 "../src/worm.vala"
						bonus_distance = distance;
#line 1855 "../src/worm.vala"
						_tmp48_ = b;
#line 1855 "../src/worm.vala"
						_tmp49_ = bonus_get_etype (_tmp48_);
#line 1855 "../src/worm.vala"
						_tmp50_ = _tmp49_;
#line 1855 "../src/worm.vala"
						_vala_bonus_type = _tmp50_;
#line 10402 "worm.c"
					}
				}
			}
#line 1834 "../src/worm.vala"
			_g_object_unref0 (b);
#line 10408 "worm.c"
		}
#line 1834 "../src/worm.vala"
		_g_object_unref0 (_b_list);
#line 10412 "worm.c"
	}
#line 1861 "../src/worm.vala"
	result = bonus_distance;
#line 1861 "../src/worm.vala"
	_g_object_unref0 (slice);
#line 1861 "../src/worm.vala"
	if (bonus_type) {
#line 1861 "../src/worm.vala"
		*bonus_type = _vala_bonus_type;
#line 10422 "worm.c"
	}
#line 1861 "../src/worm.vala"
	return result;
#line 10426 "worm.c"
}

void
worm_ai_move (Worm* self,
              gint* board,
              gint board_length1,
              gint board_length2,
              GeeLinkedList* worms)
{
	WormMap* worm_map = NULL;
	guint8 _tmp0_;
	guint8 _tmp1_;
	WormMap* _tmp2_;
	BonuseType bonus_type = 0;
	gint64 shortest_distance = 0LL;
	WormDirection shortest_dir = 0;
	WormDirection _tmp3_;
	BonuseType shortest_bonus_type = 0;
	WormDirection dir[3] = {0};
	WormDirection _tmp4_;
	WormDirection _tmp5_;
	WormDirection _tmp6_;
	WormDirection _tmp7_[3] = {0};
	WormDirection bonus_dir = 0;
	WormDirection best_dir = 0;
	gint64 best_yet = 0LL;
	WormDirection _tmp38_;
	gint _tmp39_ = 0;
	WormDirection* _tmp40_;
#line 1865 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1865 "../src/worm.vala"
	g_return_if_fail (worms != NULL);
#line 1867 "../src/worm.vala"
	_tmp0_ = self->priv->_width;
#line 1867 "../src/worm.vala"
	_tmp1_ = self->priv->_height;
#line 1867 "../src/worm.vala"
	_tmp2_ = worm_map_new ((GeeList*) worms, _tmp0_, _tmp1_);
#line 1867 "../src/worm.vala"
	worm_map = _tmp2_;
#line 1871 "../src/worm.vala"
	shortest_distance = G_MAXINT64;
#line 1872 "../src/worm.vala"
	_tmp3_ = self->priv->_direction;
#line 1872 "../src/worm.vala"
	shortest_dir = _tmp3_;
#line 1873 "../src/worm.vala"
	shortest_bonus_type = (BonuseType) -1;
#line 1875 "../src/worm.vala"
	_tmp4_ = self->priv->_direction;
#line 1875 "../src/worm.vala"
	_tmp5_ = self->priv->_direction;
#line 1875 "../src/worm.vala"
	_tmp6_ = self->priv->_direction;
#line 1875 "../src/worm.vala"
	_tmp7_[0] = _tmp4_;
#line 1875 "../src/worm.vala"
	_tmp7_[1] = worm_direction_turn_left (_tmp5_);
#line 1875 "../src/worm.vala"
	_tmp7_[2] = worm_direction_turn_right (_tmp6_);
#line 1875 "../src/worm.vala"
	memcpy (dir, _tmp7_, 3 * sizeof (WormDirection));
#line 10490 "worm.c"
	{
		WormDirection* direction_collection = NULL;
		gint direction_collection_length1 = 0;
		gint _direction_collection_size_ = 0;
		gint direction_it = 0;
#line 1876 "../src/worm.vala"
		direction_collection = dir;
#line 1876 "../src/worm.vala"
		direction_collection_length1 = 3;
#line 1876 "../src/worm.vala"
		for (direction_it = 0; direction_it < direction_collection_length1; direction_it = direction_it + 1) {
#line 10502 "worm.c"
			WormDirection direction = 0;
#line 1876 "../src/worm.vala"
			direction = direction_collection[direction_it];
#line 10506 "worm.c"
			{
				gint64 d = 0LL;
				WormMap* _tmp8_;
				Position _tmp9_ = {0};
				Position _tmp10_;
				BonuseType _tmp11_ = 0;
				gint64 _tmp12_;
				gboolean _tmp13_ = FALSE;
#line 1878 "../src/worm.vala"
				_tmp8_ = worm_map;
#line 1878 "../src/worm.vala"
				worm_get_head (self, &_tmp9_);
#line 1878 "../src/worm.vala"
				_tmp10_ = _tmp9_;
#line 1878 "../src/worm.vala"
				_tmp12_ = worm_ai_count_distance_to_a_bonus_in_direction (self, board, (gint) board_length1, (gint) board_length2, _tmp8_, &_tmp10_, direction, &_tmp11_);
#line 1878 "../src/worm.vala"
				bonus_type = _tmp11_;
#line 1878 "../src/worm.vala"
				d = _tmp12_;
#line 1879 "../src/worm.vala"
				if (worm_ai_is_bonus_more_attractive (self, bonus_type, d, shortest_bonus_type, shortest_distance)) {
#line 1880 "../src/worm.vala"
					_tmp13_ = worm_can_move_direction (self, board, (gint) board_length1, (gint) board_length2, worms, direction);
#line 10531 "worm.c"
				} else {
#line 1879 "../src/worm.vala"
					_tmp13_ = FALSE;
#line 10535 "worm.c"
				}
#line 1879 "../src/worm.vala"
				if (_tmp13_) {
#line 1882 "../src/worm.vala"
					shortest_distance = d;
#line 1883 "../src/worm.vala"
					shortest_dir = direction;
#line 1884 "../src/worm.vala"
					shortest_bonus_type = bonus_type;
#line 10545 "worm.c"
				}
			}
		}
	}
#line 1888 "../src/worm.vala"
	if (shortest_distance >= G_MAXINT64) {
#line 10552 "worm.c"
		WormDirection start_direction[4] = {0};
		WormDirection _tmp14_;
		WormDirection _tmp15_;
		WormDirection _tmp16_;
		WormDirection _tmp17_;
		WormDirection _tmp18_[4] = {0};
		WormDirection look_direction[4] = {0};
		WormDirection _tmp19_;
		WormDirection _tmp20_;
		WormDirection _tmp21_;
		WormDirection _tmp22_;
		WormDirection _tmp23_[4] = {0};
		gint64 d = 0LL;
#line 1891 "../src/worm.vala"
		_tmp14_ = self->priv->_direction;
#line 1891 "../src/worm.vala"
		_tmp15_ = self->priv->_direction;
#line 1891 "../src/worm.vala"
		_tmp16_ = self->priv->_direction;
#line 1891 "../src/worm.vala"
		_tmp17_ = self->priv->_direction;
#line 1891 "../src/worm.vala"
		_tmp18_[0] = _tmp14_;
#line 1891 "../src/worm.vala"
		_tmp18_[1] = _tmp15_;
#line 1891 "../src/worm.vala"
		_tmp18_[2] = worm_direction_turn_right (_tmp16_);
#line 1891 "../src/worm.vala"
		_tmp18_[3] = worm_direction_turn_left (_tmp17_);
#line 1891 "../src/worm.vala"
		memcpy (start_direction, _tmp18_, 4 * sizeof (WormDirection));
#line 1892 "../src/worm.vala"
		_tmp19_ = self->priv->_direction;
#line 1892 "../src/worm.vala"
		_tmp20_ = self->priv->_direction;
#line 1892 "../src/worm.vala"
		_tmp21_ = self->priv->_direction;
#line 1892 "../src/worm.vala"
		_tmp22_ = self->priv->_direction;
#line 1892 "../src/worm.vala"
		_tmp23_[0] = worm_direction_turn_left (_tmp19_);
#line 1892 "../src/worm.vala"
		_tmp23_[1] = worm_direction_turn_right (_tmp20_);
#line 1892 "../src/worm.vala"
		_tmp23_[2] = _tmp21_;
#line 1892 "../src/worm.vala"
		_tmp23_[3] = _tmp22_;
#line 1892 "../src/worm.vala"
		memcpy (look_direction, _tmp23_, 4 * sizeof (WormDirection));
#line 10602 "worm.c"
		{
			gint i = 0;
#line 1894 "../src/worm.vala"
			i = 0;
#line 10607 "worm.c"
			{
				gboolean _tmp24_ = FALSE;
#line 1894 "../src/worm.vala"
				_tmp24_ = TRUE;
#line 1894 "../src/worm.vala"
				while (TRUE) {
#line 10614 "worm.c"
					WormMap* _tmp26_;
					Position _tmp27_ = {0};
					Position _tmp28_;
					WormDirection _tmp29_;
					Position _tmp30_ = {0};
					WormDirection _tmp31_;
					BonuseType _tmp32_ = 0;
					gint64 _tmp33_;
#line 1894 "../src/worm.vala"
					if (!_tmp24_) {
#line 10625 "worm.c"
						gint _tmp25_;
#line 1894 "../src/worm.vala"
						_tmp25_ = i;
#line 1894 "../src/worm.vala"
						i = _tmp25_ + 1;
#line 10631 "worm.c"
					}
#line 1894 "../src/worm.vala"
					_tmp24_ = FALSE;
#line 1894 "../src/worm.vala"
					if (!(i < 4)) {
#line 1894 "../src/worm.vala"
						break;
#line 10639 "worm.c"
					}
#line 1896 "../src/worm.vala"
					_tmp26_ = worm_map;
#line 1896 "../src/worm.vala"
					worm_get_head (self, &_tmp27_);
#line 1896 "../src/worm.vala"
					_tmp28_ = _tmp27_;
#line 1896 "../src/worm.vala"
					_tmp29_ = start_direction[i];
#line 1896 "../src/worm.vala"
					worm_get_position_after_direction_move (self, &_tmp28_, _tmp29_, &_tmp30_);
#line 1896 "../src/worm.vala"
					_tmp31_ = look_direction[i];
#line 1896 "../src/worm.vala"
					_tmp33_ = worm_ai_count_distance_to_a_bonus_in_direction (self, board, (gint) board_length1, (gint) board_length2, _tmp26_, &_tmp30_, _tmp31_, &_tmp32_);
#line 1896 "../src/worm.vala"
					bonus_type = _tmp32_;
#line 1896 "../src/worm.vala"
					d = _tmp33_;
#line 1898 "../src/worm.vala"
					if (worm_ai_is_bonus_more_attractive (self, bonus_type, d, shortest_bonus_type, shortest_distance)) {
#line 10661 "worm.c"
						WormDirection _tmp34_;
#line 1900 "../src/worm.vala"
						shortest_distance = d + 1;
#line 1901 "../src/worm.vala"
						_tmp34_ = start_direction[i];
#line 1901 "../src/worm.vala"
						shortest_dir = _tmp34_;
#line 1902 "../src/worm.vala"
						shortest_bonus_type = bonus_type;
#line 10671 "worm.c"
					}
				}
			}
		}
	}
#line 1907 "../src/worm.vala"
	bonus_type = shortest_bonus_type;
#line 1908 "../src/worm.vala"
	if (shortest_distance >= G_MAXINT64) {
#line 1911 "../src/worm.vala"
		if (g_random_int_range ((gint32) 0, (gint32) 30) == ((gint32) 1)) {
#line 10683 "worm.c"
			WormDirection _tmp35_ = 0;
#line 1912 "../src/worm.vala"
			if (g_random_boolean ()) {
#line 10687 "worm.c"
				WormDirection _tmp36_;
#line 1912 "../src/worm.vala"
				_tmp36_ = self->priv->_direction;
#line 1912 "../src/worm.vala"
				_tmp35_ = worm_direction_turn_right (_tmp36_);
#line 10693 "worm.c"
			} else {
				WormDirection _tmp37_;
#line 1912 "../src/worm.vala"
				_tmp37_ = self->priv->_direction;
#line 1912 "../src/worm.vala"
				_tmp35_ = worm_direction_turn_left (_tmp37_);
#line 10700 "worm.c"
			}
#line 1912 "../src/worm.vala"
			shortest_dir = _tmp35_;
#line 10704 "worm.c"
		}
	}
#line 1926 "../src/worm.vala"
	bonus_dir = shortest_dir;
#line 1927 "../src/worm.vala"
	best_dir = WORM_DIRECTION_NONE;
#line 1928 "../src/worm.vala"
	best_yet = G_MAXINT64;
#line 1929 "../src/worm.vala"
	_tmp38_ = dir[0];
#line 1929 "../src/worm.vala"
	_tmp40_ = worm_direction_get_space_fill_array (_tmp38_, &_tmp39_);
#line 10717 "worm.c"
	{
		WormDirection* direction_collection = NULL;
		gint direction_collection_length1 = 0;
		gint _direction_collection_size_ = 0;
		gint direction_it = 0;
#line 1929 "../src/worm.vala"
		direction_collection = _tmp40_;
#line 1929 "../src/worm.vala"
		direction_collection_length1 = _tmp39_;
#line 1929 "../src/worm.vala"
		for (direction_it = 0; direction_it < direction_collection_length1; direction_it = direction_it + 1) {
#line 10729 "worm.c"
			WormDirection direction = 0;
#line 1929 "../src/worm.vala"
			direction = direction_collection[direction_it];
#line 10733 "worm.c"
			{
				gint this_len = 0;
				gboolean _tmp41_ = FALSE;
				gboolean _tmp53_ = FALSE;
#line 1931 "../src/worm.vala"
				this_len = 0;
#line 1933 "../src/worm.vala"
				if (direction == bonus_dir) {
#line 1933 "../src/worm.vala"
					_tmp41_ = bonus_type == BONUS_ETYPE_LIFE;
#line 10744 "worm.c"
				} else {
#line 1933 "../src/worm.vala"
					_tmp41_ = FALSE;
#line 10748 "worm.c"
				}
#line 1933 "../src/worm.vala"
				if (!_tmp41_) {
#line 10752 "worm.c"
					WormMap* _tmp42_;
					Position _tmp43_ = {0};
					Position _tmp44_;
					Position _tmp45_ = {0};
					WormMap* _tmp47_;
					Position _tmp48_ = {0};
					Position _tmp49_;
					gint _tmp50_;
					gint _tmp51_;
					gint _tmp52_;
#line 1939 "../src/worm.vala"
					_tmp42_ = worm_map;
#line 1939 "../src/worm.vala"
					worm_get_head (self, &_tmp43_);
#line 1939 "../src/worm.vala"
					_tmp44_ = _tmp43_;
#line 1939 "../src/worm.vala"
					worm_get_position_after_direction_move (self, &_tmp44_, direction, &_tmp45_);
#line 1939 "../src/worm.vala"
					if (!worm_can_move_to_map (self, board, (gint) board_length1, (gint) board_length2, _tmp42_, &_tmp45_)) {
#line 10773 "worm.c"
						gint _tmp46_;
#line 1940 "../src/worm.vala"
						_tmp46_ = self->priv->_capacity;
#line 1940 "../src/worm.vala"
						this_len += _tmp46_;
#line 10779 "worm.c"
					}
#line 1942 "../src/worm.vala"
					if (worm_ai_too_close (self, worms, direction)) {
#line 1943 "../src/worm.vala"
						this_len += 4;
#line 10785 "worm.c"
					}
#line 1945 "../src/worm.vala"
					_tmp47_ = worm_map;
#line 1945 "../src/worm.vala"
					worm_get_head (self, &_tmp48_);
#line 1945 "../src/worm.vala"
					_tmp49_ = _tmp48_;
#line 1945 "../src/worm.vala"
					_tmp50_ = worm_get_length (self);
#line 1945 "../src/worm.vala"
					_tmp51_ = _tmp50_;
#line 1945 "../src/worm.vala"
					_tmp52_ = self->priv->_change;
#line 1945 "../src/worm.vala"
					this_len += worm_ai_deadend_after (board, (gint) board_length1, (gint) board_length2, worms, _tmp47_, &_tmp49_, direction, _tmp51_ + _tmp52_);
#line 10801 "worm.c"
				}
#line 1947 "../src/worm.vala"
				if (direction == bonus_dir) {
#line 1947 "../src/worm.vala"
					_tmp53_ = this_len <= 0;
#line 10807 "worm.c"
				} else {
#line 1947 "../src/worm.vala"
					_tmp53_ = FALSE;
#line 10811 "worm.c"
				}
#line 1947 "../src/worm.vala"
				if (_tmp53_) {
#line 1948 "../src/worm.vala"
					this_len -= 100;
#line 10817 "worm.c"
				}
#line 1955 "../src/worm.vala"
				if (this_len <= 0) {
#line 1956 "../src/worm.vala"
					this_len -= (gint) g_random_int_range ((gint32) 0, (gint32) 100);
#line 10823 "worm.c"
				}
#line 1957 "../src/worm.vala"
				if (((gint64) this_len) < best_yet) {
#line 1959 "../src/worm.vala"
					best_yet = (gint64) this_len;
#line 1960 "../src/worm.vala"
					best_dir = direction;
#line 10831 "worm.c"
				}
			}
		}
#line 1929 "../src/worm.vala"
		direction_collection = (g_free (direction_collection), NULL);
#line 10837 "worm.c"
	}
#line 1965 "../src/worm.vala"
	worm_set_direction (self, best_dir);
#line 1865 "../src/worm.vala"
	_g_object_unref0 (worm_map);
#line 10843 "worm.c"
}

void
worm_get_starting_position (Worm* self,
                            Position * result)
{
	Position _tmp0_;
#line 1124 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1124 "../src/worm.vala"
	_tmp0_ = self->priv->_starting_position;
#line 1124 "../src/worm.vala"
	*result = _tmp0_;
#line 1124 "../src/worm.vala"
	return;
#line 10859 "worm.c"
}

static gboolean
_position_equal (const Position * s1,
                 const Position * s2)
{
#line 1124 "../src/worm.vala"
	if (s1 == s2) {
#line 1124 "../src/worm.vala"
		return TRUE;
#line 10870 "worm.c"
	}
#line 1124 "../src/worm.vala"
	if (s1 == NULL) {
#line 1124 "../src/worm.vala"
		return FALSE;
#line 10876 "worm.c"
	}
#line 1124 "../src/worm.vala"
	if (s2 == NULL) {
#line 1124 "../src/worm.vala"
		return FALSE;
#line 10882 "worm.c"
	}
#line 1124 "../src/worm.vala"
	if (s1->x != s2->x) {
#line 1124 "../src/worm.vala"
		return FALSE;
#line 10888 "worm.c"
	}
#line 1124 "../src/worm.vala"
	if (s1->y != s2->y) {
#line 1124 "../src/worm.vala"
		return FALSE;
#line 10894 "worm.c"
	}
#line 1124 "../src/worm.vala"
	return TRUE;
#line 10898 "worm.c"
}

static void
worm_set_starting_position (Worm* self,
                            Position * value)
{
	Position old_value;
#line 1124 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1124 "../src/worm.vala"
	worm_get_starting_position (self, &old_value);
#line 1124 "../src/worm.vala"
	if (_position_equal (value, &old_value) != TRUE) {
#line 10912 "worm.c"
		Position _tmp0_;
#line 1124 "../src/worm.vala"
		_tmp0_ = *value;
#line 1124 "../src/worm.vala"
		self->priv->_starting_position = _tmp0_;
#line 1124 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_STARTING_POSITION_PROPERTY]);
#line 10920 "worm.c"
	}
}

gint
worm_get_id (Worm* self)
{
	gint result;
#line 1126 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1126 "../src/worm.vala"
	result = self->priv->_id;
#line 1126 "../src/worm.vala"
	return result;
#line 10934 "worm.c"
}

static void
worm_set_id (Worm* self,
             gint value)
{
	gint old_value;
#line 1126 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1126 "../src/worm.vala"
	old_value = worm_get_id (self);
#line 1126 "../src/worm.vala"
	if (old_value != value) {
#line 1126 "../src/worm.vala"
		self->priv->_id = value;
#line 1126 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_ID_PROPERTY]);
#line 10952 "worm.c"
	}
}

gboolean
worm_get_is_materialized (Worm* self)
{
	gboolean result;
#line 1133 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1133 "../src/worm.vala"
	result = self->priv->rounds_to_stay_dematerialized <= 0;
#line 1133 "../src/worm.vala"
	return result;
#line 10966 "worm.c"
}

guint8
worm_get_lives (Worm* self)
{
	guint8 result;
#line 1135 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1135 "../src/worm.vala"
	result = self->priv->_lives;
#line 1135 "../src/worm.vala"
	return result;
#line 10979 "worm.c"
}

void
worm_set_lives (Worm* self,
                guint8 value)
{
	guint8 old_value;
#line 1135 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1135 "../src/worm.vala"
	old_value = worm_get_lives (self);
#line 1135 "../src/worm.vala"
	if (old_value != value) {
#line 1135 "../src/worm.vala"
		self->priv->_lives = value;
#line 1135 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_LIVES_PROPERTY]);
#line 10997 "worm.c"
	}
}

gint
worm_get_change (Worm* self)
{
	gint result;
#line 1136 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1136 "../src/worm.vala"
	result = self->priv->_change;
#line 1136 "../src/worm.vala"
	return result;
#line 11011 "worm.c"
}

void
worm_set_change (Worm* self,
                 gint value)
{
	gint old_value;
#line 1136 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1136 "../src/worm.vala"
	old_value = worm_get_change (self);
#line 1136 "../src/worm.vala"
	if (old_value != value) {
#line 1136 "../src/worm.vala"
		self->priv->_change = value;
#line 1136 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_CHANGE_PROPERTY]);
#line 11029 "worm.c"
	}
}

gint
worm_get_score (Worm* self)
{
	gint result;
#line 1137 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1137 "../src/worm.vala"
	result = self->priv->_score;
#line 1137 "../src/worm.vala"
	return result;
#line 11043 "worm.c"
}

void
worm_set_score (Worm* self,
                gint value)
{
	gint old_value;
#line 1137 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1137 "../src/worm.vala"
	old_value = worm_get_score (self);
#line 1137 "../src/worm.vala"
	if (old_value != value) {
#line 1137 "../src/worm.vala"
		self->priv->_score = value;
#line 1137 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_SCORE_PROPERTY]);
#line 11061 "worm.c"
	}
}

gint
worm_get_length (Worm* self)
{
	gint result;
	WormPositions* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 1141 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1141 "../src/worm.vala"
	_tmp0_ = self->list;
#line 1141 "../src/worm.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 1141 "../src/worm.vala"
	_tmp2_ = _tmp1_;
#line 1141 "../src/worm.vala"
	result = _tmp2_;
#line 1141 "../src/worm.vala"
	return result;
#line 11084 "worm.c"
}

void
worm_get_head (Worm* self,
               Position * result)
{
	Position head = {0};
	WormPositions* _tmp0_;
	Position _tmp1_ = {0};
	Position _tmp2_;
#line 1146 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1148 "../src/worm.vala"
	_tmp0_ = self->list;
#line 1148 "../src/worm.vala"
	worm_positions_get_head (_tmp0_, &_tmp1_);
#line 1148 "../src/worm.vala"
	head = _tmp1_;
#line 1149 "../src/worm.vala"
	_tmp2_ = head;
#line 1149 "../src/worm.vala"
	*result = _tmp2_;
#line 1149 "../src/worm.vala"
	return;
#line 11109 "worm.c"
}

static void
worm_set_head (Worm* self,
               Position * value)
{
	WormPositions* _tmp0_;
	Position _tmp1_;
#line 1151 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1153 "../src/worm.vala"
	_tmp0_ = self->list;
#line 1153 "../src/worm.vala"
	_tmp1_ = *value;
#line 1153 "../src/worm.vala"
	worm_positions_set_head (_tmp0_, &_tmp1_);
#line 1151 "../src/worm.vala"
	g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_HEAD_PROPERTY]);
#line 11128 "worm.c"
}

WormDirection
worm_get_direction (Worm* self)
{
	WormDirection result;
#line 1157 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1157 "../src/worm.vala"
	result = self->priv->_direction;
#line 1157 "../src/worm.vala"
	return result;
#line 11141 "worm.c"
}

static void
worm_set_direction (Worm* self,
                    WormDirection value)
{
	WormDirection old_value;
#line 1157 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1157 "../src/worm.vala"
	old_value = worm_get_direction (self);
#line 1157 "../src/worm.vala"
	if (old_value != value) {
#line 1157 "../src/worm.vala"
		self->priv->_direction = value;
#line 1157 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_DIRECTION_PROPERTY]);
#line 11159 "worm.c"
	}
}

static guint8
worm_get_width (Worm* self)
{
	guint8 result;
#line 1177 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1177 "../src/worm.vala"
	result = self->priv->_width;
#line 1177 "../src/worm.vala"
	return result;
#line 11173 "worm.c"
}

static void
worm_set_width (Worm* self,
                guint8 value)
{
	guint8 old_value;
#line 1177 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1177 "../src/worm.vala"
	old_value = worm_get_width (self);
#line 1177 "../src/worm.vala"
	if (old_value != value) {
#line 1177 "../src/worm.vala"
		self->priv->_width = value;
#line 1177 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_WIDTH_PROPERTY]);
#line 11191 "worm.c"
	}
}

static guint8
worm_get_height (Worm* self)
{
	guint8 result;
#line 1178 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1178 "../src/worm.vala"
	result = self->priv->_height;
#line 1178 "../src/worm.vala"
	return result;
#line 11205 "worm.c"
}

static void
worm_set_height (Worm* self,
                 guint8 value)
{
	guint8 old_value;
#line 1178 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1178 "../src/worm.vala"
	old_value = worm_get_height (self);
#line 1178 "../src/worm.vala"
	if (old_value != value) {
#line 1178 "../src/worm.vala"
		self->priv->_height = value;
#line 1178 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_HEIGHT_PROPERTY]);
#line 11223 "worm.c"
	}
}

static gint
worm_get_capacity (Worm* self)
{
	gint result;
#line 1179 "../src/worm.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1179 "../src/worm.vala"
	result = self->priv->_capacity;
#line 1179 "../src/worm.vala"
	return result;
#line 11237 "worm.c"
}

static void
worm_set_capacity (Worm* self,
                   gint value)
{
	gint old_value;
#line 1179 "../src/worm.vala"
	g_return_if_fail (self != NULL);
#line 1179 "../src/worm.vala"
	old_value = worm_get_capacity (self);
#line 1179 "../src/worm.vala"
	if (old_value != value) {
#line 1179 "../src/worm.vala"
		self->priv->_capacity = value;
#line 1179 "../src/worm.vala"
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_CAPACITY_PROPERTY]);
#line 11255 "worm.c"
	}
}

static GObject *
worm_constructor (GType type,
                  guint n_construct_properties,
                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Worm * self;
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint* _tmp2_;
#line 1181 "../src/worm.vala"
	parent_class = G_OBJECT_CLASS (worm_parent_class);
#line 1181 "../src/worm.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 1181 "../src/worm.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WORM, Worm);
#line 1183 "../src/worm.vala"
	_tmp0_ = self->priv->_width;
#line 1183 "../src/worm.vala"
	_tmp1_ = self->priv->_height;
#line 1183 "../src/worm.vala"
	_tmp2_ = g_new0 (guint, _tmp0_ * _tmp1_);
#line 1183 "../src/worm.vala"
	worm_deadend_board = (g_free (worm_deadend_board), NULL);
#line 1183 "../src/worm.vala"
	worm_deadend_board = _tmp2_;
#line 1183 "../src/worm.vala"
	worm_deadend_board_length1 = _tmp0_;
#line 1183 "../src/worm.vala"
	worm_deadend_board_length2 = _tmp1_;
#line 1181 "../src/worm.vala"
	return obj;
#line 11292 "worm.c"
}

static void
worm_class_init (WormClass * klass,
                 gpointer klass_data)
{
#line 1116 "../src/worm.vala"
	worm_parent_class = g_type_class_peek_parent (klass);
#line 1116 "../src/worm.vala"
	g_type_class_adjust_private_offset (klass, &Worm_private_offset);
#line 1116 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_worm_get_property;
#line 1116 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_worm_set_property;
#line 1116 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->constructor = worm_constructor;
#line 1116 "../src/worm.vala"
	G_OBJECT_CLASS (klass)->finalize = worm_finalize;
#line 1116 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_STARTING_POSITION_PROPERTY, worm_properties[WORM_STARTING_POSITION_PROPERTY] = g_param_spec_boxed ("starting-position", "starting-position", "starting-position", TYPE_POSITION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1116 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_ID_PROPERTY, worm_properties[WORM_ID_PROPERTY] = g_param_spec_int ("id", "id", "id", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1116 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_IS_MATERIALIZED_PROPERTY, worm_properties[WORM_IS_MATERIALIZED_PROPERTY] = g_param_spec_boolean ("is-materialized", "is-materialized", "is-materialized", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1116 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_LIVES_PROPERTY, worm_properties[WORM_LIVES_PROPERTY] = g_param_spec_uchar ("lives", "lives", "lives", 0, G_MAXUINT8, WORM_STARTING_LIVES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1116 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_CHANGE_PROPERTY, worm_properties[WORM_CHANGE_PROPERTY] = g_param_spec_int ("change", "change", "change", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1116 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_SCORE_PROPERTY, worm_properties[WORM_SCORE_PROPERTY] = g_param_spec_int ("score", "score", "score", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1116 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_LENGTH_PROPERTY, worm_properties[WORM_LENGTH_PROPERTY] = g_param_spec_int ("length", "length", "length", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1116 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_HEAD_PROPERTY, worm_properties[WORM_HEAD_PROPERTY] = g_param_spec_boxed ("head", "head", "head", TYPE_POSITION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1116 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_DIRECTION_PROPERTY, worm_properties[WORM_DIRECTION_PROPERTY] = g_param_spec_enum ("direction", "direction", "direction", TYPE_WORM_DIRECTION, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1116 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_WIDTH_PROPERTY, worm_properties[WORM_WIDTH_PROPERTY] = g_param_spec_uchar ("width", "width", "width", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1116 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_HEIGHT_PROPERTY, worm_properties[WORM_HEIGHT_PROPERTY] = g_param_spec_uchar ("height", "height", "height", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1116 "../src/worm.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_CAPACITY_PROPERTY, worm_properties[WORM_CAPACITY_PROPERTY] = g_param_spec_int ("capacity", "capacity", "capacity", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1116 "../src/worm.vala"
	worm_signals[WORM_BONUS_FOUND_SIGNAL] = g_signal_new ("bonus-found", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 11337 "worm.c"
}

static void
worm_instance_init (Worm * self,
                    gpointer klass)
{
	GeeArrayQueue* _tmp0_;
	WormPositions* _tmp1_;
	GeeArrayList* _tmp2_;
#line 1116 "../src/worm.vala"
	self->priv = worm_get_instance_private (self);
#line 1129 "../src/worm.vala"
	self->keypress = FALSE;
#line 1131 "../src/worm.vala"
	self->is_stopped = FALSE;
#line 1135 "../src/worm.vala"
	self->priv->_lives = WORM_STARTING_LIVES;
#line 1136 "../src/worm.vala"
	self->priv->_change = 0;
#line 1137 "../src/worm.vala"
	self->priv->_score = 0;
#line 1163 "../src/worm.vala"
	_tmp0_ = gee_array_queue_new (TYPE_WORM_DIRECTION, NULL, NULL, NULL, NULL, NULL);
#line 1163 "../src/worm.vala"
	self->priv->key_queue = _tmp0_;
#line 1165 "../src/worm.vala"
	_tmp1_ = worm_positions_new ();
#line 1165 "../src/worm.vala"
	self->list = _tmp1_;
#line 1166 "../src/worm.vala"
	_tmp2_ = gee_array_list_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL);
#line 1166 "../src/worm.vala"
	self->priv->bonus_eaten = _tmp2_;
#line 1486 "../src/worm.vala"
	self->priv->LastUturnA = FALSE;
#line 11373 "worm.c"
}

static void
worm_finalize (GObject * obj)
{
	Worm * self;
#line 1116 "../src/worm.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WORM, Worm);
#line 1163 "../src/worm.vala"
	_g_object_unref0 (self->priv->key_queue);
#line 1165 "../src/worm.vala"
	_g_object_unref0 (self->list);
#line 1166 "../src/worm.vala"
	_g_object_unref0 (self->priv->bonus_eaten);
#line 1173 "../src/worm.vala"
	(self->priv->get_other_worms_target_destroy_notify == NULL) ? NULL : (self->priv->get_other_worms_target_destroy_notify (self->priv->get_other_worms_target), NULL);
#line 1173 "../src/worm.vala"
	self->priv->get_other_worms = NULL;
#line 1173 "../src/worm.vala"
	self->priv->get_other_worms_target = NULL;
#line 1173 "../src/worm.vala"
	self->priv->get_other_worms_target_destroy_notify = NULL;
#line 1175 "../src/worm.vala"
	(self->priv->get_bonuses_target_destroy_notify == NULL) ? NULL : (self->priv->get_bonuses_target_destroy_notify (self->priv->get_bonuses_target), NULL);
#line 1175 "../src/worm.vala"
	self->priv->get_bonuses = NULL;
#line 1175 "../src/worm.vala"
	self->priv->get_bonuses_target = NULL;
#line 1175 "../src/worm.vala"
	self->priv->get_bonuses_target_destroy_notify = NULL;
#line 1116 "../src/worm.vala"
	G_OBJECT_CLASS (worm_parent_class)->finalize (obj);
#line 11406 "worm.c"
}

 G_GNUC_NO_INLINE static GType
worm_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WormClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) worm_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Worm), 0, (GInstanceInitFunc) worm_instance_init, NULL };
	GType worm_type_id;
	worm_type_id = g_type_register_static (G_TYPE_OBJECT, "Worm", &g_define_type_info, 0);
	Worm_private_offset = g_type_add_instance_private (worm_type_id, sizeof (WormPrivate));
	return worm_type_id;
}

GType
worm_get_type (void)
{
	static gsize worm_type_id__once = 0;
	if (g_once_init_enter (&worm_type_id__once)) {
		GType worm_type_id;
		worm_type_id = worm_get_type_once ();
		g_once_init_leave (&worm_type_id__once, worm_type_id);
	}
	return worm_type_id__once;
}

static void
_vala_worm_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Worm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM, Worm);
#line 1116 "../src/worm.vala"
	switch (property_id) {
#line 1116 "../src/worm.vala"
		case WORM_STARTING_POSITION_PROPERTY:
#line 11443 "worm.c"
		{
			Position boxed;
#line 1116 "../src/worm.vala"
			worm_get_starting_position (self, &boxed);
#line 1116 "../src/worm.vala"
			g_value_set_boxed (value, &boxed);
#line 11450 "worm.c"
		}
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_ID_PROPERTY:
#line 1116 "../src/worm.vala"
		g_value_set_int (value, worm_get_id (self));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_IS_MATERIALIZED_PROPERTY:
#line 1116 "../src/worm.vala"
		g_value_set_boolean (value, worm_get_is_materialized (self));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_LIVES_PROPERTY:
#line 1116 "../src/worm.vala"
		g_value_set_uchar (value, worm_get_lives (self));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_CHANGE_PROPERTY:
#line 1116 "../src/worm.vala"
		g_value_set_int (value, worm_get_change (self));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_SCORE_PROPERTY:
#line 1116 "../src/worm.vala"
		g_value_set_int (value, worm_get_score (self));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_LENGTH_PROPERTY:
#line 1116 "../src/worm.vala"
		g_value_set_int (value, worm_get_length (self));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_HEAD_PROPERTY:
#line 11492 "worm.c"
		{
			Position boxed;
#line 1116 "../src/worm.vala"
			worm_get_head (self, &boxed);
#line 1116 "../src/worm.vala"
			g_value_set_boxed (value, &boxed);
#line 11499 "worm.c"
		}
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_DIRECTION_PROPERTY:
#line 1116 "../src/worm.vala"
		g_value_set_enum (value, worm_get_direction (self));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_WIDTH_PROPERTY:
#line 1116 "../src/worm.vala"
		g_value_set_uchar (value, worm_get_width (self));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_HEIGHT_PROPERTY:
#line 1116 "../src/worm.vala"
		g_value_set_uchar (value, worm_get_height (self));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_CAPACITY_PROPERTY:
#line 1116 "../src/worm.vala"
		g_value_set_int (value, worm_get_capacity (self));
#line 1116 "../src/worm.vala"
		break;
#line 11527 "worm.c"
		default:
#line 1116 "../src/worm.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1116 "../src/worm.vala"
		break;
#line 11533 "worm.c"
	}
}

static void
_vala_worm_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Worm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM, Worm);
#line 1116 "../src/worm.vala"
	switch (property_id) {
#line 1116 "../src/worm.vala"
		case WORM_STARTING_POSITION_PROPERTY:
#line 1116 "../src/worm.vala"
		worm_set_starting_position (self, g_value_get_boxed (value));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_ID_PROPERTY:
#line 1116 "../src/worm.vala"
		worm_set_id (self, g_value_get_int (value));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_LIVES_PROPERTY:
#line 1116 "../src/worm.vala"
		worm_set_lives (self, g_value_get_uchar (value));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_CHANGE_PROPERTY:
#line 1116 "../src/worm.vala"
		worm_set_change (self, g_value_get_int (value));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_SCORE_PROPERTY:
#line 1116 "../src/worm.vala"
		worm_set_score (self, g_value_get_int (value));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_HEAD_PROPERTY:
#line 1116 "../src/worm.vala"
		worm_set_head (self, g_value_get_boxed (value));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_DIRECTION_PROPERTY:
#line 1116 "../src/worm.vala"
		worm_set_direction (self, g_value_get_enum (value));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_WIDTH_PROPERTY:
#line 1116 "../src/worm.vala"
		worm_set_width (self, g_value_get_uchar (value));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_HEIGHT_PROPERTY:
#line 1116 "../src/worm.vala"
		worm_set_height (self, g_value_get_uchar (value));
#line 1116 "../src/worm.vala"
		break;
#line 1116 "../src/worm.vala"
		case WORM_CAPACITY_PROPERTY:
#line 1116 "../src/worm.vala"
		worm_set_capacity (self, g_value_get_int (value));
#line 1116 "../src/worm.vala"
		break;
#line 11607 "worm.c"
		default:
#line 1116 "../src/worm.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1116 "../src/worm.vala"
		break;
#line 11613 "worm.c"
	}
}

